Imports System.Math
Imports System.IO
Module Dynamique_2D
    '
    'Calcul des efforts appliqus  la structure et de ses dplacements sous l'effet d'un seisme
    '
    'Variables publiques  l'ensemble du module
    Dim title As String = "STRUCTURE : module de calcul Analyse Dynamique 2D"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly
    ' Dim msgg As String Dim Decale As Double
    Public Sub Cal_sismique_2D(ByRef structure_OK As Boolean, ByVal Kg(,) As Double, ByVal L() As Double, _
                                ByVal Rot(,) As Double, ByVal kg0(,) As Double)

        'DynMode = nbre de valeurs propres  calculer - DynMode = 1 valeur par dfaut
        'DynIter = nbre max d'itrations  envisager - DynIter = 30 valeur par dfaut
        'dyntol = prcision de convergence - DynTol = 0.001 valeur par dfaut
        '---------------------------------------------------------------------------
        '--> Debogage de l'application:
        'Dim myStreamwriter As StreamWriter
        'passage = passage + 1
        'Dim fich As String
        'fich = "detail_calcul_sismique_" + CStr(passage) + ".txt"
        'Dim fs As New FileStream(fich, FileMode.OpenOrCreate) ', FileAccess.Write)
        'Dim sw As New StreamWriter(fs)
        '--> Dclaration des variables:
        Dim DynMode, i, i3, ii, j, jj, j3, Neq, Maxx_mode, pas As Integer
        Dim Mg(3 * Total_noeud, 3 * Total_noeud), m_pas As Double


        '1 -- Etablissement de la matrice Masse de la structure
        If MasCon = False Then
            If Def_Tranchant = True Then
                Call Matrice_masse_Repartie_2D_avec_G(Mg, L)
            Else
                Call Matrice_masse_Repartie_2D(Mg, L, Rot)
            End If
        Else
            Call Matrice_masse_Concentre_2D(Mg, L) 'valeur par dfaut
        End If

        'Call C_Limit(Mg) 'Prise en compte des conditions d'appui et des relaxations

        '2 -- Calcul des valeurs et vecteurs propres K-M*Lambda avec suppression des lignes et colonnes correspondants  
        '     aux noeuds Appui

        ii = 3 * (Total_noeud - Total_appui)
        If ii = 0 Then ii = 3 'cas de la poutre sur 2 appuis avec une matrice cohrente
        Dim Vect_prop(ii, ii), valp(ii), T(ii) As Double
        ReDim Freq(ii, 2)
        Call Vpinv(structure_OK, 3 * Total_noeud, Kg, Mg, T)
        Dim Vm(), Vk() As Double
        ii = 0
        For i = 1 To 3 * Total_noeud 'colonne
            i3 = CInt(Int((i + 2) / 3))
            If Appui(i3) = False Then 'test si noeud n'est pas un appui
                For j = 1 To i 'ligne, la matrice K est symtrique, on ne rentre que le triangle suprieur, colonne par colonne
                    j3 = CInt(Int((j + 2) / 3))
                    If Appui(j3) = False Then 'test si noeud n'est pas un appui
                        ii = ii + 1 'la matrice M est symtrique, on ne rentre que le triangle suprieur, colonne par colonne
                        ReDim Preserve Vm(ii), Vk(ii)
                        Vk(ii) = Kg(j, i) : Vm(ii) = Mg(j, i)
                    End If
                Next
            End If
        Next
        Call Jacobi(Vk, Vm, ii, 15, 0.000000000001, valp, Vect_prop, structure_OK)
        If structure_OK = False Then
            '--> Debogage de l'application:
            ' sw.Write(msgg) : sw.Close()
            'Option: calcul du dterminant
            Dim Mat1(3 * Total_noeud, 3 * Total_noeud), det1 As Double
            Dim msg As String
            For i = 1 To 3 * Total_noeud
                For j = 1 To 3 * Total_noeud
                    Mat1(i, j) = Kg(i, j)
                Next
            Next
            Call Determinant(3 * Total_noeud, Mat1, det1)
            If det1 < 0 Then
                msg = "Le dterminant de la matrice de rigidit est ngatif." & vbCrLf & _
                    "Il est gal  : " & CStr(det1)
                MsgBox(msg, style, title)
            End If
            Erase Mat1, Vect_prop, valp, T, Freq
            Exit Sub
        Else
            'affectation des priodes propres de vibration suivant les valeurs propres obtenus
            For i = 1 To ii : T(i) = (2 * PI) / Sqrt(valp(i)) : Freq(i, 0) = 1 / T(i) : Next
        End If
        Neq = 3 * (Total_noeud - Total_appui)
        DynMode = 3 * (Total_noeud - Total_appui)
        Dim Depl_prop(Neq, Neq, DynMode) As Double 'identique au vecteur propre mais arrang sous une forme plus commode
        ReDim Depl_modal(Total_noeud * 3, 2, DynMode), Mmi(Neq, 3), Effort_quadra(6, Total_element, 2)
        ReDim Max_mode(3), Mass_struct(3), Depl_quadra(3 * Total_noeud, 2)
        '3 -- Calcul des Modes propres pertinents
        'rduction de la matrice masse aux noeuds non appuis
        Dim Mg1(Neq, Neq) As Double
        Dim P_mode(Neq, 3) As Double
        ii = 0
        For i = 1 To 3 * Total_noeud
            i3 = CInt(Int((i + 2) / 3))
            If Appui(i3) = False Then 'test si noeud n'est pas un appui
                ii = ii + 1 : jj = 0
                For j = 1 To 3 * Total_noeud
                    j3 = CInt(Int((j + 2) / 3))
                    If Appui(j3) = False Then 'test si noeud n'est pas un appui
                        jj = jj + 1
                        Mg1(ii, jj) = Mg(i, j)
                    End If
                Next
            End If
        Next
        'Discrimination des modes propres pertinents par les masses modales
        Call Masse_modale(Neq, Mg1, T, P_mode, Vect_prop, Depl_prop)
        '4 -- Calcul des efforts et des dplacement de la structure sous effort sismique
        '--Calcul des rponses modales (forces modales et deplacements modaux)
        Dim FNodalAppui(,,,), eFbarre_modal(,,,) As Double
        Call Reponse_modale(Kg, P_mode, Depl_prop, Rot, L, kg0, FNodalAppui, eFbarre_modal)
        '--Combinaison quadratique des dplacements et des efforts induits par le mouvement sismique
        Dim R_Appui_quadra(,,) As Double
        Call Combinaison_quadratique_reponse_modale(eFbarre_modal, FNodalAppui, R_Appui_quadra)
        '5 -- Combinaison des efforts et dplacements de la structure sous effort sismique et statique - Dtermination 
        ' des valeurs enveloppes
        Call Combinaison_sismique_effort_deplacement(R_Appui_quadra)

        ''--> Debogage de l'application:
        'sw.Write(msgg)
        'sw.Close()
        'msgg = "" 'remise  0 de la variable
    End Sub
    Private Sub Matrice_masse_Concentre_2D(ByRef Mg(,) As Double, ByVal L() As Double)
        Dim i, i1, i2, j, jD, jF As Integer
        Dim mg0(9, Total_element), mg1(9, Total_element), mg_ele(3, 3), mv, S1, S2, S As Double
        Dim msg As String
        'composition de toutes les matrices lmentaires, lment par lment
        '1- construction de la matrice de masse locale Mg0 et Mg1
        For i = 1 To Total_element
            ' si element a tous ses noeuds encastrs 
            If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                If Inert_Variable(i) = True Then
                    Select Case Type_profile(i)
                        Case 1 'profil en I
                            If H(1, i) <> H(2, i) Then 'inertie variable sur la hauteur du profil
                                S1 = ea(i) * H(1, i) + 2 * B(i) * es(i)
                                S2 = ea(i) * H(2, i) + 2 * B(i) * es(i)
                                If S2 > S1 Then S = (S1 + 2 * S2) / 3 Else S = (S2 + 2 * S1) / 3
                                mv = Ro(i) * S
                                mg0(1, i) = mv * L(i) / 2 : mg0(2, i) = 0 : mg0(3, i) = 0
                                mg0(4, i) = 0 : mg0(5, i) = mv * L(i) / 2 : mg0(6, i) = 0
                                mg0(7, i) = 0 : mg0(8, i) = 0 : mg0(9, i) = mv * L(i) ^ 3 / 24
                                mg1(1, i) = mv * L(i) / 2 : mg1(2, i) = 0 : mg1(3, i) = 0
                                mg1(4, i) = 0 : mg1(5, i) = mv * L(i) / 2 : mg1(6, i) = 0
                                mg1(7, i) = 0 : mg1(8, i) = 0 : mg1(9, i) = mv * L(i) ^ 3 / 24
                            Else
                                    msg = "Caractristiques de l'lment poutre en dehors du domaine" & vbCrLf & _
                                    "de modlisation du logiciel"
                                    MsgBox(msg, style, title)
                                    Exit Sub
                            End If
                            'Pour mmoire
                            'Case 2 'profil en tube rond
                            '    msg = "Caractristiques de l'lment poutre en dehors du domaine" & vbCrLf & _
                            '                                   "de modlisation du logiciel"
                            '    MsgBox(msg, style, title)
                            '    Exit Sub
                            'Case 3 'profil en tube rectangulaire
                    End Select
                Else
                    mg0(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(2, i) = 0 : mg0(3, i) = 0
                    mg0(4, i) = 0 : mg0(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(6, i) = 0
                    mg0(7, i) = 0 : mg0(8, i) = 0 : mg0(9, i) = Ro(i) * Sx(i) * L(i) ^ 3 / 24
                    mg1(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(2, i) = 0 : mg1(3, i) = 0
                    mg1(4, i) = 0 : mg1(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(6, i) = 0
                    mg1(7, i) = 0 : mg1(8, i) = 0 : mg1(9, i) = Ro(i) * Sx(i) * L(i) ^ 3 / 24
                End If
            End If
            ' si noe 1 relax et noe 2 encastr 
            If Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
                mg0(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(2, i) = 0 : mg0(3, i) = 0
                mg0(4, i) = 0 : mg0(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(6, i) = 0
                mg0(7, i) = 0 : mg0(8, i) = 0 : mg0(9, i) = 0
                mg1(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(2, i) = 0 : mg1(3, i) = 0
                mg1(4, i) = 0 : mg1(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(6, i) = 0
                mg1(7, i) = 0 : mg1(8, i) = 0 : mg1(9, i) = Ro(i) * Sx(i) * L(i) ^ 3 / 24
            End If
            ' si noe 1 encastr et noe 2 relax 
            If Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
                mg0(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(2, i) = 0 : mg0(3, i) = 0
                mg0(4, i) = 0 : mg0(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(6, i) = 0
                mg0(7, i) = 0 : mg0(8, i) = 0 : mg0(9, i) = Ro(i) * Sx(i) * L(i) ^ 3 / 24
                mg1(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(2, i) = 0 : mg1(3, i) = 0
                mg1(4, i) = 0 : mg1(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(6, i) = 0
                mg1(7, i) = 0 : mg1(8, i) = 0 : mg1(9, i) = 0
            End If
            ' si noe 1 et 2 relaxes
            If Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                mg0(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(2, i) = 0 : mg0(3, i) = 0
                mg0(4, i) = 0 : mg0(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg0(6, i) = 0
                mg0(7, i) = 0 : mg0(8, i) = 0 : mg0(9, i) = 0
                mg1(1, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(2, i) = 0 : mg1(3, i) = 0
                mg1(4, i) = 0 : mg1(5, i) = Ro(i) * Sx(i) * L(i) / 2 : mg1(6, i) = 0
                mg1(7, i) = 0 : mg1(8, i) = 0 : mg1(9, i) = 0
            End If
            'masses additionnelles
            mg0(1, i) = mg0(1, i) + mass_rep(1, i) * L(i) / 2 : mg0(1, i) = mg0(1, i) + mass_rep(2, i) * L(i) / 2
            mg0(5, i) = mg0(5, i) + mass_rep(1, i) * L(i) / 2 : mg0(5, i) = mg0(5, i) + mass_rep(2, i) * L(i) / 2
            mg1(1, i) = mg1(1, i) + mass_rep(1, i) * L(i) / 2 : mg1(1, i) = mg1(1, i) + mass_rep(2, i) * L(i) / 2
            mg1(5, i) = mg1(5, i) + mass_rep(1, i) * L(i) / 2 : mg1(5, i) = mg1(5, i) + mass_rep(2, i) * L(i) / 2
        Next
        '2 - Assemblage de la matrice
        'mise  zro de la matrice de masse globale
        For i = 1 To 3 * Total_noeud
            For j = 1 To 3 * Total_noeud
                Mg(i, j) = 0
            Next
        Next
        'assemblage matrice
        For i = 1 To Total_element
            jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = mg0(j, i)
                Next
            Next
            Call MatAdd(Mg, mg_ele, jD, jD)
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = mg1(j, i)
                Next
            Next
            Call MatAdd(Mg, mg_ele, jF, jF)
        Next
        Erase mg0, mg1, mg_ele
        ''--> Debogage de l'application: 
        ''    affichage dans le fichier de dtails du calcul de la matrice globale Mg
        'Dim F_Mg(3 * Total_noeud, 3 * Total_noeud) As String
        'msgg = msgg & "Matrice globale de masse Mg:" & vbCrLf
        'For i = 1 To 3 * Total_noeud
        '    For j = 1 To 3 * Total_noeud
        '        F_Mg(i, j) = Format(Mg(i, j), "###0.00")
        '        msgg = msgg & "  " & F_Mg(i, j)
        '    Next
        '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'Next
        'msgg = msgg & vbCrLf
    End Sub
    Private Sub Matrice_masse_Repartie_2D(ByRef Mg(,) As Double, ByVal L() As Double, ByVal Rot(,) As Double)
        Dim i, i1, i2, j, jD, jF, k, k11 As Integer
        Dim mg0(9, Total_element), mg1(9, Total_element), ml0(9, Total_element), ml1(9, Total_element), C1 As Double
        Dim mg_ele(3, 3), emass(6, 6), R(3, 3), Rt(3, 3), BB(3, 3) As Double
        'composition de toutes les matrices lmentaires, lment par lment
        '1- construction de la matrice de masse locale Mg0 et Mg1
        For i = 1 To Total_element
            ' si element a tous ses noeuds encastrs 
            If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                C1 = Ro(i) * Sx(i) * L(i) / 420
                emass(1, 1) = C1 * 2 * 420 / 6 : emass(1, 2) = 0 : emass(1, 3) = 0 : emass(1, 4) = C1 * 420 / 6 : emass(1, 5) = 0 : emass(1, 6) = 0
                emass(2, 2) = 156 * C1 : emass(2, 3) = -C1 * 22 * L(i) : emass(2, 4) = 0 : emass(2, 5) = C1 * 54 : emass(2, 6) = C1 * 13 * L(i)
                emass(3, 3) = C1 * 4 * L(i) ^ 2 : emass(3, 4) = 0 : emass(3, 5) = -C1 * 13 * L(i) : emass(3, 6) = -C1 * 3 * L(i) ^ 2
                emass(4, 4) = C1 * 2 * 420 / 6 : emass(4, 5) = 0 : emass(4, 6) = 0
                emass(5, 5) = C1 * 156 : emass(5, 6) = C1 * 22 * L(i)
                emass(6, 6) = C1 * 4 * L(i) ^ 2
            End If
            ' si element a le noe 1 relax et le noe 2 noeud encastr 
            If Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
                C1 = Ro(i) * Sx(i) * L(i) / 420
                emass(1, 1) = C1 * 2 * 420 / 6 : emass(1, 2) = 0 : emass(1, 3) = 0 : emass(1, 4) = C1 * 420 / 6 : emass(1, 5) = 0 : emass(1, 6) = 0
                emass(2, 2) = 156 * C1 : emass(2, 3) = 0 : emass(2, 4) = 0 : emass(2, 5) = C1 * 54 : emass(2, 6) = C1 * 13 * L(i)
                emass(3, 3) = 0 : emass(3, 4) = 0 : emass(3, 5) = 0 : emass(3, 6) = 0
                emass(4, 4) = C1 * 2 * 420 / 6 : emass(4, 5) = 0 : emass(4, 6) = 0
                emass(5, 5) = C1 * 156 : emass(5, 6) = C1 * 22 * L(i)
                emass(6, 6) = C1 * 4 * L(i) ^ 2
            End If
            ' si element a le noe 1 encastr et le noe 2 noeud relax 
            If Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
                C1 = Ro(i) * Sx(i) * L(i) / 420
                emass(1, 1) = C1 * 2 * 420 / 6 : emass(1, 2) = 0 : emass(1, 3) = 0 : emass(1, 4) = C1 * 420 / 6 : emass(1, 5) = 0 : emass(1, 6) = 0
                emass(2, 2) = 156 * C1 : emass(2, 3) = -C1 * 22 * L(i) : emass(2, 4) = 0 : emass(2, 5) = C1 * 54 : emass(2, 6) = 0
                emass(3, 3) = C1 * 4 * L(i) ^ 2 : emass(3, 4) = 0 : emass(3, 5) = -C1 * 13 * L(i) : emass(3, 6) = 0
                emass(4, 4) = C1 * 2 * 420 / 6 : emass(4, 5) = 0 : emass(4, 6) = 0
                emass(5, 5) = C1 * 156 : emass(5, 6) = 0
                emass(6, 6) = 0
            End If
            ' si element a tous ses noeuds relaxs
            If Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                C1 = Ro(i) * Sx(i) * L(i) / 6
                emass(1, 1) = C1 * 2 : emass(1, 2) = 0 : emass(1, 3) = 0 : emass(1, 4) = C1 : emass(1, 5) = 0 : emass(1, 6) = 0
                emass(2, 2) = 0 : emass(2, 3) = 0 : emass(2, 4) = 0 : emass(2, 5) = 0 : emass(2, 6) = 0
                emass(3, 3) = 0 : emass(3, 4) = 0 : emass(3, 5) = 0 : emass(3, 6) = 0
                emass(4, 4) = C1 * 2 : emass(4, 5) = 0 : emass(4, 6) = 0
                emass(5, 5) = 0 : emass(5, 6) = 0
                emass(6, 6) = 0
            End If
            'Remplissage de la moiti partie basse infrieure symtrique de la matrice masse
            For j = 2 To 6
                i1 = j - 1
                For i2 = 1 To i1
                    emass(j, i2) = emass(i2, j)
                Next
            Next
            mg0(1, i) = emass(1, 1) : mg0(2, i) = emass(1, 2) : mg0(3, i) = emass(1, 3)
            mg0(4, i) = emass(2, 1) : mg0(5, i) = emass(2, 2) : mg0(6, i) = emass(2, 3)
            mg0(7, i) = emass(3, 1) : mg0(8, i) = emass(3, 2) : mg0(9, i) = emass(3, 3)
            ml1(1, i) = emass(1, 4) : ml1(2, i) = emass(1, 5) : ml1(3, i) = emass(1, 6)
            ml1(4, i) = emass(2, 4) : ml1(5, i) = emass(2, 5) : ml1(6, i) = emass(2, 6)
            ml1(7, i) = emass(3, 4) : ml1(8, i) = emass(3, 5) : ml1(9, i) = emass(3, 6)
            mg1(1, i) = emass(4, 4) : mg1(2, i) = emass(4, 5) : mg1(3, i) = emass(4, 6)
            mg1(4, i) = emass(5, 4) : mg1(5, i) = emass(5, 5) : mg1(6, i) = emass(5, 6)
            mg1(7, i) = emass(6, 4) : mg1(8, i) = emass(6, 5) : mg1(9, i) = emass(6, 6)
            ml0(1, i) = emass(4, 1) : ml0(2, i) = emass(4, 2) : ml0(3, i) = emass(4, 3)
            ml0(4, i) = emass(5, 1) : ml0(5, i) = emass(5, 2) : ml0(6, i) = emass(5, 3)
            ml0(7, i) = emass(6, 1) : ml0(8, i) = emass(6, 2) : ml0(9, i) = emass(6, 3)

        Next
        '2 - Assemblage de la matrice
        'mise  zro de la matrice de masse globale
        For i = 1 To 3 * Total_noeud
            For j = 1 To 3 * Total_noeud
                Mg(i, j) = 0
            Next
        Next
        'assemblage matrice
        For i = 1 To Total_element
            'mise de rot dans R et Rt
            j = 0
            For k = 1 To 3
                For k11 = 1 To 3
                    j = j + 1
                    R(k, k11) = Rot(j, i) : Rt(k11, k) = Rot(j, i)
                Next
            Next
            'mg0
            jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = mg0(j, i)
                Next
            Next
            'rotation et addition
            Call Matmul(Rt, mg_ele, BB)
            Call Matmul(BB, R, mg_ele)
            Call MatAdd(Mg, mg_ele, jD, jD)
            'mg1
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = mg1(j, i)
                Next
            Next
            'rotation et addition
            Call Matmul(Rt, mg_ele, BB)
            Call Matmul(BB, R, mg_ele)
            Call MatAdd(Mg, mg_ele, jF, jF)
            'ml0
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = ml0(j, i)
                Next
            Next
            'rotation et addition
            Call Matmul(Rt, mg_ele, BB)
            Call Matmul(BB, R, mg_ele)
            Call MatAdd(Mg, mg_ele, jF, jD)
            'ml1
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = ml1(j, i)
                Next
            Next
            'rotation et addition
            Call Matmul(Rt, mg_ele, BB)
            Call Matmul(BB, R, mg_ele)
            Call MatAdd(Mg, mg_ele, jD, jF)
        Next
        Erase mg0, mg1, ml0, ml1, mg_ele, BB, R, Rt
    End Sub
    Private Sub Matrice_masse_Repartie_2D_avec_G(ByRef Mg(,) As Double, ByVal L() As Double)
        Dim beta, zasf, X, Y, xl, yl, C0, C1, const2, Sr(Total_element), emass(6, 6) As Double '
        Dim a1, a2, s11, s12, q11, q12, t11, t12 As Double
        Dim mg0(9, Total_element), mg1(9, Total_element), ml0(9, Total_element), ml1(9, Total_element), mg_ele(3, 3) As Double
        Dim i, i1, i2, j, j1, j2, jD, jF As Integer
        Dim udlmass As Double
        Def_Tranchant = True 'a titre provisoire
        'composition de toutes les matrices lmentaires, lment par lment
        '1- construction de la matrice de masse locale Mg0 et Mg1
        For i = 1 To Total_element
            X = X_noe(Ele(2, i)) - X_noe(Ele(1, i))
            Y = Y_noe(Ele(2, i)) - Y_noe(Ele(1, i))
            If Type_probleme = 2 Then Call Section_reduite(i, Sr(i)) 'dtermination de la section rduite de l'lment
            zasf = Sx(i) / Sr(i)
            xl = X / L(i) 'cosinus directeur
            yl = Y / L(i) 'sinus directeur
            beta = 12 * Ey(i) * Iy(i) * zasf / (G(i) * Sx(i) * L(i) ^ 2)
            'Calcul des coefficients de la matrice masse rpartie sous dformation due au moment de flexion
            'et d'effort tranchant
            'ATTENTION: udlmass est donn dans le repre local  l'lment ce qui explique l'utilisation des cosinus 
            '           et sinus directeur dans la matrice masse
            'A titre provisoire
            udlmass = Ro(i) * Sx(i)
            C0 = udlmass * L(i) / (beta + 1) ^ 2
            C1 = C0 * Iy(i) / (Sx(i) * L(i) ^ 2)
            s11 = (1 / 105 + beta / 60 + beta ^ 2 / 120) * L(i) ^ 2 * C0 + (2 / 15 + beta / 6 + beta ^ 2 / 3) * L(i) ^ 2 * C1
            s12 = -(1 / 140 + beta / 60 + beta ^ 2 / 120) * L(i) ^ 2 * C0 - (1 / 30 + beta / 6 - beta ^ 2 / 6) * L(i) ^ 2 * C1
            q11 = (11 / 210 + 11 * beta / 120 + beta ^ 2 / 24) * L(i) * C0 + (0.5 * beta - 0.1) * L(i) * C1
            q12 = -(13 / 420 + 3 * beta / 40 + beta ^ 2 / 24) * L(i) * C0 + (0.5 * beta - 0.1) * L(i) * C1
            t11 = (13 / 35 + 0.7 * beta + beta ^ 2 / 3) * C0 + 1.2 * C1
            t12 = -(54 / 420 + 0.3 * beta + beta ^ 2 / 6) * C0 + 1.2 * C1
            'Calcul des coefficients de la matrice masse rpartie sous dformation axiale
            const2 = udlmass * L(i) / 6
            a1 = 2 * const2
            a2 = const2
            'calcul des coefficient de la matrice masse dans le repre global
            emass(1, 1) = t11 * yl ^ 2 + a1 * xl ^ 2 : emass(1, 2) = (-t11 + a1) * xl * yl : emass(1, 3) = q11 * yl
            emass(1, 4) = -t12 * yl ^ 2 + a2 * yl ^ 2 : emass(1, 5) = (t12 + a2) * xl * yl : emass(1, 6) = q12 * yl
            emass(2, 2) = t11 * yl ^ 2 + a1 * xl ^ 2 : emass(2, 3) = q11 * xl : emass(2, 4) = emass(1, 5)
            emass(2, 5) = -t12 * xl ^ 2 + a2 * yl ^ 2 : emass(2, 6) = -q12 * xl
            emass(3, 3) = s11 : emass(3, 4) = -emass(1, 6) : emass(3, 5) = -emass(2, 6) : emass(3, 6) = s12
            emass(4, 4) = emass(1, 1) : emass(4, 5) = emass(1, 2) : emass(4, 6) = -emass(1, 3)
            emass(5, 5) = emass(2, 2) : emass(5, 6) = -emass(2, 3)
            emass(6, 6) = s11
            ' si element a tous ses noeuds relaxs
            If Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                C1 = Ro(i) * Sx(i) * L(i) / 6
                emass(1, 1) = C1 * 2 : emass(1, 2) = 0 : emass(1, 3) = 0 : emass(1, 4) = C1 : emass(1, 5) = 0 : emass(1, 6) = 0
                emass(2, 2) = 0 : emass(2, 3) = 0 * L(i) : emass(2, 4) = 0 : emass(2, 5) = 0 : emass(2, 6) = 0
                emass(3, 3) = 0 : emass(3, 4) = 0 : emass(3, 5) = 0 : emass(3, 6) = 0
                emass(4, 4) = C1 * 2 : emass(4, 5) = 0 : emass(4, 6) = 0
                emass(5, 5) = 0 : emass(5, 6) = 0
                emass(6, 6) = 0
            End If
            'Remplissage de la moiti partie basse infrieure symtrique de la matrice masse
            For j = 2 To 6
                j1 = j - 1
                For j2 = 1 To j1
                    emass(j, j2) = emass(j2, j)
                Next
            Next
            '' si element a tous ses noeuds encastrs 
            'If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
            mg0(1, i) = emass(1, 1) : mg0(2, i) = emass(1, 2) : mg0(3, i) = emass(1, 3)
            mg0(4, i) = emass(2, 1) : mg0(5, i) = emass(2, 2) : mg0(6, i) = emass(2, 3)
            mg0(7, i) = emass(3, 1) : mg0(8, i) = emass(3, 2) : mg0(9, i) = emass(3, 3)
            ml1(1, i) = emass(1, 4) : ml1(2, i) = emass(1, 5) : ml1(3, i) = emass(1, 6)
            ml1(4, i) = emass(2, 4) : ml1(5, i) = emass(2, 5) : ml1(6, i) = emass(2, 6)
            ml1(7, i) = emass(3, 4) : ml1(8, i) = emass(3, 5) : ml1(9, i) = emass(3, 6)
            mg1(1, i) = emass(4, 4) : mg1(2, i) = emass(4, 5) : mg1(3, i) = emass(4, 6)
            mg1(4, i) = emass(5, 4) : mg1(5, i) = emass(5, 5) : mg1(6, i) = emass(5, 6)
            mg1(7, i) = emass(6, 4) : mg1(8, i) = emass(6, 5) : mg1(9, i) = emass(6, 6)
            ml0(1, i) = emass(4, 1) : ml0(2, i) = emass(4, 2) : ml0(3, i) = emass(4, 3)
            ml0(4, i) = emass(5, 1) : ml0(5, i) = emass(5, 2) : ml0(6, i) = emass(5, 3)
            ml0(7, i) = emass(6, 1) : ml0(8, i) = emass(6, 2) : ml0(9, i) = emass(6, 3)
            'End If
            '' si noe 1 et 2 relaxs
            'If Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
            'mg0(1, i) = emass(1, 1) : mg0(2, i) = emass(1, 2) : mg0(3, i) = 0
            'mg0(4, i) = emass(2, 1) : mg0(5, i) = emass(2, 2) : mg0(6, i) = 0
            'mg0(7, i) = 0 : mg0(8, i) = 0 : mg0(9, i) = 0
            'ml0(1, i) = emass(1, 4) : ml0(2, i) = emass(1, 5) : ml0(3, i) = 0
            'ml0(4, i) = emass(2, 4) : ml0(5, i) = emass(2, 5) : ml0(6, i) = 0
            'ml0(7, i) = 0 : ml0(8, i) = 0 : ml0(9, i) = 0
            'mg1(1, i) = emass(4, 4) : mg1(2, i) = emass(4, 5) : mg1(3, i) = 0
            'mg1(4, i) = emass(5, 4) : mg1(5, i) = emass(5, 5) : mg1(6, i) = 0
            'mg1(7, i) = 0 : mg1(8, i) = 0 : mg1(9, i) = 0
            'ml1(1, i) = emass(4, 1) : ml1(2, i) = emass(4, 2) : ml1(3, i) = 0
            'ml1(4, i) = emass(5, 1) : ml1(5, i) = emass(5, 2) : ml1(6, i) = 0
            'ml1(7, i) = 0 : ml1(8, i) = 0 : ml1(9, i) = 0
            'End If
        Next
        '2 - Assemblage de la matrice
        'mise  zro de la matrice de masse globale
        For i = 1 To 3 * Total_noeud
            For j = 1 To 3 * Total_noeud
                Mg(i, j) = 0
            Next
        Next
        'assemblage matrice
        For i = 1 To Total_element
            jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = mg0(j, i)
                Next
            Next
            Call MatAdd(Mg, mg_ele, jD, jD)
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = mg1(j, i)
                Next
            Next
            Call MatAdd(Mg, mg_ele, jF, jF)
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = ml0(j, i)
                Next
            Next
            Call MatAdd(Mg, mg_ele, jF, jD)
            j = 0
            For i1 = 1 To 3
                For i2 = 1 To 3
                    j = j + 1
                    mg_ele(i1, i2) = ml1(j, i)
                Next
            Next
            Call MatAdd(Mg, mg_ele, jD, jF)
        Next
        Erase mg0, mg1, ml0, ml1, mg_ele, emass


        ''Retrouver les liberts des noeuds correspondant aux noeuds-stockage dans la matrice colonne
        'For idofn = 1 To ndofn
        '    memdis(idofn) = nodfre(iend, idofn)
        '    memdis(idofn + idofn) = nodfre(jend, idofn)
        'Next
        ''Assemblage de la matrice masse de la structure sous forme de vecteur
        'For ievab = 1 To nevab
        '    If memdis(ievab) > 0 Then
        '        For jevab = 1 To nevab
        '            If memdis(jevab) > 0 And memdis(jevab) >= memdis(ievab) Then
        '                'Calcul de la position des elements dans vecteur
        '                ij = ndia(memdis(jevab)) + memdis(jevab) - memdis(ievab)
        '                gmass(ij) = gmass(ij) + emass(ievab, jevab)
        '            End If
        '        Next
        '    End If
        'Next
        ''Modifier la matrice masse pour prise en compte des masses concentres
        'If nlodn > 0 Then
        '    For ilodn = 1 To nlodnd
        '        For idofn = 1 To 2
        '            i = nodfre(maspt(ilodnd), idofn)
        '            If i > 0 Then
        '                ij = ndia(i)
        '                gmass(ij) = gmass(ij) + xmasnd(ilodnd)
        '            End If
        '        Next
        '    Next
        'End If

    End Sub
    Private Sub Section_reduite(ByVal i As Integer, ByRef Sr As Double)
        'l'effort tranchant prpondrant est suppos vertical et // au sens de la + grande inertie
        Select Case Type_profile(i)
            Case 1 'profil en I
                If Gamma(i) = 0 Then
                    If Sry(i) = 0 Then
                        Sr = H(1, i) * ea(i)
                    Else
                        Sr = Sry(i)
                    End If
                Else
                    'profil  plat
                    If Sry(i) = 0 Then
                        Sr = 2 * B(i) * es(i)
                    Else
                        Sr = Sry(i)
                    End If
                End If
            Case 2 'profil en tube rond
                Sr = 5 * Sx(i) / 6
            Case 3 'profil en tube carr
                Sr = 5 * Sx(i) / 6
        End Select
    End Sub
    Private Sub MatAdd(ByRef AK(,) As Double, ByVal A(,) As Double, ByVal Jlig As Integer, ByVal Jcol As Integer)
        'Sous-programme d'addition de la matrice A en ligne Jlig et colonne jcol dans la matrice Mg
        Dim i, j, ii, jj, il, ic As Integer
        ii = 3 * (Jlig - 1)
        jj = 3 * (Jcol - 1)
        For i = 1 To 3
            For j = 1 To 3
                il = ii + i
                ic = jj + j
                AK(il, ic) = AK(il, ic) + A(i, j)
            Next
        Next
    End Sub
   
    Private Sub Jacobi(ByVal VK() As Double, ByVal VM() As Double, ByVal n As Integer, ByVal ncyM As Integer, ByVal eps As Double, _
                       ByRef ValP() As Double, ByRef Vect(,) As Double, ByRef structure_OK As Boolean)
        'n = taille de la matrice n x n ou du vecteur n
        'ncyM = nombe de cycle Maximum
        Dim i, ii, ik, ip1, ij, ij1, ic, itr, i0, im, iMax, j, j1, j2, jk, jjk, jp1, jm1, j0, j3, jj As Integer
        Dim a, aa, a2, b, bb, b2, c1, c2, c3, d, d1, d2, det, epsd, epsd0, fK, fM, valp0(n) As Double
        Dim Test_convergence As Boolean
        Dim msg As String
        epsd0 = 0.0001
        itr = 0
        ic = 0
        'Vrifier que les termes diagonaux soient positifs et initialiser les valeurs propres
        j = 0
        For i = 1 To n
            j = j + i
            If VK(j) <= 0 Then
                msg = "Erreur, la matrice de rigidit prsente un terme diagonal ngatif  " & vbCrLf & _
                                       "dans module Jacobi au test initial"
                MsgBox(msg, style, title)
                structure_OK = False
                Exit Sub
            ElseIf VM(j) <= 0 Then
                msg = "Erreur, la matrice masse prsente un terme diagonal ngatif  " & vbCrLf & _
                     "dans module Jacobi au test initial"
                MsgBox(msg, style, title)
                structure_OK = False
                Exit Sub
            Else
                ValP(i) = VK(j) / VM(j) : valp0(i) = ValP(i)
            End If
        Next
        'Initialiser les vecteurs propres
        For i = 1 To n : For j = 1 To n : Vect(i, j) = 0 : Next : Vect(i, i) = 1 : Next
        'Pour chaque cycle
        Do While ic < ncyM
            ic = ic + 1
            '--Tolrance dynamique
            epsd = epsd0 ^ ic
            '--Balayage du triangle suprieur par lignes
            iMax = n - 1
            ii = 0
            For i = 1 To iMax
                i0 = ii + 1 : ii = ii + i : ip1 = i + 1 : ij = ii + i : jj = ii
                For j = ip1 To n
                    jp1 = j + 1 : jm1 = j - 1 : j0 = jj + 1 : jj = jj + j : j3 = jj - 1
                    '-- calcul des facteurs de couplage
                    fK = (VK(ij) * VK(ij)) / (VK(ii) * VK(jj)) : fM = (VM(ij) * VM(ij)) / (VM(ii) * VM(jj))
                    If fK > epsd Or fM > epsd Then
                        '--calcul des coefficients de la transformation
                        itr = itr + 1
                        c1 = VK(ii) * VM(ij) - VM(ii) * VK(ij)
                        c2 = VK(jj) * VM(ij) - VM(jj) * VK(ij)
                        c3 = VK(ii) * VM(jj) - VM(ii) * VK(jj)
                        det = (c3 * c3 / 4) + (c1 * c2)
                        If det < 0 Then
                            msg = "Erreur, transformation de Jacobi singulire"
                            MsgBox(msg, style, title)
                            structure_OK = False
                            Exit Sub
                        End If
                        det = Sqrt(det)
                        d1 = c3 / 2 + det
                        d2 = c3 / 2 - det
                        d = d1
                        If Abs(d2) > Abs(d1) Then d = d2
                        If d = 0 Then
                            a = 0
                            b = -VK(ij) / VK(jj)
                        Else
                            a = c2 / d
                            b = -c1 / d
                        End If
                        '--modifier les colonnes de K et M
                        If i <> 1 Then
                            ik = i0
                            j1 = ij - 1
                            For jk = j0 To j1
                                c1 = VK(ik)
                                c2 = VK(jk)
                                VK(ik) = c1 + b * c2
                                VK(jk) = c2 + a * c1
                                c1 = VM(ik)
                                c2 = VM(jk)
                                VM(ik) = c1 + b * c2
                                VM(jk) = c2 + a * c1
                                ik = ik + 1
                            Next
                        End If
                        If i <> jm1 Then
                            ik = ii + i
                            j2 = ij + 1
                            im = i
                            For jk = j2 To j3
                                c1 = VK(ik)
                                c2 = VK(jk)
                                VK(ik) = c1 + b * c2
                                VK(jk) = c2 + a * c1
                                c1 = VM(ik)
                                c2 = VM(jk)
                                VM(ik) = c1 + b * c2
                                VM(jk) = c2 + a * c1
                                im = im + 1
                                ik = ik + im
                            Next
                        End If
                        If j <> n Then
                            ik = ij + j
                            jk = jj + j
                            im = j
                            For jjk = jp1 To n
                                c1 = VK(ik)
                                c2 = VK(jk)
                                VK(ik) = c1 + b * c2
                                VK(jk) = c2 + a * c1
                                c1 = VM(ik)
                                c2 = VM(jk)
                                VM(ik) = c1 + b * c2
                                VM(jk) = c2 + a * c1
                                im = im + 1
                                ik = ik + im
                                jk = jk + im
                            Next
                        End If
                        c1 = VK(ii)
                        c2 = VK(ij)
                        c3 = VK(jj)
                        b2 = b * b
                        bb = 2 * b
                        a2 = a * a
                        aa = a * 2
                        VK(ii) = c1 + bb * c2 + b2 * c3
                        VK(ij) = 0
                        VK(jj) = c3 + aa * c2 + a2 * c1
                        c1 = VM(ii)
                        c2 = VM(ij)
                        c3 = VM(jj)
                        VM(ii) = c1 + bb * c2 + b2 * c3
                        VM(ij) = 0
                        VM(jj) = c3 + aa * c2 + a2 * c1
                        '-- mettre  jour les vecteurs propres
                        For ij1 = 1 To n
                            c1 = Vect(ij1, i)
                            c2 = Vect(ij1, j)
                            Vect(ij1, i) = c1 + b * c2
                            Vect(ij1, j) = c2 + a * c1
                        Next
                    End If
                    ij = ij + j
                Next
            Next
            '--mise  jour des valeurs propres
            ii = 0
            For i = 1 To n
                ii = ii + i
                If VK(ii) <= 0 Then
                    msg = "Erreur, la matrice de rigidit prsente un terme diagonal ngatif  " & vbCrLf & _
                        "dans module Jacobi au cycle N " & CStr(ic)
                    MsgBox(msg, style, title)
                    structure_OK = False
                    Exit Sub
                ElseIf VM(ii) <= 0 Then
                    msg = "Erreur, la matrice masse prsente un terme diagonal ngatif  " & vbCrLf & _
                         "dans module Jacobi au cycle N " & CStr(ic)
                    MsgBox(msg, style, title)
                    structure_OK = False
                    Exit Sub
                Else
                    ValP(i) = VK(ii) / VM(ii)
                End If
            Next
            '--tests de convergence
            '---- 1 - test de convergence des valeurs propres
            i = 1
            Test_convergence = False
            Do
                If Abs(ValP(i) - valp0(i)) > (eps * valp0(i)) Then Exit Do
                i = i + 1
            Loop Until i = n + 1
            If i = n + 1 Then Test_convergence = True
            '---- 2 - test de convergence sur les termes non diagonaux
            If Test_convergence = True Then
                jj = 1 : j = 2
                Do
                    jj = jj + j
                    jm1 = j - 1
                    ii = 0
                    For i = 1 To jm1
                        ii = ii + i
                        ij = jj - j + i
                        fK = VK(ij) * VK(ij) / (VK(ii) * VK(jj))
                        fM = VM(ij) * VM(ij) / (VM(ii) * VM(jj))
                        If fK > eps ^ 2 Or fM > eps ^ 2 Then Test_convergence = False : Exit For
                    Next
                    j = j + 1
                Loop Until Test_convergence = False Or j = n + 1
                If Test_convergence = True Then
                    '--normaliser les vecteurs propres
                    jj = 0
                    For j = 1 To n
                        jj = jj + j
                        c1 = Sqrt(VM(jj))
                        For i = 1 To n
                            Vect(i, j) = Vect(i, j) / c1  'vecteur propre pour la valeur propre j
                        Next
                    Next
                    '--convergence atteinte
                    'Console.WriteLine("convergence atteinte en " & CStr(ic) & " cycles et " & CStr(itr) & " transformations dans Jacobi")
                    Exit Sub
                End If
            End If
            '--recopier valp dans valp0
            For i = 1 To n
                valp0(i) = ValP(i)
            Next
        Loop
        msg = "Erreur, non convergence dans Jacobi en " & Str(ncyM) & " cycles"
        MsgBox(msg, style, title)
        structure_OK = False
    End Sub
    Private Sub Masse_modale(ByVal neq As Integer, ByVal Mg(,) As Double, ByVal T() As Double, ByRef P_mode(,) As Double, _
                             ByVal Vect_prop(,) As Double, ByRef Depl_prop(,,) As Double)
        'Mmi(DynMode, 3) = masse modale de rang i=1  DynMode suivant la direction d'excitation X=1,Y=2,Z=3
        'P_mode(DynMode, 3)= facteur de participation de la masse modale de rang i=1  DynMode suivant la direction d'excitation X=1,Y=2,Z=3e
        'Remarque sur ce sous-programme:
        '  le programme calcule toutes les masses modales puis les classent par ordre dcroissant pour dterminer les
        'frquences pertinentes pour la direction choisie. L'algorithme est plus long mais plus clair

        Dim i, i1, i_mode, ii, j, jj, k, pas As Integer
        Dim A(neq), Vxyz(neq), m_pas2(neq) As Double
        Dim M_tot, m_pas, m_pas1 As Double
        'Calcul du vecteur de dplacement correspondant  la direction d'excitation tudie
        'suivant X->j=1, Y->j=2, suivant rotation autour de Z->j=3 - cette dernire n'est pas calcul car tant trs
        'peu pertinent pour un calcul de structure 2D
        For j = 1 To 2
            'dtermination du vecteur direction X ou Y
            k = 0
            For i = 1 To neq
                Vxyz(i) = 0
                If (k * 3) + j = i Then
                    Vxyz(i) = 1
                    k = k + 1
                End If
            Next
            'dtermination de la masse de la structure participante au vecteur direction X ou Y
            For i = 1 To neq
                A(i) = 0
                For i1 = 1 To neq
                    A(i) = A(i) + Mg(i, i1) * Vxyz(i1)
                Next
            Next
            Mass_struct(j) = Vxyz(1) * A(1)
            For i = 2 To neq
                Mass_struct(j) = Mass_struct(j) + Vxyz(i) * A(i)
            Next
            'Calcul de la masse modale effective du mode i suivant la direction X ou Y
            For i_mode = 1 To neq
                P_mode(i_mode, j) = Vect_prop(1, i_mode) * A(1)
                For i = 2 To neq
                    P_mode(i_mode, j) = P_mode(i_mode, j) + Vect_prop(i, i_mode) * A(i)
                Next
                Mmi(i_mode, j) = P_mode(i_mode, j) ^ 2 'masse modale de rang i
            Next
        Next j
        'classement des masses modales de la plus grande  la plus petite par la mthode de tri de Shell-Metzner ce 
        'qui oblige de reclasser Def_dyn(,) et Freq(,)
        For j = 1 To 2 'direction X ou Y
            For i = 1 To neq 'mode
                Freq(i, j) = 1 / T(i)
                For i1 = 1 To neq '3 valeurs par noeud car espace 2D
                    Depl_prop(i1, i, j) = Vect_prop(i1, i)
                Next
            Next
            pas = neq
            Do
                pas = CInt(Int(pas / 2))
                Do
                    jj = 0
                    For i = 1 To neq - pas
                        If Mmi(i, j) < Mmi(i + pas, j) Then
                            m_pas = Mmi(i, j) : m_pas1 = Freq(i, j)
                            For i1 = 1 To neq
                                m_pas2(i1) = Depl_prop(i1, i, j)
                            Next
                            Mmi(i, j) = Mmi(i + pas, j) : Freq(i, j) = Freq(i + pas, j)
                            For i1 = 1 To neq
                                Depl_prop(i1, i, j) = Depl_prop(i1, i + pas, j)
                            Next
                            Mmi(i + pas, j) = m_pas : Freq(i + pas, j) = m_pas1
                            For i1 = 1 To neq
                                Depl_prop(i1, i + pas, j) = m_pas2(i1)
                            Next
                            jj = jj + 1
                        End If
                    Next
                Loop While jj <> 0
            Loop While pas > 1
        Next
        'dtermination des masses modales pertinentes
        For j = 1 To 2
            M_tot = 0
            For i_mode = 1 To neq
                M_tot = M_tot + Mmi(i_mode, j)
                Max_mode(j) = i_mode
                If M_tot > 0.9 * Mass_struct(j) And i_mode >= 3 Then Exit For
            Next
        Next
    End Sub
    Private Sub Masse_Participante(ByVal L() As Double, ByVal N_cas As Integer, ByRef mass As Double)
        'total des masses situes au dessus de l'interface sol-structure susceptible de subir des dplacements dans la direction tudie
        Dim j As Integer
        mass = 0
        'forces uniformement rparties dans le repre local
        For j = 1 To Total_element      'balayage de l'ensemble des lments de la structure
            Stop
            'If p_cas(1, j, N_cas) = True Then 'force rpartie suivant X local
            '    Stop 'mass = mass + L(j) * ForL(N_cas, j, 1) * 10 / 9.81 'transformation daN->Kg
            '    If mass < 0 Then mass = -mass
            'End If
            'If p_cas(2, j, N_cas) = True Then 'force rpartie suivant Y local
            '    Stop '      mass = mass + L(j) * ForL(N_cas, j, 2) * 10 / 9.81
            '    If mass < 0 Then mass = -mass
            'End If
        Next

    End Sub
    Private Sub Reponse_modale(ByVal Kg(,) As Double, ByVal P_mode(,) As Double, ByVal Depl_prop(,,) As Double, _
                               ByVal Rot(,) As Double, ByVal L() As Double, ByVal kg0(,) As Double, ByRef FNodalAppui(,,,) As Double, _
                               ByRef eFbarre_modal(,,,) As Double)
        Dim i, i3, ii, i_mode, j, j1, jD, jF, jj, k, Maxxx As Integer
        Dim omega(3 * (Total_noeud - Total_appui)), T, Efb(6, Total_element), Dp(3, Total_noeud), X0, Y0, A0, X1, Y1, A1, Dpp(3) As Double
        Dim Tg(3, 3), K1(3, 3), L1(3, 3), F0, F1, FB(6, Total_element), FN(3, Total_noeud) As Double
        If Max_mode(1) > Max_mode(2) Then Maxxx = Max_mode(1) Else Maxxx = Max_mode(2)
        ReDim FNodalAppui(3, Total_noeud, 2, Maxxx)
        ReDim eFbarre_modal(6, Total_element, 2, Maxxx)
        For j = 1 To 2 'Pour chaque direction du seisme (suivant X->j=1, suivant Y->j=2, suivant rotation autour de Z->j=3)
            'calcul des dplacements et des efforts nodaux modaux pour chaque mode et chaque direction du seisme
            For i_mode = 1 To Max_mode(j) 'pour chaque frquence pertinente dans la direction j
                omega(i_mode) = (2 * PI * Freq(i_mode, j)) ^ 2  'pulsation leve au carr
                k = 0
                For i = 1 To Total_noeud * 3   'pour chaque noeud en espace 2D, 3 dplacements x,y et rot  
                    i3 = CInt(Int((i + 2) / 3))
                    If Appui(i3) = True Then
                        Depl_modal(i, j, i_mode) = 0
                    Else
                        k = k + 1
                        T = 1 / Freq(i_mode, j)
                        Depl_modal(i, j, i_mode) = Depl_prop(k, i_mode, j) * P_mode(i_mode, j) * R(T) / omega(i_mode)
                    End If
                Next
            Next
        Next
        'Calcul des efforts sismiques
        Call Second_Membre(L, Rot, FB)
        For j = 1 To 2 'Pour chaque direction du seisme (suivant X->j=1, suivant Y->j=2, suivant rotation autour de Z->j=3)
            'calcul des efforts nodaux modaux pour chaque mode et chaque direction du seisme
            For i_mode = 1 To Max_mode(j) 'pour chaque frquence pertinente dans la direction j
                'Phase 1 : calcul des efforts dans les barres
                For k = 1 To Total_element
                    'mise  zro de Efb
                    For i3 = 1 To 6
                        Efb(i3, k) = 0
                    Next
                    'dplacement absolu des noeuds dans le repre local pour chaque lment
                    jD = Ele(1, k) : jF = Ele(2, k) 'numro de noeud de dbut et fin de barre
                    i3 = (jD - 1) * 3 + 1
                    Dp(1, jD) = Depl_modal(i3, j, i_mode) : Dp(2, jD) = Depl_modal(i3 + 1, j, i_mode) : Dp(3, jD) = Depl_modal(i3 + 2, j, i_mode)
                    i3 = (jF - 1) * 3 + 1
                    Dp(1, jF) = Depl_modal(i3, j, i_mode) : Dp(2, jF) = Depl_modal(i3 + 1, j, i_mode) : Dp(3, jF) = Depl_modal(i3 + 2, j, i_mode)
                    X0 = Dp(1, jD) * Rot(1, k) + Dp(2, jD) * Rot(2, k)
                    Y0 = Dp(1, jD) * Rot(4, k) + Dp(2, jD) * Rot(5, k)
                    A0 = Dp(3, jD)
                    X1 = Dp(1, jF) * Rot(1, k) + Dp(2, jF) * Rot(2, k)
                    Y1 = Dp(1, jF) * Rot(4, k) + Dp(2, jF) * Rot(5, k)
                    A1 = Dp(3, jF)
                    'calcul des dplacements relatifs
                    Dpp(1) = X1 - X0
                    Dpp(2) = Y1 - Y0 - A0 * L(k)
                    Dpp(3) = A1 - A0
                    'calcul de la matrice K1 et L1
                    j1 = 0
                    For ii = 1 To 3
                        For jj = 1 To 3
                            j1 = j1 + 1
                            K1(ii, jj) = kg0(j1, k)
                        Next
                    Next
                    'matrice de transposition
                    For ii = 1 To 3
                        For jj = 1 To 3
                            Tg(ii, jj) = 0
                        Next
                        Tg(ii, ii) = -1
                    Next
                    Tg(3, 2) = -L(k)
                    'calcul de la matrice L1
                    Call Matmul(Tg, K1, L1)
                    'Efforts dus aux dplacements
                    For ii = 1 To 3
                        F0 = 0 : F1 = 0
                        For jj = 1 To 3
                            F0 = F0 + L1(ii, jj) * Dpp(jj)
                            F1 = F1 + K1(ii, jj) * Dpp(jj)
                        Next
                        Efb(ii, k) = Efb(ii, k) + F0
                        Efb(ii + 3, k) = Efb(ii + 3, k) + F1
                    Next
                    'Ajout des termes dus aux forces sur les barres
                    For ii = 1 To 6
                        Efb(ii, k) = Efb(ii, k) + FB(ii, k)
                    Next
                Next
                'phase 2 :  raction d'appui
                For ii = 1 To Total_noeud
                    For jj = 1 To 3
                        FN(jj, ii) = 0
                    Next
                Next
                'boucle sur les barres: dtermination des efforts nodaux - repre global
                For i = 1 To Total_element
                    jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
                    FN(1, jD) = FN(1, jD) + Rot(1, i) * Efb(1, i) + Rot(4, i) * Efb(2, i)
                    FN(2, jD) = FN(2, jD) + Rot(2, i) * Efb(1, i) + Rot(5, i) * Efb(2, i)
                    FN(3, jD) = FN(3, jD) + Efb(3, i)
                    FN(1, jF) = FN(1, jF) + Rot(1, i) * Efb(4, i) + Rot(4, i) * Efb(5, i)
                    FN(2, jF) = FN(2, jF) + Rot(2, i) * Efb(4, i) + Rot(5, i) * Efb(5, i)
                    FN(3, jF) = FN(3, jF) + Efb(6, i)
                Next
                'affectation des rsultats
                'ractions d'appui dans le repre global
                For i = 1 To Total_noeud
                    If Appui(i) = True Then
                        FNodalAppui(1, i, j, i_mode) = FN(1, i) : FNodalAppui(2, i, j, i_mode) = FN(2, i)
                        FNodalAppui(3, i, j, i_mode) = FN(3, i)
                    End If
                Next
                'efforts dans les barres dans le repre local de la barre
                For i = 1 To Total_element
                    eFbarre_modal(1, i, j, i_mode) = Efb(1, i) : eFbarre_modal(2, i, j, i_mode) = Efb(2, i)
                    eFbarre_modal(3, i, j, i_mode) = Efb(3, i)
                    eFbarre_modal(4, i, j, i_mode) = Efb(4, i) : eFbarre_modal(5, i, j, i_mode) = Efb(5, i)
                    eFbarre_modal(6, i, j, i_mode) = Efb(6, i)
                Next
            Next
        Next
    End Sub
    Private Sub Matmul(ByVal AA(,) As Double, ByVal BB(,) As Double, ByRef CC(,) As Double)
        'Sous-programme de multiplication de matrice 3x3
        Dim i, j, k As Integer
        Dim sum As Double
        For i = 1 To 3
            For j = 1 To 3
                sum = 0
                For k = 1 To 3
                    sum = sum + AA(i, k) * BB(k, j)
                Next
                CC(i, j) = sum
            Next
        Next
    End Sub
    Private Sub Second_Membre(ByVal L() As Double, ByVal Rot(,) As Double, ByRef FB(,) As Double)
        'Calcul du vecteur force
        Dim i, ii, j, jd, jf, jj As Integer
        Dim forc As Double
        'mise  zero des vecteurs  FB
        For i = 1 To Total_element : For j = 1 To 6 : FB(j, i) = 0 : Next : Next
        'forces uniformement rparties sur la longueur de l'lment
        For j = 1 To Total_element      'balayage de l'ensemble des lments de la structure
            'force rpartie suivant X local  --> force //  la barre
            forc = mass_rep(1, j)
            If Appui(Ele(1, j)) = True And R_appui(1, Ele(1, j)) = True And R_appui(2, Ele(1, j)) = True And R_appui(6, Ele(1, j)) = True Then
                FB(4, j) = FB(4, j) - L(j) * forc
            ElseIf Appui(Ele(2, j)) = True And R_appui(1, Ele(2, j)) = True And R_appui(2, Ele(2, j)) = True And R_appui(6, Ele(2, j)) = True Then
                FB(1, j) = FB(1, j) - L(j) * forc
            Else
                FB(1, j) = FB(1, j) - L(j) * forc / 2
                FB(4, j) = FB(4, j) - L(j) * forc / 2
            End If
            'force rpartie suivant Y local --> force -  la barre
            forc = mass_rep(2, j)
            ' si noe 1 ou noe 2 libre alors 
            If Appui(Ele(1, j)) = True And R_appui(1, Ele(1, j)) = True And R_appui(2, Ele(1, j)) = True And R_appui(6, Ele(1, j)) = True Then
                FB(2, j) = FB(2, j) + 0
                FB(3, j) = FB(3, j) + 0
                FB(5, j) = FB(5, j) - L(j) * forc
                FB(6, j) = FB(6, j) + L(j) ^ 2 * forc / 2
            ElseIf Appui(Ele(2, j)) = True And R_appui(1, Ele(2, j)) = True And R_appui(2, Ele(2, j)) = True And R_appui(6, Ele(2, j)) = True Then
                FB(2, j) = FB(2, j) - L(j) * forc
                FB(3, j) = FB(3, j) - L(j) ^ 2 * forc / 2
                FB(5, j) = FB(5, j) + 0
                FB(6, j) = FB(6, j) + 0

                ' si noe 1 et noe 2 encastrs
            ElseIf Rel_ele(1, j) = False And Rel_ele(2, j) = False Then
                FB(2, j) = FB(2, j) - L(j) * forc / 2
                FB(3, j) = FB(3, j) - L(j) ^ 2 * forc / 12
                FB(5, j) = FB(5, j) - L(j) * forc / 2
                FB(6, j) = FB(6, j) + L(j) ^ 2 * forc / 12

                ' si noe 1 relax et noe 2 encastr 
            ElseIf Rel_ele(1, j) = True And Rel_ele(2, j) = False Then
                FB(2, j) = FB(2, j) - 3 * L(j) * forc / 8
                FB(3, j) = FB(3, j) + 0
                FB(5, j) = FB(5, j) - 5 * L(j) * forc / 8
                FB(6, j) = FB(6, j) + L(j) ^ 2 * forc / 8

                ' si noe 1 encastr et noe 2 relax alors 
            ElseIf Rel_ele(1, j) = False And Rel_ele(2, j) = True Then
                FB(2, j) = FB(2, j) - 5 * L(j) * forc / 8
                FB(3, j) = FB(3, j) - L(j) ^ 2 * forc / 8
                FB(5, j) = FB(5, j) - 3 * L(j) * forc / 8
                FB(6, j) = FB(6, j) + 0
            End If
        Next
    End Sub

    Private Sub Combinaison_quadratique_reponse_modale(ByVal eFbarre_modal(,,,) As Double, _
                                        ByVal FNodalAppui(,,,) As Double, ByRef R_Appui_quadra(,,) As Double)
        Dim i, j, j1, k, k1, Totaux_cas_de_charges, N_comb1, Maxx_mode, Neq As Integer
        Maxx_mode = Maxi(Max_mode, 3)
        Dim R_modal(Maxx_mode) As Boolean
        Dim Fr(Maxx_mode) As Integer
        Dim T(Maxx_mode, 2), qsi100 As Double
        Dim beta_ik, Roo, S(Total_noeud * 3, 3), S1(Total_noeud * 3, 3) As Double
        For j = 1 To 2 : For i = 1 To Max_mode(j) : R_modal(i) = True : Fr(i) = 0 : T(i, j) = 1 / Freq(i, j) : Next : Next
        For j = 1 To Total_noeud : For i = 1 To 3 : S(j, i) = 0 : Next : Next
        Neq = 3 * (Total_noeud - Total_appui)
        qsi100 = Qsi / 100 'qsi=amortissement modal
        ReDim R_Appui_quadra(3, Total_noeud, 2)
        'calcul des dplacements S(i,j) pour chaque direction de seisme (horizontal et vertical)
        For k1 = 1 To 2 'en espace 2D, k1= 1 -> suivant x, k1=2 -> suivant y
            'vrification de l'indpendance de chaque frquence pour chaque direction sismique
            For i = 1 To Max_mode(k1) - 1 'pour chaque mode
                k = 0
                For j = i + 1 To Max_mode(k1)
                    If T(j, k1) > 0.9 * T(i, k1) Then
                        'rponse modale non indpendante
                        R_modal(i) = False : k = k + 1
                    End If
                Next
                Fr(i) = k
            Next
            For i = 1 To Max_mode(k1)
                If R_modal(i) = True Then 'rponse modale indpendante
                    'dplacement
                    For j = 1 To 3 * Total_noeud : S(j, k1) = S(j, k1) + Depl_modal(j, k1, i) ^ 2 : Next
                    'forces sismique sur la barre
                    For k = 1 To Total_element
                        Effort_quadra(1, k, k1) = Effort_quadra(1, k, k1) + eFbarre_modal(1, k, k1, i) ^ 2 'effort normal sur la barre noeud 1
                        Effort_quadra(2, k, k1) = Effort_quadra(2, k, k1) + eFbarre_modal(2, k, k1, i) ^ 2 'effort tranchant sur la barre noeud 1
                        Effort_quadra(3, k, k1) = Effort_quadra(3, k, k1) + eFbarre_modal(3, k, k1, i) ^ 2 'moment de flexion sur la barre noeud 1
                        Effort_quadra(4, k, k1) = Effort_quadra(4, k, k1) + eFbarre_modal(4, k, k1, i) ^ 2 'effort normal sur la barre noeud 2
                        Effort_quadra(5, k, k1) = Effort_quadra(5, k, k1) + eFbarre_modal(5, k, k1, i) ^ 2 'effort tranchant sur la barre noeud 2
                        Effort_quadra(6, k, k1) = Effort_quadra(6, k, k1) + eFbarre_modal(6, k, k1, i) ^ 2 'moment de flexion sur la barre noeud 2
                    Next
                    'ractions d'appui dans le repre global
                    For k = 1 To Total_noeud
                        If Appui(k) = True Then
                            R_Appui_quadra(1, k, k1) = R_Appui_quadra(1, k, k1) + FNodalAppui(1, k, k1, i) ^ 2
                            R_Appui_quadra(2, k, k1) = R_Appui_quadra(2, k, k1) + FNodalAppui(2, k, k1, i) ^ 2
                            R_Appui_quadra(3, k, k1) = R_Appui_quadra(3, k, k1) + FNodalAppui(3, k, k1, i) ^ 2
                        End If
                    Next
                Else 'rponse modale non indpendante
                    '''''' provisoire
                    For k = 1 To Total_element
                        For j1 = 1 To 6
                            Effort_quadra(j1, k, k1) = Effort_quadra(j1, k, k1) + eFbarre_modal(j1, k, k1, i) ^ 2 'effort sur la barre noeud 1
                        Next
                    Next
                    'ractions d'appui dans le repre global
                    For k = 1 To Total_noeud
                        If Appui(k) = True Then
                            For j1 = 1 To 3
                                R_Appui_quadra(j1, k, k1) = R_Appui_quadra(j1, k, k1) + FNodalAppui(j1, k, k1, i) ^ 2
                            Next
                        End If
                    Next
                    'For k = i + 1 To i + Fr(i)
                    '    Roo = T(k, k1) / T(i, k1)
                    '    beta_ik = (8 * qsi100 ^ 2 * (1 + Roo) * Roo ^ 1.5) / (10000.0 * (1 - Roo ^ 2) ^ 2 + 4 * qsi100 ^ 2 * Roo * (1 + Roo) ^ 2)
                    '    'dplacement
                    '    For j = 1 To 3 * Total_noeud 'on ajoute le dplacement modal du noeud aux dplacements modaux prcdent
                    '        S(j, k1) = S(j, j1) + beta_ik * U(j, k1, i) * U(j, k1, k)
                    '        S1(j, k1) = S1(j, k1) + beta_ik * F_modal(j, k1, i) * F_modal(j, k1, k)
                    '    Next
                    'Next
                End If
            Next
        Next
        For j = 1 To 2 'suivant direction de l'excitation sismique
            For i = 1 To Total_noeud * 3
                Depl_quadra(i, j) = Sqrt(S(i, j)) 'dplacement quadratique
            Next
            For i = 1 To Total_element
                For k = 1 To 6
                    Effort_quadra(k, i, j) = Sqrt(Effort_quadra(k, i, j)) / q_cpt 'effort quadratique sur barre 
                Next
            Next
            For i = 1 To Total_noeud
                If Appui(i) = True Then
                    For k = 1 To 3
                        R_Appui_quadra(k, i, j) = Sqrt(R_Appui_quadra(k, i, j)) / q_cpt
                    Next
                End If
            Next
        Next
    End Sub
    Private Sub Combinaison_sismique_effort_deplacement(ByVal R_Appui_quadra(,,) As Double)
        Dim i, i1, j, k, N_cas, N_cas1, N_comb As Integer ', jd, jf 
        Dim F_sism1(6, Total_element, 2) As Double
        Dim D_sism2(3, Total_noeud), D_sism1(Total_noeud * 3, 2) As Double
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3)
        Dim R_Appui1(3, Total_noeud, N_cas1) As Double
        '1 -- Calcul des dplacements de la combinaison
        N_cas = Total_cas_de_charge(1) + Total_cas_de_charge(2) + 1
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3)
        For k = N_cas To N_cas1
            For j = 1 To 2 'suivant direction de l'excitation sismique, suivant X ou suivant Y pour un espace 2D
                For i = 1 To Total_noeud * 3
                    D_sism1(i, j) = Depl_quadra(i, j) * Exyz(j, k)
                Next
            Next
            For i = 1 To Total_noeud * 3 Step 3
                j = CInt(Fix((i - 1) / 3)) + 1 'n du noeud
                D_sism2(1, j) = D_sism1(i, 1) + D_sism1(i, 2)
                D_sism2(2, j) = D_sism1(i + 1, 1) + D_sism1(i + 1, 2)
                D_sism2(3, j) = D_sism1(i + 2, 1) + D_sism1(i + 2, 2)
            Next
            'dplacements des noeuds dans le repre global
            For i = 1 To Total_noeud
                Depl(k, i, 1) = Depl(k, i, 1) + D_sism2(1, i)
                Depl(k, i, 2) = Depl(k, i, 2) + D_sism2(2, i)
                Depl(k, i, 3) = Depl(k, i, 3) + D_sism2(3, i)
            Next
        Next
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3) + Total_cas_de_charge(4)
        N_cas = N_cas1 + Total_combinaison(1) + Total_combinaison(2) + 1
        N_cas1 = N_cas1 + Total_combinaison(1) + Total_combinaison(2) + Total_combinaison(3)
        N_comb = Total_combinaison(1) + Total_combinaison(2) + 1
        For k = N_cas To N_cas1 'boucle sur les combinaisons
            For i = 1 To dim_Cas_comb(N_comb) 'balayage du vecteur ensemble des cas pour la comb k
                For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
                    If Cas_comb(i, N_comb) <= Total_cas_de_charge(1) Then 'le N de cas n'est pas une charge sismique
                        Depl(k, j, 1) = Depl(k, j, 1) + Depl(Cas_comb(i, N_comb), j, 1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl(k, j, 2) = Depl(k, j, 2) + Depl(Cas_comb(i, N_comb), j, 2) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl(k, j, 3) = Depl(k, j, 3) + Depl(Cas_comb(i, N_comb), j, 3) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl1(k, j, 1) = Depl1(k, j, 1) + Depl(Cas_comb(i, N_comb), j, 1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl1(k, j, 2) = Depl1(k, j, 2) + Depl(Cas_comb(i, N_comb), j, 2) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl1(k, j, 3) = Depl1(k, j, 3) + Depl(Cas_comb(i, N_comb), j, 3) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                    Else
                        Depl(k, j, 1) = Depl(k, j, 1) + Depl(Cas_comb(i, N_comb), j, 1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl(k, j, 2) = Depl(k, j, 2) + Depl(Cas_comb(i, N_comb), j, 2) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl(k, j, 3) = Depl(k, j, 3) + Depl(Cas_comb(i, N_comb), j, 3) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl1(k, j, 1) = Depl1(k, j, 1) - Depl(Cas_comb(i, N_comb), j, 1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl1(k, j, 2) = Depl1(k, j, 2) - Depl(Cas_comb(i, N_comb), j, 2) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Depl1(k, j, 3) = Depl1(k, j, 3) - Depl(Cas_comb(i, N_comb), j, 3) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                    End If
                Next
            Next
            N_comb = N_comb + 1
        Next
        '2 -- Calcul des efforts sur la barre de la combinaison
        N_cas = Total_cas_de_charge(1) + Total_cas_de_charge(2) + 1
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3)
        For k = N_cas To N_cas1
            'application du coef sur la direction pour tous les efforts sismiques
            For j = 1 To 2 'suivant direction de l'excitation sismique, suivant X ou suivant Y pour un espace 2D
                For i = 1 To Total_element
                    For i1 = 1 To 6
                        F_sism1(i1, i, j) = Effort_quadra(i1, i, j) * Exyz(j, k)
                    Next
                Next
            Next
            'sommation pour tous les elements des forces sismiques
            For i = 1 To Total_element
                For i1 = 1 To 6
                    eFBarre(k, i, i1) = F_sism1(i1, i, 1) + F_sism1(i1, i, 2)
                Next
            Next
        Next
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3) + Total_cas_de_charge(4)
        N_cas = N_cas1 + Total_combinaison(1) + Total_combinaison(2) + 1
        N_cas1 = N_cas1 + Total_combinaison(1) + Total_combinaison(2) + Total_combinaison(3)
        N_comb = Total_combinaison(1) + Total_combinaison(2) + 1
        For k = N_cas To N_cas1 'boucle sur les combinaisons
            For i = 1 To dim_Cas_comb(N_comb) 'balayage du vecteur ensemble des cas pour la comb k
                If Cas_comb(i, N_comb) <= Total_cas_de_charge(1) Then 'le N de cas n'est pas une charge sismique
                    For j = 1 To Total_element      'balayage de l'ensemble des noeuds de la structure
                        For i1 = 1 To 6 'N,M et T pour noeuds 1 et 2 de la barre j
                            eFBarre(k, j, i1) = eFBarre(k, j, i1) + eFBarre(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                            eFBarre1(k, j, i1) = eFBarre1(k, j, i1) + eFBarre(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Next
                    Next
                Else
                    For j = 1 To Total_element      'balayage de l'ensemble des noeuds de la structure
                        For i1 = 1 To 6 'N,M et T pour noeuds 1 et 2 de la barre j
                            eFBarre(k, j, i1) = eFBarre(k, j, i1) + eFBarre(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                            eFBarre1(k, j, i1) = eFBarre1(k, j, i1) - eFBarre(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                        Next
                    Next
                End If
            Next
            N_comb = N_comb + 1
        Next
        '3 -- Calcul des ractions d'appui de la combinaison
        N_cas = Total_cas_de_charge(1) + Total_cas_de_charge(2) + 1
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3)
        For k = N_cas To N_cas1
            'application du coef sur la direction pour tous les efforts sismiques
            For j = 1 To 2 'suivant direction de l'excitation sismique, suivant X ou suivant Y pour un espace 2D
                For i = 1 To Total_noeud
                    If Appui(i) = True Then
                        For i1 = 1 To 3
                            R_Appui1(i1, i, j) = R_Appui_quadra(i1, i, j) * Exyz(j, k)
                        Next
                    End If
                Next
            Next
            'sommation pour tous les elements des forces sismiques
            For i = 1 To Total_noeud
                If Appui(i) = True Then
                    For i1 = 1 To 3
                        FNodal(k, i, i1) = R_Appui1(i1, i, 1) + R_Appui1(i1, i, 2)
                    Next
                End If
            Next
        Next
        N_cas1 = Total_cas_de_charge(1) + Total_cas_de_charge(2) + Total_cas_de_charge(3) + Total_cas_de_charge(4)
        N_cas = N_cas1 + Total_combinaison(1) + Total_combinaison(2) + 1
        N_cas1 = N_cas1 + Total_combinaison(1) + Total_combinaison(2) + Total_combinaison(3)
        N_comb = Total_combinaison(1) + Total_combinaison(2) + 1
        For k = N_cas To N_cas1 'boucle sur les combinaisons
            For i = 1 To dim_Cas_comb(N_comb)  'balayage du vecteur ensemble des cas pour la comb k
                If Cas_comb(i, N_comb) <= Total_cas_de_charge(1) Then  'le N de cas n'est pas une charge sismique
                    For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
                        If Appui(j) = True Then
                            For i1 = 1 To 3 'N,M et T pour noeuds 1 et 2 de la barre j
                                FNodal(k, j, i1) = FNodal(k, j, i1) + FNodal(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                                FNodal1(k, j, i1) = FNodal1(k, j, i1) + FNodal(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                            Next
                        End If
                    Next
                Else
                    For j = 1 To Total_noeud     'balayage de l'ensemble des noeuds de la structure
                        If Appui(j) = True Then
                            For i1 = 1 To 3 'N,M et T pour noeuds 1 et 2 de la barre j
                                Dim tata As Double
                                tata = FNodal(Cas_comb(i, N_comb), j, i1)
                                FNodal(k, j, i1) = FNodal(k, j, i1) + FNodal(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                                FNodal1(k, j, i1) = FNodal1(k, j, i1) - FNodal(Cas_comb(i, N_comb), j, i1) * Coef_pond(Cas_comb(i, N_comb), N_comb)
                            Next
                        End If
                    Next
                End If
            Next
            N_comb = N_comb + 1
        Next
    End Sub
    Private Function R(ByVal Ti As Double) As Double
        'R(T) est le spectre de l'accelration normalise
        Dim Tb, Tc, Td, Rm, Roo As Double
        Roo = (5 / Qsi) ^ 0.4

        Select Case Site_PS
            Case 0
                Tb = 0.15 : Tc = 0.3 : Td = 2.67 : Rm = 2.5
                Select Case Ti
                    Case Is < Tc
                        R = 2.5
                    Case Is < Td
                        R = 1.12 / Ti ^ (2 / 3)
                    Case Else
                        R = 2.99 / Ti ^ (5 / 3)
                End Select
            Case 1
                Tb = 0.2 : Tc = 0.4 : Td = 3.2 : Rm = 2.5
                Select Case Ti
                    Case Is < Tc
                        R = 2.5
                    Case Is < Td
                        R = 1.36 / Ti ^ (2 / 3)
                    Case Else
                        R = 4.34 / Ti ^ (5 / 3)
                End Select
            Case 2
                Tb = 0.3 : Tc = 0.6 : Td = 3.85 : Rm = 2.25
                Select Case Ti
                    Case Is < Tc
                        R = 2.25
                    Case Is < Td
                        R = 1.6 / Ti ^ (2 / 3)
                    Case Else
                        R = 6.16 / Ti ^ (5 / 3)
                End Select
            Case 3
                Tb = 0.45 : Tc = 0.9 : Td = 4.44 : Rm = 2
                Select Case Ti
                    Case Is < Tc
                        R = 2
                    Case Is < Td
                        R = 1.86 / Ti ^ (2 / 3)
                    Case Else
                        R = 8.29 / Ti ^ (5 / 3)
                End Select
        End Select
        R = aN * R * Roo * Tau
    End Function
    Private Function Maxi(ByVal A() As Integer, ByVal total As Integer) As Integer
        'calcul de la valeur maximale dans un tableau
        Dim i As Integer
        Maxi = 0
        For i = 1 To total
            If Maxi < A(i) Then Maxi = A(i)
        Next
    End Function
    Private Sub Determinant(ByVal n3 As Integer, ByVal akg(,) As Double, ByRef det1 As Double)
        Dim nm3, i, j, k, ip1 As Integer
        'phase 1: triangularisation de la matrice
        nm3 = n3 - 1
        det1 = 1
        For i = 1 To nm3
            'test si terme diagonal non nul
            If Abs(akg(i, i)) < 0.00000001 Then
                Stop
                Exit Sub
            End If
            det1 = det1 * akg(i, i)
            'calcul des termes sur ligne j
            ip1 = i + 1
            For j = ip1 To n3
                'boucle sur les termes de la ligne j
                For k = ip1 To n3
                    akg(j, k) = akg(j, k) - (akg(j, i) / akg(i, i)) * akg(i, k)
                Next
                akg(j, i) = 0
            Next
        Next
        Erase akg
    End Sub
    'Private Sub Bldyna()
    '    'Bloc de rsolution d'un problme dynamique instationnaire linaire
    '    'Mthode de Newmark implicite
    '    'Donnes: Nonsym  0=symtrie,  1=non symtrie
    '    '       tfcg, tfrg  niveau de charge
    '    'npas, dpas, dfg  nombre de pas, pas, niveau de charge par pas
    '    console.Write (Indice de non symtrie: ")
    '    Console.Read(nonsym)
    '    Call Exdyna()
    'End Sub
    'Private Sub Exdyna()
    '    'bloc d'execution d'un problme dynamique linaire par Newmark
    '    'Initialisation des vecteurs  0  T=0
    '    'Boucle sur les pas de temps
    '    'Lecture des paramtres: tfcg,tfrg, puis npas, dpas, dfg
    '    tfg = 1
    '    Console.Write("Niveau de sollicitation:" & vbCrLf & _
    '    "Coefficient de niveau de sollicitation concentre Tfcg: ")
    '    Console.Read(tfcg)
    '    Console.Read("Coefficient de niveau de sollicitation rpartie Tfrg: " & tfrg)
    '    Console.Read("Coefficient de niveau sollicitation dbut pas Tfg: " & tfg)
    '    If ifcg = 1 Then Call Maj(tfcg, 0, neq, vfcg, vfext0)
    '    If ifrg = 1 Then Call Maj(tfrg, 1, neq, vfrg, vfext0)
    '    '--Initialiser les paramtres et vecteurs
    '    ipas = 0
    '    tpas = 0
    '    Call Init(0, neq, vdlg0)
    '    Call Init(0, neq, vvitg)
    '    Call Init(0, neq, vaccg)
    '    Call Movecl(neq, kclim, vclim, vdlg0)
    '    '--lire les paramtres pour un ensemble de pas identiques
    '    Console.Read("Nombre de pas   Npas: " & npas)
    '    Console.Read("Accroissement de pas   Dpas: " & dpas)
    '    Console.Read("Accroissement de charge/pas   Dfg: " & dfg)
    '    Do While npas <> 0
    '        iktdyn = 1
    '        adpas = dpas * dpas / 4
    '        '--boucle sur les pas
    '        For ip = 1 To npas
    '            ipas = ipas + 1
    '            tpas = tpas + dpas
    '            tfg = tfg + dfg
    '            Call Maj(tfg * adpas, 0, neq, vfext0, vresg) 'vecteur vfext0 dans vresg : multiplier par dpas*dpas/4
    '            Call Asdyna() 'Assemblage des vke dans kg
    '            '--factoriser K=L*S: conditions limites par 1 sur la diagonale
    '            If iktdyn > 0 Then
    '                For j = 1 To neq
    '                    If kclim(j) > 0 Then
    '                        ii = (j - 1) * neq
    '                        For i = 1 To neq
    '                            vkg(ii + i) = 0
    '                            vkg(j + (i - 1) * neq) = 0
    '                        Next
    '                        vkg(ii + j) = 1
    '                        vresg(j) = 0
    '                    End If
    '                Next
    '                Call kfacmp(mp, mglob, neq, nonsym, vkg)
    '            End If
    '            Call solmp(mp, mglob, neq, nonsym, vkg, vresg) 'Rsoudre (L*S)*Vrg=Vrg
    '            '--mise  jour de la solution avec les conditions aux limites
    '            For i = 1 To neq
    '                vdlg(i) = vresg(i)
    '                If kclim(i) > 0 Then vdlg(i) = vclim(i)
    '            Next
    '            '--calcul de Vitg et acclration en T+Dpas
    '            Call Accvit(neq, dpas, vdlg0, vdlg, vitg, vacg)
    '            Call Move(neq, vdlg, vdlg0)
    '            Call Prtsol() ' impression de la solution vdlg
    '            iktdyn = 0 'retour nouveau pas, pas de factorisation
    '        Next ip
    '        Console.Read("Nombre de pas   Npas: " & npas)
    '        Console.Read("Accroissement de pas   Dpas: " & dpas)
    '        Console.Read("Accroissement de charge/pas   Dfg: " & dfg)
    '    Loop
    'End Sub
    'Private Sub Asdyna()
    '    'Calcul de Vke, Vme et Vfe
    '    'Assemblage de matrices 
    '    'M+K*Dpas*Dpas/4 pour dfinir Vkg si iktdyn=1
    '    'calcul du rsidu Vresg
    '    'R=Dpas*Dpas/4 (Fg=r) + M*(U+Dpas*Vit+Dpas*Dpas/4  Vacc)
    '    'Vresg est dj avec>> Dpas*Dpas/4*Vfg
    '    '--Boucle sur les lments
    '    adpas = dpas * dpas / 4
    '    If iktdyn = 1 Then Call Init(0, neq * neq, vkg)
    '    For iel = 1 To nelt
    '        itype = ktpel(iel) 'type d'lment
    '        Call Elmlib(icpar, vcore, vprne, vpree, vdle, vke, vfe) 'Initialiser les paramtres de l'lment
    '        '--Cration des tables lmentaires: Konec  Vcore  Vprel
    '        Call tkone(nnel, iel, konec, kdlnc, kone, kdle)
    '        Call tvcore(nnel, ndim, vcor, kone, vcore)
    '        Call tvpree(nprel, iel, kprel, vprel, vpree)
    '        Call Elmlib(icvke, vcore, vprne, vpree, vdle, vke, vfe) 'calcul de Vke
    '        Call Elmlib(icvme, vcore, vprne, vpree, vdle, vme, vfe) 'calcul de Vme
    '        '--Etape rsidu
    '        Call dlelm(idle, kdle, vdlg0, vdle)
    '        Call dlelm(idle, kdle, vitg, vite)
    '        Call dlelm(idle, kdle, vaccg, vacce)
    '        '--Vresg=Adpas*Vresg+M*U+Dpas*Vitg+Adpas*Accell
    '        For i = 1 To idle
    '            vdle(i) = vdle(i) + dpas * vite(i) + adpas * vacce(i)
    '        Next
    '        Call Matvec(idle, idle, vme, vdle, vfe)
    '        Call Asfe(idle, kdle, vfe, vresg)
    '        '--Etape construire M+K*dpas*dpas/4
    '        If iktdyn = 1 Then
    '            For i = 1 To ike
    '                vke(i) = vme(i) + adpas * vke(i)
    '            Next
    '            Call Aske(neq, idle, kdle, vke, vkg)
    '        End If
    '    Next
    'End Sub
    'Private Sub Accvit(ByVal neq, ByVal Dpas, ByVal VDlg0, ByVal Vdlg, ByVal Vitg, ByVal Vaccg)
    '    'Calcul des vecteurs vitesse et acclration
    '    '  Formule de Newmark
    '    'Entre: neq   nbre total de dd
    '    '        vdlg   dplacement en T+Dpas;   Vdlg0: dplacement en T
    '    '        Vitg   vitesse en T             Vaccg: Acclration en T
    '    'Sortie: Vitg   vitesse en T+Dpas        Vaccg: Acclration en T+Dpas
    '    'Attention Vitg et Vaccg sont modifis
    '    ad2 = 4 / Dpas ^ 2
    '    ad1 = 4 / Dpas
    '    For i = 1 To neq
    '        Vaccg(i) = ad2 * (Vdlg(i) - VDlg0(i)) - ad1 * Vitg(i) - Vaccg(i)
    '        Vitg(i) = -Vitg(i) + (Vdlg(i) - VDlg0(i)) * 2 / pas
    '    Next
    'End Sub
    Private Sub Poubelle()

        'Private Sub C_Limit(ByRef AK(,) As Double)
        '    'Prise en compte des conditions d'appui et des relaxations
        '    Dim i, ii, i3, j, jj As Integer
        '    For i = 1 To Total_noeud
        '        If Appui(i) = True Then 'test si noeud est un appui
        '            i3 = (i - 1) * 3
        '            'Conditions aux limites modifies suivant les ddl Bloques
        '            'test pour tenir compte que les barres sont initialises encastres dans une ossature. Or, une barre seule sur 
        '            'un appui rotul (articulation libre) ne produit pas de moment  son extrmit. Par contre, plusieurs barres
        '            'concourrantes sur un noeuds peuvent tre encastres entre elles et articules vis  vis de l'appui ce qui est
        '            'le cas pour des poutres continues. Si on ne veut pas de moment en bout de barre, il sufira alors de relacher 
        '            'le noeud (ce qui relaxera toutes les extrmites de barres aboutissant  ce noeud) ou alors de dclarer un 
        '            'relachement sur cette barre pour le noeud concern - Voir notice pour l'entre des donnes

        '            '--> ddl suivant X et Y bloqus, rotation libre ou lastiquement libre
        '            If (R_appui(1, i) = False And R_appui(2, i) = False And R_appui(6, i) = True) _
        '            Or (R_appui(7, i) = False And R_appui(8, i) = False And R_appui(12, i)) Then  'le noeud est articule
        '                'mise  zro ligne et colonne sur Kg
        '                For ii = 1 To 2
        '                    For jj = 1 To 3 * Total_noeud
        '                        AK(i3 + ii, jj) = 0
        '                        AK(jj, i3 + ii) = 0
        '                    Next
        '                Next
        '                Select Case Type_probleme
        '                    Case 1 'Treillis plan
        '                        For ii = 1 To 3
        '                            AK(i3 + ii, i3 + ii) = 0
        '                        Next
        '                    Case 2 'portique plan
        '                        Select Case n_barre_appui(i)
        '                            Case 1 '1 barre sur l'appui
        '                                For ii = 1 To 3
        '                                    AK(i3 + ii, i3 + ii) = 0
        '                                Next

        '                            Case Is > 1
        '                                'pas de relaxation du noeud sauf si cela est indiqu de faon explicite
        '                                For ii = 1 To 2
        '                                    AK(i3 + ii, i3 + ii) = 0
        '                                Next

        '                        End Select
        '                End Select

        '                '--> ddl suivant X et Y bloqus, rotation bloque
        '            ElseIf R_appui(1, i) = False And R_appui(2, i) = False And R_appui(6, i) = False Then  'le noeud est encastre
        '                'mise  zro ligne et colonne sur AK
        '                For ii = 1 To 3
        '                    For jj = 1 To 3 * Total_noeud
        '                        AK(i3 + ii, jj) = 0
        '                        AK(jj, i3 + ii) = 0
        '                    Next
        '                Next
        '                'mise d'un 1 sur la diagonale
        '                For ii = 1 To 3
        '                    AK(i3 + ii, i3 + ii) = 1 '0
        '                Next
        '                '--> le noeud est un appui rouleau ou appui lastique suivant X et bloqu suivant Y
        '            ElseIf (R_appui(1, i) = True And R_appui(2, i) = False) _
        '            Or (R_appui(7, i) = True And R_appui(8, i) = False) Then
        '                'mise  zro ligne et colonne sur AK mais on conserve la ligne et la colonne correspondant  dx pour pouvoir
        '                'calculer le dplacement de l'appui suivant X.
        '                For ii = 2 To 3
        '                    For jj = 1 To 3 * Total_noeud
        '                        AK(i3 + ii, jj) = 0
        '                        AK(jj, i3 + ii) = 0
        '                    Next
        '                Next
        '                'mise d'un 1 sur la diagonale
        '                For ii = 2 To 3
        '                    AK(i3 + ii, i3 + ii) = 1 '0
        '                Next

        '                '--> le noeud est un appui rouleau ou appui lastique suivant Y et bloqu suivant x
        '            ElseIf (R_appui(1, i) = False And R_appui(2, i) = True) _
        '            Or (R_appui(7, i) = False And R_appui(8, i) = True) Then
        '                For jj = 1 To 3 * Total_noeud
        '                    AK(i3 + 1, jj) = 0 : AK(i3 + 3, jj) = 0
        '                    AK(jj, i3 + 1) = 0 : AK(jj, i3 + 3) = 0
        '                Next
        '                'mise d'un 1 sur la diagonale
        '                AK(i3 + 1, i3 + 1) = 1 : AK(i3 + 3, i3 + 3) = 1 '0
        '            End If

        '        Else
        '            Select Case Type_probleme
        '                Case 1 'Treillis plan
        '                    'tous les noeuds sont relachs (articulation)
        '                    i3 = i * 3
        '                    AK(i3, i3) = 1 'mise d'un 1 sur la diagonale
        '                Case 2 'Portique plan

        '            End Select

        '        End If
        '    Next

        '    '--> Module de dbogage:
        '    '''affichage dans le fichier de dtails du calcul de la matrice globale AK
        '    'Dim F_AK(3 * Total_noeud, 3 * Total_noeud) As String
        '    'msgg = msgg & "Matrice globale de rigidit AK:" & vbCrLf
        '    'For i = 1 To 3 * Total_noeud
        '    '    For j = 1 To 3 * Total_noeud
        '    '        F_AK(i, j) = Format(AK(i, j), "###0.0")
        '    '        msgg = msgg & "  " & F_AK(i, j)
        '    '    Next
        '    '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        '    'Next
        '    'msgg = msgg & vbCrLf

        'End Sub

        'Dim i, i_mode, j, k As Integer
        'Dim omega(DynMode), Up(3 * Total_noeud), Up1(3 * Total_noeud) As Double
        'For j = 1 To 2 'Pour chaque direction du seisme (suivant X->j=1, suivant Y->j=2, suivant rotation autour de Z->j=3)
        '    'calcul des dplacements pour chaque mode et chaque direction du seisme
        '    For i_mode = 1 To Max_mode(j) 'pour chaque frquence pertinente dans la direction j
        '        omega(i_mode) = (2 * PI / T(i_mode)) ^ 2 'pulsation leve au carr
        '        k = 0
        '        For i = 1 To Total_noeud * 3   'pour chaque noeud en espace 2D, 3 dplacements x,y et rot  
        '            k = k + 1
        '            U(i, j, i_mode) = Def_dyn(k, i_mode) * P_mode(i_mode, j) * R(T(i_mode)) / omega(i_mode)

        '            Up(k) = U(i, j, i_mode)
        '        Next
        '    Next
        '    'calcul des efforts nodaux modaux dans le repre global pour chaque mode et chaque direction du seisme
        '    For i_mode = 1 To Max_mode(j) 'pour chaque frquence pertinente dans la direction j
        '        For i = 1 To Total_noeud * 3
        '            Up1(i) = 0
        '            For k = 1 To Total_noeud * 3
        '                Up1(i) = Up1(i) + Kg(i, k) * Up(k)
        '            Next
        '        Next
        '        k = 0
        '        For i = 1 To Total_noeud * 3
        '            F_modal(i, j, i_mode) = 0
        '            k = k + 1
        '            F_modal(i, j, i_mode) = F_modal(i, j, i_mode) + Up1(k)
        '        Next
        '    Next
        'Next


        ''poids de la structure        
        'Mass_struct(j) = Poids_structure 'dtermination de Mass_struct(j) pour les 3 directions
        'Select Case j
        '    Case 1 'horizontal
        '        Call Masse_Participante(L, N_cas_Horizontal(1), mass_ajout)
        '    Case 2 'vertical
        '        Call Masse_Participante(L, N_cas_Vertical(1), mass_ajout)
        '    Case 3
        '        mass_ajout = 0
        'End Select
        'Mass_struct(j) = Mass_struct(j) + mass_ajout

        'For i = 1 To neq
        '    A(i) = 0
        '    For i1 = 1 To neq
        '        A(i) = A(i) + Mg(i, i1) * Vxyz(i1)
        '    Next
        'Next
        'Mass_struct(j) = Vxyz(1) * A(1)

        'Select Case Type_probleme
        '    Case 1 'treillis plan
        '        If DynMode > Total_noeud Then DynMode = Total_noeud
        '    Case 2 'portique plan
        '        If DynMode > 3 * Total_noeud Then DynMode = 3 * Total_noeud
        'End Select
        'Decale = 0.01 'Decale =dcalage des valeurs propres (K-decale*M)

        'For i_mode = 1 To DynMode 'calcul des Masse gnralis des modes 1  dynmode
        '    'calcul de la Masse gnralis pour le mode i: t{Dj}*[Mg] *{Dj}
        '    For i = 1 To neq
        '        A(i) = 0
        '        For j = 1 To neq
        '            A(i) = A(i) + Mg(i, j) * Def_dyn(j, i_mode)
        '        Next
        '    Next
        '    Mgi(i_mode) = Def_dyn(1, i_mode) * A(1)
        '    For i = 2 To neq
        '        Mgi(i_mode) = Mgi(i_mode) + Def_dyn(i, i_mode) * A(i)
        '    Next
        'Next
    End Sub

    Private Sub Vpinv(ByRef structure_OK As Boolean, ByVal neq As Integer, ByVal kg(,) As Double, _
                      ByVal Mg(,) As Double, ByRef T() As Double)
        'neq = dimension de la matrice Kg et Mg
        'Kg = Matrice de rigidit
        'Mg = matrice masse
        'Calcul des plus petites valeurs et vecteurs propres
        'Mthode d'itration inverse avec orthogonalisation de Gram-shmit
        'Entre: Vkg    triangularise avec dcalage
        '        Mg    Matrice masse assemble
        '        dynmode  nombre de valeurs propres cherches
        'Sortie: Vecp   vecteur propre (neq = 3 ou 6 x totalnoeud suivant 2D ou 3D, mode 1  n = dynmode)
        '        valp   valeurs propres(dynmode)= pulsation de la structure
        Dim Dynmode As Integer = 3 'provisoire
        Dim dyniter As Integer = 15
        Dim DynTol As Double = 0.001
        Dim a, c(Dynmode), C1, lamdo, lamda, cF, dyntol1, CjUj(neq), Ui(neq) As Double '
        Dim i, i1, i3, iter, ivalp, j, j1, j3 As Integer
        i1 = 3 * (Total_noeud - Total_appui) : neq = i1
        Dim Vmy(neq), Valp(Dynmode), vecp(neq, Dynmode), Vx(neq) As Double
        Dim Vkg(i1, i1), Vmg(i1, i1) As Double
        Dim msg As String
        i1 = 0 : j1 = 0
        For i = 1 To 3 * Total_noeud 'ligne
            i3 = CInt(Int((i + 2) / 3)) : i1 = i1 + 1
            If Appui(i3) = False Then 'test si noeud n'est pas un appui
                j1 = 0
                For j = 1 To 3 * Total_noeud 'colonne la matrice K est symtrique, on ne rentre que le triangle suprieur, colonne par colonne
                    j3 = CInt(Int((j + 2) / 3)) : j1 = j1 + 1
                    If Appui(j3) = False Then 'test si noeud n'est pas un appui
                        Vkg(i1, j1) = kg(i, j) : Vmg(i1, j1) = Mg(i, j)
                    Else
                        j1 = j1 - 1
                    End If
                Next
            Else
                i1 = i1 - 1
            End If
        Next
        '--calcul de dynmode valeurs propres et vecteurs propres
        'initialisation des donnes
        lamdo = 0 : ivalp = 1
        For i = 1 To Dynmode : Valp(i) = 0 : Next
        For j = 1 To neq : CjUj(j) = 0 : For i = 1 To Dynmode : vecp(j, i) = 0 : Next : Next
        '--calcul Vec initial
        For i = 1 To neq : Vx(i) = 1 : Next
        'calcul matriciel Mg * Vx = Vmy
        For i = 1 To neq : Vmy(i) = 0 : For j = 1 To neq : Vmy(i) = Vmy(i) + Vmg(i, j) * Vx(j) : Next : Next
        Do
            If ivalp > 1 Then
                '--calcul {Ui+1}={Ui+1}-C1*{U1} et C1=<U1>*[M]*{Ui+1} pour les modes 2 et suprieurs
                'For i = 1 To neq : Vmy(i) = 0 : For j = 1 To neq : Vmy(i) = Vmy(i) + Vmg(i, j) * Ui(j) : Next : Next
                'c(ivalp - 1) = 0 : For i = 1 To neq : c(ivalp - 1) = c(ivalp - 1) + vecp(i, ivalp - 1) * Vmy(i) : Next i
                'For i = 1 To neq
                '    CjUj(i) = CjUj(i) + c(ivalp - 1) * vecp(i, ivalp - 1) '
                '    Vx(i) = Ui(i) - CjUj(i) '--calcul de Vx initial pour les modes 2 et suprieurs
                'Next
                'For i = 1 To neq
                '    Vmy(i) = 0
                '    For j = 1 To neq
                '        Vmy(i) = Vmy(i) + Vmg(i, j) * Vx(j) '--calcul de Vmy initial pour les modes 2 et suprieurs
                '    Next
                'Next
                For i = 1 To neq : Vmy(i) = 0 : Next 'initialisation  0
                For i = 1 To neq : For j = 1 To neq : Vmy(i) = Vmy(i) + Vmg(i, j) * Ui(j) : Next : Next 'calcul de [M]*{Ui+1}
                C1 = 0 : For i = 1 To neq : C1 = C1 + vecp(i, ivalp - 1) * Vmy(i) : Next i ' calcul de C1=<U1>*[M]*{Ui+1}
                '--calcul Vec initial
                For i = 1 To neq : Vx(i) = 1 : Next
                'calcul matriciel Mg * Vx = Vmy
                For i = 1 To neq : Vmy(i) = 0 : For j = 1 To neq : Vmy(i) = Vmy(i) + Vmg(i, j) * Vx(j) : Next : Next
                '--boucle d'itration
                For iter = 1 To dyniter
                    '--rsolution Kg*Vx=Vmy : Vx=K(-1)*M*Y0
                    Call Resol(structure_OK, neq, Vkg, Vmy, Vx) 'Vx={Ui+1}
                    For i = 1 To neq
                        Vx(i) = Vx(i) - C1 * vecp(i, ivalp - 1) '
                    Next
                    '--quotient de Rayleigh soit: (cm=vx*vmy) / (a=vx*mg*vx)
                    cF = 0 : For i = 1 To neq : cF = cF + Vx(i) * Vmy(i) : Next i
                    'calcul de {F}
                    For i = 1 To neq : Vmy(i) = 0 : For j = 1 To neq : Vmy(i) = Vmy(i) + Vmg(i, j) * Vx(j) : Next : Next
                    'calcul de a
                    a = 0 : For i = 1 To neq : a = a + Vx(i) * Vmy(i) : Next i
                    '--calcul de la valeur propre
                    If a > 0 Then
                        lamda = cF / a ' = quotient de Rayleigh
                        'vecteur propre et valeur propre pour ivalp
                        Valp(ivalp) = lamda '+ Decale
                        '--mise  jour vy0: M-Normalis
                        For j = 1 To neq : Vmy(j) = Vmy(j) / Sqrt(a) : Next
                    Else
                        Stop
                    End If
                    '--Test de convergence et affectation valeur propre et vecteur propre
                    dyntol1 = Abs((lamda - lamdo) / lamda)
                    If dyntol1 <= DynTol Then
                        'vecteur propre et valeur propre pour ivalp
                        Valp(ivalp) = lamda '+ Decale
                        For i = 1 To neq
                            vecp(i, ivalp) = Vx(i) / Sqrt(a)
                            Ui(i) = Vx(i)
                        Next
                        ivalp = ivalp + 1
                        'lamdo = lamda
                        Exit For
                    End If
                    lamdo = lamda
                Next

            Else
                '--boucle d'itration
                For iter = 1 To dyniter
                    '--rsolution Kg*Vx=Vmy : Vx=K(-1)*M*Y0
                    Call Resol(structure_OK, neq, Vkg, Vmy, Vx)
                    '--quotient de Rayleigh soit: (cm=vx*vmy) / (a=vx*mg*vx)
                    cF = 0 : For i = 1 To neq : cF = cF + Vx(i) * Vmy(i) : Next i
                    For i = 1 To neq : Vmy(i) = 0 : For j = 1 To neq : Vmy(i) = Vmy(i) + Vmg(i, j) * Vx(j) : Next : Next
                    a = 0 : For i = 1 To neq : a = a + Vx(i) * Vmy(i) : Next i
                    '--calcul de la valeur propre
                    If a > 0 Then
                        lamda = cF / a ' = quotient de Rayleigh
                        '--mise  jour vy0: M-Normalis
                        For j = 1 To neq : Vmy(j) = Vmy(j) / Sqrt(a) : Next
                    Else
                        Stop
                    End If
                    '--Test de convergence et affectation valeur propre et vecteur propre
                    dyntol1 = Abs((lamda - lamdo) / lamda)
                    If dyntol1 <= DynTol Then
                        'vecteur propre et valeur propre pour ivalp
                        Valp(ivalp) = lamda '+ Decale
                        For i = 1 To neq
                            vecp(i, ivalp) = Vx(i) / Sqrt(a)
                            Ui(i) = Vx(i)
                        Next
                        ivalp = ivalp + 1
                        'lamdo = lamda
                        Exit For
                    End If
                    lamdo = lamda
                Next
            End If
        Loop While ivalp <= Dynmode
        'affectation des priodes propres de vibration(= frquence) et valeurs propres (= dplacements) de la structure
        Dim FF As Double 'Dim T, FF As Double
        'T = (2 * PI) / Sqrt(Valp(1)) : FF = 1 / T
        For i = 1 To Dynmode : T(i) = (2 * PI) / Sqrt(Valp(i)) : FF = 1 / T(i) : Next
        'For j = 1 To neq : For i = 1 To Dynmode : Def_dyn(j, i) = vecp(j, i) : Next : Next
        ''verification calcul matriciel
        'Dim AAA(neq) As Double
        'For i = 1 To neq : AAA(i) = 0 : For j = 1 To neq : AAA(i) = AAA(i) + kg(i, j) * Vx(j) : Next : Next
        'For i = 1 To neq : Vx(i) = Vmy(i) : Next 'Call Move(neq, Vmy, vx)
        ' Call solmp(neq, VKg, Vx)

    End Sub
    Private Sub Resol(ByRef structure_OK As Boolean, ByVal neq As Integer, ByVal Kg(,) As Double, ByVal F() As Double, ByRef U() As Double)
        'Rsolution du systme linaire d'quation [K]*{U}={F}
        Dim i, j As Integer
        Dim akg(3 * Total_noeud, 3 * Total_noeud) As Double
        ''affectation de tableaux
        For i = 1 To neq
            For j = 1 To neq
                akg(i, j) = Kg(i, j)
            Next
        Next

        Call Gauss_Pivot_Max(neq, akg, F, U, structure_OK)
        If structure_OK = False Then Exit Sub
        Erase akg
    End Sub
    Private Sub Gauss_Pivot_Max(ByVal n As Integer, ByVal Akg(,) As Double, ByVal F() As Double, ByRef U() As Double, _
                                ByRef structure_OK As Boolean)
        ' RESOLUTION DE SYSTEME LINEAIRE par la METHODE DE LA TRIANGULATION DE GAUSS AVEC RECHERCHE DU PIVOT MAXIMUM
        ' "PREMIER MEMBRE DU SYSTEME : MATRICE A"
        '"SECOND  MEMBRE DU SYSTEME : MATRICE B"
        'matrice de dimension nxn
        Dim msg As String
        Dim i, j, L, Lmax, k, ns As Integer
        Dim m, S, m1, A(n, n), B(n) As Double
        For i = 1 To n
            B(i) = F(i)
            For j = 1 To n
                A(i, j) = Akg(i, j)
            Next
        Next
        ns = n
        For k = 1 To ns - 1
            m = A(k, k)
            Lmax = k
            For L = k + 1 To ns
                If Abs(A(L, k)) >= Abs(m) Then
                    m = A(L, k)
                    Lmax = L
                End If
            Next L
            If Abs(m) < 9.999999E-21 Then 'pivot nul
                'msg = "Cas n" & CStr(i_pas) & " - calcul du terme diagonal n" & CStr(k) & vbCrLf & _
                '                " matrice de rigidit singulire"
                msg = " matrice de rigidit singulire"
                MsgBox(msg, style, title)
                structure_OK = False
                Exit Sub
            End If
            If Lmax <> k Then
                If Abs(A(Lmax, k)) >= 10 * Abs(A(k, k)) Then
                    For L = k To ns
                        m1 = A(k, L)
                        A(k, L) = A(Lmax, L)
                        A(Lmax, L) = m1
                    Next
                    m1 = B(k)
                    B(k) = B(Lmax)
                    B(Lmax) = m1
                End If
            End If
            For i = k + 1 To ns
                B(i) = B(i) - A(i, k) / A(k, k) * B(k)
                For j = k + 1 To ns
                    A(i, j) = A(i, j) - A(i, k) / A(k, k) * A(k, j)
                Next j
            Next i
        Next k
        '
        'CALCUL DES SOLUTIONS
        '
        If Abs(A(ns, ns)) < 9.999999E-21 Then 'pivot nul
            'msg = "Cas n" & CStr(i_pas) & " - calcul du dernier terme diagonal" & vbCrLf & _
            '            " matrice de rigidit singulire"
            msg = " matrice de rigidit singulire"
            MsgBox(msg, style, title)
            structure_OK = False
            Exit Sub
        End If
        U(ns) = B(ns) / A(ns, ns)
        For i = ns - 1 To 1 Step -1
            S = 0
            For k = i + 1 To ns
                S = S + A(i, k) * U(k)
            Next k
            U(i) = (B(i) - S) / A(i, i)
        Next i
        Erase A, B
    End Sub
End Module
