Imports System.Math
Imports System.IO
Module Lineaire_2D
    'Variables publiques  l'ensemble du module
    Dim title As String = "STRUCTURE : module de calcul Analyse Lineaire 2D"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly

    Public Sub Analyse_Lineaire_2D(ByRef structure_OK As Boolean, ByRef Kg(,) As Double, ByRef kg0(,) As Double, _
                                    ByRef L() As Double, ByRef Rot(,) As Double, ByVal j1 As Integer, ByVal j2 As Integer)
        'Variables : 
        ' j1 et j2 sont les indices pour les cas de charges non linaires
        ' Kg = Matrice de rigidit globale de la structure
        ' kg0(9,total_element ) = matrice de rigidit locale infrieure droite pour tous les lments
        '--> Dclarations de variables:
        'nouvelles variables
        Dim i As Integer
        Dim FN(3, Total_noeud) As Double
        Dim FB(6, Total_element), Dp(3, Total_noeud) As Double
        Dim Sr(Total_element) As Double
        Dim Fapp(3, Total_noeud) As Double
        Call Matrice_Rigidite_2D(Kg, L, Rot, kg0, Sr, structure_OK)
        Call Appui_elastique(Kg)
        Call C_Limit_Kg(Kg, Fapp, structure_OK)
        If structure_OK = False Then Exit Sub
        'dtermination des ractions d'appui, des efforts sur les barres et des dplacements pour chaque cas de charge
        For i = Total_cas_de_charge(j1) + 1 To Total_cas_de_charge(j1) + Total_cas_de_charge(j2)
            Select Case Type_probleme
                Case 1 'treillis
                    Call Second_Membre_Treillis(L, FN, i)
                Case 2 'portique
                    If Def_Tranchant = True Then
                        'calcul du vecteur force avec prise en compte de l'effort tranchant
                        Call Second_Membre_Portique_avec_G(L, Rot, FN, FB, i, Sr)
                    Else
                        'calcul du vecteur force sans prise en compte de l'effort tranchant
                        Call Second_Membre_Portique_sans_G(L, Rot, FN, FB, i)
                    End If
            End Select
            Call Resol_2D(FN, Fapp, Kg, Dp, structure_OK, i) : If structure_OK = False Then Exit Sub
            Call Resultat(Dp, Rot, L, kg0, FB, i)
        Next i
        'Sommation des lments prcdements dtermins (efforts nodaux, dplacements,efforts sur les lments) suivant les valeurs de la combinaison
        Call Combinaison()
        Erase FN, FB, Dp, Sr, Fapp
    End Sub
    Public Sub Matrice_Rigidite_2D(ByRef Kg(,) As Double, ByRef L() As Double, ByRef Rot(,) As Double, ByRef Kg0(,) As Double, _
                                    ByRef Sr() As Double, ByRef structure_OK As Boolean)
        Dim i, j, jD, jF, k, k11 As Integer
        Dim a, alpha, b0, d1, d2 As Double
        Dim k0(3, 3), Td(3, 3), Tg(3, 3), R(3, 3), Rt(3, 3) As Double
        Dim k1(3, 3), l0(3, 3), l1(3, 3), BB(3, 3) As Double
        Dim msg As String
        'Matrice de rigidit globale de la structure = Kg
        'Variables : kg0(9,total_element ) = matrice de rigidit locale infrieure droite pour tous les lments
        '            k0(3, 3) = matrice de rigidit suprieure gauche
        '            k1(3, 3) = matrice de rigidit infrieure droite
        '            l0(3, 3) = matrice de rigidit infrieure gauche
        '            l1(3, 3) = matrice de rigidit suprieure droite
        '            Td(3,3) = matrice de transformation droite
        '            Tg(3,3) = matrice de transformation gauche
        '            R(3, 3) = matrice de rotation
        '            Rt(3, 3) = transpos de la matrice de rotation

        'composition de toutes les matrices lmentaires, lment par lment
        '1- construction de la matrice de rigidit locale kg0
        For i = 1 To Total_element
            a = X_noe(Ele(2, i)) - X_noe(Ele(1, i))
            b0 = Y_noe(Ele(2, i)) - Y_noe(Ele(1, i))
            L(i) = Sqrt(a ^ 2 + b0 ^ 2) 'longueur de l'lment
            If Def_Tranchant = True And Type_probleme = 2 Then Call Section_reduite(i, Sr(i)) 'dtermination de la section rduite de l'lment
            d1 = Acos(a / L(i))
            d2 = Asin(b0 / L(i))
            'l'angle alpha doit tre compris entre 0 et 2pi ce qui oblige  la gymnastique ci-dessous sinon
            'l'angle allait tre compris entre 0 et pi ou pi/2 et -pi/2 suivant si le calcul tait fait en
            'cosinus ou sinus
            If a >= 0 And b0 >= 0 Then  'quadrant 1
                alpha = d1
            ElseIf a <= 0 And b0 >= 0 Then 'quadrant 2
                alpha = d1
            ElseIf a <= 0 And b0 <= 0 Then 'quadrant 3
                alpha = PI - d2  'd2 est ngatif
            ElseIf a >= 0 And b0 <= 0 Then 'quadrant 4
                alpha = 2 * PI + d2
            End If
            If Type_profile(i) = 4 Then
                'si le profil est une cornire, ce dernier ne reprend que les efforts normaux
                Call K_2D_tout_relaxe(i, L(i), Kg0)

                ' si element a tous ses noeuds encastrs alors Call K_2D_tout_encastre avec I constant ou variable
            ElseIf Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                If Inert_Variable(i) = True Then
                    Select Case Type_profile(i)
                        Case 1 'profil en I
                            If H(1, i) <> H(2, i) Then 'inertie variable sur la hauteur du profil
                                Call K_2D_tout_encastre_I_variable(i, L(i), Kg0, H(1, i), H(2, i), ea(i), es(i), B(i))
                            Else
                                msg = "Caractristiques de l'lment poutre n" & Str(i) & " en dehors du domaine" & vbCrLf & _
                                "de modlisation du logiciel"
                                MsgBox(msg, style, title)
                                structure_OK = False
                                Exit Sub
                            End If
                        Case 2 'profil en tube rond
                            msg = "Caractristiques de l'lment poutre n" & Str(i) & " en dehors du domaine" & vbCrLf & _
                                                           "de modlisation du logiciel"
                            MsgBox(msg, style, title)
                            structure_OK = False
                            Exit Sub
                        Case 3 'profil en tube rectangulaire
                            If H(1, i) <> H(2, i) Then 'inertie variable sur la hauteur du profil
                                Call K_2D_tout_encastre_Rectangle_variable(i, L(i), Kg0, H(1, i), H(2, i), B(i))
                            Else
                                msg = "Caractristiques de l'lment poutre n" & Str(i) & " en dehors du domaine" & vbCrLf & _
                                "de modlisation du logiciel"
                                MsgBox(msg, style, title)
                                structure_OK = False
                                Exit Sub
                            End If
                    End Select
                Else
                    If Def_Tranchant = False Then
                        'calcul sans prise en compte de la dformation de l'effort tranchant
                        Call K_2D_tout_encastre(i, L(i), Kg0)
                    Else
                        Call K_2D_tout_encastre_avec_G(i, L(i), Sr(i), Kg0)
                    End If
                End If

                ' si noe 1 ou noe 2 libre (poutre console)alors 
            ElseIf Appui(Ele(1, i)) = True And R_appui(1, Ele(1, i)) = True And R_appui(2, Ele(1, i)) = True And R_appui(6, Ele(1, i)) = True Then
                Call K_2D_tout_encastre(i, L(i), Kg0) 'Call K_2D_gauche_libre(i, L(i), Kg0)
            ElseIf Appui(Ele(2, i)) = True And R_appui(1, Ele(2, i)) = True And R_appui(2, Ele(2, i)) = True And R_appui(6, Ele(2, i)) = True Then
                Call K_2D_tout_encastre(i, L(i), Kg0) ' Call K_2D_droit_libre(i, L(i), Kg0)

                ' si noe 1 relax et noe 2 encastr 
            ElseIf Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
                If Def_Tranchant = False Then
                    'calcul sans prise en compte de la dformation de l'effort tranchant
                    Call K_2D_gauche_relaxe(i, L(i), Kg0)
                Else
                    Call K_2D_gauche_relaxe_avec_G(i, L(i), Sr(i), Kg0)
                End If

                ' si noe 1 encastr et noe 2 relax 
            ElseIf Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
                If Def_Tranchant = False Then
                    'calcul sans prise en compte de la dformation de l'effort tranchant
                    Call K_2D_droit_relaxe(i, L(i), Kg0)
                Else
                    Call K_2D_droit_relaxe_avec_G(i, L(i), Sr(i), Kg0)
                End If

                ' si noe 1 relax et noe 2 relax 
            ElseIf Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                Call K_2D_tout_relaxe(i, L(i), Kg0)
            End If
            Call Rotation(i, alpha, Rot) ' calcul de la matrice de rotation pour l'lment concern
        Next
        '2 - Assemblage de la matrice
        'mise  zro de la matrice de rigidit globale
        For i = 1 To 3 * Total_noeud
            For j = 1 To 3 * Total_noeud
                Kg(i, j) = 0
            Next
        Next
        'assemblage matrice
        For i = 1 To Total_element
            'assemblage matrice rigidit locale infrieure droite = k1
            j = 0
            For k = 1 To 3
                For k11 = 1 To 3
                    j = j + 1
                    k1(k, k11) = Kg0(j, i)
                Next
            Next
            'calcul des matrices transfert Td et Tg
            For k = 1 To 3
                For k11 = 1 To 3
                    Td(k, k11) = 0 : Tg(k, k11) = 0
                Next
                Td(k, k) = -1 : Tg(k, k) = -1
            Next
            Td(2, 3) = -L(i) : Tg(3, 2) = -L(i)
            'mise de rot dans R et Rt
            j = 0
            For k = 1 To 3
                For k11 = 1 To 3
                    j = j + 1
                    R(k, k11) = Rot(j, i) : Rt(k11, k) = Rot(j, i)
                Next
            Next
            'calcul des matrices K0,L0 et L1
            Call Matmul(Tg, k1, l1)
            Call Matmul(l1, Td, k0)
            Call Matmul(k1, Td, l0)
            'rotation et addition
            jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
            Call Matmul(Rt, k0, BB)
            Call Matmul(BB, R, k0)
            Call MatAdd(Kg, k0, jD, jD)

            Call Matmul(Rt, k1, BB)
            Call Matmul(BB, R, k1)
            Call MatAdd(Kg, k1, jF, jF)

            Call Matmul(Rt, l0, BB)
            Call Matmul(BB, R, l0)
            Call MatAdd(Kg, l0, jF, jD)

            Call Matmul(Rt, l1, BB)
            Call Matmul(BB, R, l1)
            Call MatAdd(Kg, l1, jD, jF)
        Next

        'Pour viter la matrice singulire et continuer le calcul avec Avertissement du projeteur
        For i = 1 To Total_noeud * 3
            If Kg(i, i) = 0 Then
                Kg(i, i) = 1
                'MsgBox("Pivot nul en ligne/colonne: " & Str(i) & vbCrLf & _
                '"Vrifiez la cohrence des rsultats du calcul du logiciel", MsgBoxStyle.Exclamation, _
                '"Sub Matrice_Rigidite_2D")
            End If
        Next
        'Libration de mmoire
        Erase k0, Td, Tg, k1, l0, l1, BB, R, Rt
        '--> Debogage de l'application: 
        ''    affichage dans le fichier de dtails du calcul de la matrice globale Kg
        'Dim F_kg(3 * Total_noeud, 3 * Total_noeud) As String
        'msgg = msgg & "Matrice globale de rigidit Kg:" & vbCrLf
        'For i = 1 To 3 * Total_noeud
        '    For j = 1 To 3 * Total_noeud
        '        F_kg(i, j) = Format(Kg(i, j), "###0.00")
        '        msgg = msgg & "  " & F_kg(i, j)
        '    Next
        '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'Next
        'msgg = msgg & vbCrLf
    End Sub
    Private Sub K_2D_tout_encastre(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)


        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = (12 * Ey(k) * Iy(k)) / l ^ 3 : A(6, k) = (-6 * Ey(k) * Iy(k)) / l ^ 2
        A(7, k) = 0 : A(8, k) = (-6 * Ey(k) * Iy(k)) / l ^ 2 : A(9, k) = (4 * Ey(k) * Iy(k)) / l

        '--> Debogage de l'application: 
        '       criture de la matrice de rigidit lmentaire dans un fichier
        'Dim k1 As Integer
        'Dim F_A(9) As String
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_2D_tout_encastre_avec_G(ByVal k As Integer, ByVal l As Double, ByVal Sr As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)
        '     Den = rigidit distorsionnelle Den = Ey(k) * Sr
        Dim GammaG, Aux As Double

        GammaG = 6 * Ey(k) * Iy(k) / (l ^ 2 * G(k) * Sr)
        Aux = Ey(k) * Iy(k) / (l ^ 3 * (1 + 2 * GammaG))
        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = 12 * Aux : A(6, k) = -6 * l * Aux
        A(7, k) = 0 : A(8, k) = -6 * l * Aux : A(9, k) = 4 * l ^ 2 * (1 + GammaG / 2)

    End Sub
    Private Sub K_2D_tout_encastre_I_variable(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double, _
                                              ByVal h1 As Double, ByVal h2 As Double, ByVal ea As Double, ByVal es As Double, ByVal b As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        Dim i As Integer
        Dim aa, bb, cc, dd, hx, S, x, FF, FFb, pas As Double  '
        'dtermination du coefficient aa
        'calcul de l'intgration numrique par la mthode des trapzes
        'calcul du pas - dcoupage de la longueur en 20 fois
        pas = l / 20
        'calcul de f(x0) initial
        S = 1 / (ea * h1 + 2 * b * es)
        S = S / 2
        x = 0
        i = 1
        Do
            'calcul du x+pas
            x = x + pas
            'calcul de f(x+pas)
            hx = h1 + x * (h2 - h1) / l
            'sommation de f(x+pas) au f(x) prcdent
            S = S + (1 / (ea * hx + 2 * b * es))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = h1 + x * (h2 - h1) / l
        FF = 1 / (ea * FF + 2 * b * es)
        FFb = h2
        FFb = 1 / (ea * FFb + 2 * b * es)
        'sommation gnrale sur tous les pas de calcul
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        aa = S

        'dtermination du coefficient bb
        hx = h1
        S = 12 * l ^ 2 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3)
        S = S / 2
        x = 0
        i = 1
        Do
            x = x + pas
            hx = (h1 + x * ((h2 - h1) / l))
            S = S + (12 * (l - x) ^ 2 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = (h1 + x * ((h2 - h1) / l))
        FF = 12 * (l - x) ^ 2 / (ea * FF ^ 3 + 6 * b * es * FF ^ 2 + 12 * b * es ^ 3 * FF + 8 * b * es ^ 3)
        FFb = 0
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        bb = S

        'dtermination du coefficient cc
        hx = h1
        S = 12 * l / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3)
        S = S / 2
        x = 0
        i = 1
        Do
            x = x + pas
            hx = (h1 + x * ((h2 - h1) / l))
            S = S + (12 * (l - x) / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = (h1 + x * ((h2 - h1) / l))
        FF = 12 * (l - x) / (ea * FF ^ 3 + 6 * b * es * FF ^ 2 + 12 * b * es ^ 3 * FF + 8 * b * es ^ 3)
        FFb = 0
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        cc = S

        'dtermination du coefficient dd
        hx = h1
        S = 12 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3)
        S = S / 2
        x = 0
        i = 1
        Do
            x = x + pas
            hx = (h1 + x * ((h2 - h1) / l))
            S = S + (12 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = (h1 + x * ((h2 - h1) / l))
        FF = 12 / (ea * FF ^ 3 + 6 * b * es * FF ^ 2 + 12 * b * es ^ 3 * FF + 8 * b * es ^ 3)
        FFb = h2
        FF = 12 / (ea * FFb ^ 3 + 6 * b * es * FFb ^ 2 + 12 * b * es ^ 3 * FFb + 8 * b * es ^ 3)
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        dd = S

        A(1, k) = Ey(k) / aa : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = Ey(k) * (dd / (bb * dd - cc ^ 2)) : A(6, k) = (-cc * Ey(k)) / (bb * dd - cc ^ 2)
        A(7, k) = 0 : A(8, k) = (-cc * Ey(k)) / (bb * dd - cc ^ 2) : A(9, k) = bb * Ey(k) / (bb * dd - cc ^ 2)

        '--> Module de dbogage:
        'Dim F_A(9) As String
        'Dim i, k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_2D_tout_encastre_Rectangle_variable(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double, _
                                                 ByVal h1 As Double, ByVal h2 As Double, ByVal b As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        Dim i As Integer
        Dim aa, bb, cc, dd, hx, S, x, FF, FFb, pas As Double  '
        'dtermination du coefficient aa
        'calcul de l'intgration numrique par la mthode des trapzes
        'calcul du pas - dcoupage de la longueur en 20 fois
        pas = l / 20
        'calcul de f(x0) initial
        S = 1 / (h1 * b)
        S = S / 2
        x = 0
        i = 1
        Do
            'calcul du x+pas
            x = x + pas
            'calcul de f(x+pas)
            hx = h1 + x * (h2 - h1) / l
            'sommation de f(x+pas) au f(x) prcdent
            S = S + (1 / (hx * b))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = h1 + x * (h2 - h1) / l
        FF = 1 / (FF * b)
        FFb = h2
        FFb = 1 / (FFb * b)
        'sommation gnrale sur tous les pas de calcul
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        aa = S

        'dtermination du coefficient bb
        hx = h1
        S = 12 * l ^ 2 / (b * hx ^ 3)
        S = S / 2
        x = 0
        i = 1
        Do
            x = x + pas
            hx = (h1 + x * ((h2 - h1) / l))
            S = S + (12 * (l - x) ^ 2 / (b * hx ^ 3))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = (h1 + x * ((h2 - h1) / l))
        FF = 12 * (l - x) ^ 2 / (b * FF ^ 3)
        FFb = 0
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        bb = S

        'dtermination du coefficient cc
        hx = h1
        S = 12 * l / (b * hx ^ 3)
        S = S / 2
        x = 0
        i = 1
        Do
            x = x + pas
            hx = (h1 + x * ((h2 - h1) / l))
            S = S + (12 * (l - x) / (b * hx ^ 3))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = (h1 + x * ((h2 - h1) / l))
        FF = 12 * (l - x) / (b * FF ^ 3)
        FFb = 0
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        cc = S

        'dtermination du coefficient dd
        hx = h1
        S = 12 / (b * hx ^ 3)
        S = S / 2
        x = 0
        i = 1
        Do
            x = x + pas
            hx = (h1 + x * ((h2 - h1) / l))
            S = S + (12 / (b * hx ^ 3))
            i = i + 1
        Loop Until i = 19
        x = x + pas
        FF = (h1 + x * ((h2 - h1) / l))
        FF = 12 / (b * FF ^ 3)
        FFb = h2
        FF = 12 / (b * FFb ^ 3)
        S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        dd = S

        A(1, k) = Ey(k) / aa : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = Ey(k) * (dd / (bb * dd - cc ^ 2)) : A(6, k) = (-cc * Ey(k)) / (bb * dd - cc ^ 2)
        A(7, k) = 0 : A(8, k) = (-cc * Ey(k)) / (bb * dd - cc ^ 2) : A(9, k) = bb * Ey(k) / (bb * dd - cc ^ 2)
    End Sub
    Private Sub K_2D_gauche_relaxe(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = (3 * Ey(k) * Iy(k)) / l ^ 3 : A(6, k) = (-3 * Ey(k) * Iy(k)) / l ^ 2
        A(7, k) = 0 : A(8, k) = (-3 * Ey(k) * Iy(k)) / l ^ 2 : A(9, k) = (3 * Ey(k) * Iy(k)) / l

        '--> module de debogage:
        'Dim F_A(9) As String
        'Dim k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_2D_gauche_relaxe_avec_G(ByVal k As Integer, ByVal l As Double, ByVal Sr As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)
        Dim GammaG, Aux As Double
        GammaG = 6 * Ey(k) * Iy(k) / (l ^ 2 * G(k) * Sr)
        Aux = Ey(k) * Iy(k) / (l ^ 3 * (1 + GammaG / 2))
        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = 3 * Aux : A(6, k) = -3 * l * Aux
        A(7, k) = 0 : A(8, k) = -3 * l * Aux : A(9, k) = 3 * l ^ 2 * Aux
    End Sub
    Private Sub K_2D_droit_relaxe(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = (3 * Ey(k) * Iy(k)) / l ^ 3 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = 0

        '--> module de debogage:
        'Dim F_A(9) As String
        'Dim k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_2D_droit_relaxe_avec_G(ByVal k As Integer, ByVal l As Double, ByVal Sr As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)
        Dim GammaG, Aux As Double

        GammaG = 6 * Ey(k) * Iy(k) / (l ^ 2 * G(k) * Sr)
        Aux = Ey(k) * Iy(k) / (l ^ 3 * (1 + GammaG / 2))
        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = 3 * Aux : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = 0
    End Sub
    Private Sub K_2D_droit_libre(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0 '
        A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = -Ey(k) * Iy(k) / l

        '--> module de debogage:
        'Dim F_A(9) As String
        'Dim k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_2D_gauche_libre(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = Ey(k) * Iy(k) / l

        '--> module de debogage:
        'Dim F_A(9) As String
        'Dim k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_2D_tout_relaxe(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = 0

        '--> Module de dbogage:
        'Dim F_A(9) As String
        'Dim k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub Section_reduite(ByVal i As Integer, ByRef Sr As Double)
        'l'effort tranchant prpondrant est suppos vertical et // au sens de la + grande inertie
        Select Case Type_profile(i)
            Case 1 'profil en I
                If Gamma(i) = 0 Then
                    If Sry(i) = 0 Then
                        Sr = H(1, i) * ea(i)
                    Else
                        Sr = Sry(i)
                    End If
                Else
                    'profil  plat
                    If Sry(i) = 0 Then
                        Sr = 2 * B(i) * es(i)
                    Else
                        Sr = Sry(i)
                    End If
                End If
            Case 2 'profil en tube rond
                Sr = 5 * Sx(i) / 6
            Case 3 'profil en tube carr
                Sr = 5 * Sx(i) / 6
        End Select
    End Sub
    Private Sub Rotation(ByVal k As Integer, ByVal alpha As Double, ByRef A(,) As Double)
        Dim F_A(9) As String
        'Dim angle As String
        Dim i, j, k1 As Integer
        'matrice de rotation R pour passer du repre global au repre local: {x}= [R] {X}
        'k=N de l'lment
        For k1 = 1 To 9
            A(k1, k) = 0
        Next

        'arrondi sur matrice de rotation sinon problme de conditionnement numrique de matrice
        '90 en radian n'existe pas ->
        'If Abs(Cos(alpha)) < 0.01 Then
        '    A(1, k) = 0 : A(5, k) = 0
        'ElseIf Abs(Cos(alpha)) > 0.99 Then
        '    If Cos(alpha) > 0 Then
        '        A(1, k) = -1 : A(5, k) = -1
        '    Else
        '        A(1, k) = 1 : A(5, k) = 1
        '    End If
        'Else
        '    A(1, k) = Cos(alpha) : A(5, k) = Cos(alpha)
        'End If

        'If Abs(Sin(alpha)) < 0.01 Then
        '    A(4, k) = 0 : A(2, k) = 0
        'ElseIf Abs(Sin(alpha)) > 0.99 Then
        '    If Sin(alpha) > 0 Then
        '        A(4, k) = -1 : A(2, k) = 1
        '    Else
        '        A(4, k) = 1 : A(2, k) = -1
        '    End If
        'Else
        '    A(4, k) = -Sin(alpha) : A(2, k) = Sin(alpha)
        'End If
        A(1, k) = Cos(alpha) : A(5, k) = Cos(alpha)
        A(4, k) = -Sin(alpha) : A(2, k) = Sin(alpha)
        A(9, k) = 1

        'angle = Format(alpha * 180 / PI, "##0.00")
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00")
        'Next
        'i = Ele(1, k) : j = Ele(2, k)
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  sens " & CStr(i) & " --> " & CStr(j) & _
        '"  angle: " & angle & vbCrLf & "matrice Rot lmentaire" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(4) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf

    End Sub
    Private Sub Matmul(ByVal AA(,) As Double, ByVal BB(,) As Double, ByRef CC(,) As Double)
        'Multiplication de matrice 3x3
        Dim i, j, k As Integer
        Dim sum As Double
        For i = 1 To 3
            For j = 1 To 3
                sum = 0
                For k = 1 To 3
                    sum = sum + AA(i, k) * BB(k, j)
                Next
                ' If Abs(sum) < 0.000001 Then sum = 0 'sinon problme de conditionnement numrique de la matrice
                CC(i, j) = sum
            Next
        Next
        Erase AA, BB
    End Sub
    Private Sub MatAdd(ByRef AK(,) As Double, ByVal A(,) As Double, ByVal Jlig As Integer, ByVal Jcol As Integer)
        'Addition de la matrice A en ligne Jlig et colonne jcol dans la matrice Kg
        Dim i, j, ii, jj, il, ic As Integer
        ii = 3 * (Jlig - 1)
        jj = 3 * (Jcol - 1)
        For i = 1 To 3
            For j = 1 To 3
                il = ii + i
                ic = jj + j
                AK(il, ic) = AK(il, ic) + A(i, j)
            Next
        Next
        Erase A
    End Sub
    Public Sub Appui_elastique(ByRef Kg(,) As Double)
        'Modification de la matrice gnrale de rigidit en fonction des appuis lastiques
        'voir p95 "Calcul des structures et informatique"
        'programme d'addition des coefficients K en ligne Jlig et colonne jcol dans la matrice Kg
        'si l'appui n'est pas lastique, K=0 ce qui ne modifie pas la matrice Kg initiale
        Dim i, i3 As Integer

        For i = 1 To Total_noeud
            If Appui(i) = True Then 'test si noeud est un appui
                i3 = (i - 1) * 3
                Kg(i3 + 1, i3 + 1) = Kg(i3 + 1, i3 + 1) + Kux(i)
                Kg(i3 + 2, i3 + 2) = Kg(i3 + 2, i3 + 2) + Kuy(i)
                Kg(i3 + 3, i3 + 3) = Kg(i3 + 3, i3 + 3) + Krz(i)
            End If
        Next
    End Sub

    Public Sub Second_Membre_Treillis(ByVal L() As Double, ByRef FN(,) As Double, ByVal N_comb As Integer)                                   ', ByVal i_pas As Integer)
        'Calcul du vecteur force
        Dim i, j As Integer
        'mise  zero des vecteurs FN et FB
        For i = 1 To Total_noeud : For j = 1 To 3 : FN(j, i) = 0 : Next : Next
        'calcul  sur les cas de charges
        'forces nodales: elles s'ajoutent directement au vecteur force
        For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
            FN(1, j) = ForPN(1, j, N_comb)
            FN(2, j) = ForPN(2, j, N_comb)
        Next

    End Sub
    Public Sub Second_Membre_Portique_sans_G(ByVal L() As Double, ByVal Rot(,) As Double, ByRef FN(,) As Double, _
                                            ByRef FB(,) As Double, ByVal N_comb As Integer) ', ByVal i_pas As Integer)
        'Calcul du vecteur force
        Dim i, j, jd, jf As Integer ', Totaux_cas_de_charges

        'mise  zero des vecteurs FN et FB
        For i = 1 To Total_noeud : For j = 1 To 3 : FN(j, i) = 0 : Next : Next
        For i = 1 To Total_element : For j = 1 To 6 : FB(j, i) = 0 : Next : Next

        'calcul  sur les cas de charges
        'forces nodales: elles s'ajoutent directement au vecteur force - forces en repre global
        For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
            FN(1, j) = ForPN(1, j, N_comb)
            FN(2, j) = ForPN(2, j, N_comb)
            FN(3, j) = CplePN(j, N_comb)
        Next
        'forces sur lments
        For i = 1 To Total_element
            If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                Call Charge_travee_encastre(i, N_comb, L(i), FB)

                ' si noe 1 ou noe 2 libre alors 
                'ElseIf Appui(Ele(1, i)) = True And R_appui(1, Ele(1, i)) = True And R_appui(2, Ele(1, i)) = True And R_appui(6, Ele(1, i)) = True Then
                '    Call K_2D_gauche_libre(i, L(i), Kg0)
                'ElseIf Appui(Ele(2, i)) = True And R_appui(1, Ele(2, i)) = True And R_appui(2, Ele(2, i)) = True And R_appui(6, Ele(2, i)) = True Then
                '    Call K_2D_droit_libre(i, L(i), Kg0)

                ' si noe 1 relax et noe 2 encastr 
            ElseIf Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
                Call Charge_travee_gauche_relaxe(i, N_comb, L(i), FB)

                ' si noe 1 encastr et noe 2 relax 
            ElseIf Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
                Call Charge_travee_droite_relaxe(i, N_comb, L(i), FB)

                ' si noe 1 relax et noe 2 relax 
            ElseIf Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                Call Charge_travee_tout_relaxe(i, N_comb, L(i), FB)
            End If
        Next
        'Ajout au terme FN du terme FB
        'Passage du repre local au repre global
        For i = 1 To Total_element
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            FN(1, jd) = FN(1, jd) - (Rot(1, i) * FB(1, i) + Rot(4, i) * FB(2, i))
            FN(2, jd) = FN(2, jd) - (Rot(2, i) * FB(1, i) + Rot(5, i) * FB(2, i))
            FN(3, jd) = FN(3, jd) - FB(3, i)
            FN(1, jf) = FN(1, jf) - (Rot(1, i) * FB(4, i) + Rot(4, i) * FB(5, i))
            FN(2, jf) = FN(2, jf) - (Rot(2, i) * FB(4, i) + Rot(5, i) * FB(5, i))
            FN(3, jf) = FN(3, jf) - FB(6, i)
        Next
    End Sub
    Private Sub Charge_travee_encastre(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByRef FB(,) As Double)
        'j      = N de l'lment
        'N_comb = N de cas
        Dim a, b, C, P, P1, P2, Reaction(4) As Double
        Dim msg As String
        Dim i As Integer
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (a / L)
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForP(2, j, n_comb)
            a = a_ForP(2, j, i, n_comb) : b = L - a : P = ForP(2, j, i, n_comb)
            Reaction(1) = P * b ^ 2 * (3 * a + b) / L ^ 3
            Reaction(3) = P * a ^ 2 * (3 * b + a) / L ^ 3
            Reaction(2) = -P * a * b ^ 2 / L ^ 2 : Reaction(4) = -P * a ^ 2 * b / L ^ 2
            FB(2, j) = FB(2, j) - Reaction(1) : FB(3, j) = FB(3, j) + Reaction(2) 'noe 1: tranchant et moment
            FB(5, j) = FB(5, j) - Reaction(3) : FB(6, j) = FB(6, j) - Reaction(4) 'noe 2: tranchant et moment
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            a = a_CpleP(j, i, n_comb) : b = L - a : C = CpleP(j, i, n_comb)
            Reaction(1) = 6 * C * a * b / L ^ 3 : Reaction(3) = -Reaction(1)
            Reaction(2) = -C * b * (2 * L - 3 * b) / L ^ 2 : Reaction(4) = -C * a * (3 * a - 2 * L) / L ^ 2
            FB(2, j) = FB(2, j) + Reaction(1) : FB(3, j) = FB(3, j) - Reaction(2) 'noe 1: tranchant et moment
            FB(5, j) = FB(5, j) + Reaction(3) : FB(6, j) = FB(6, j) + Reaction(4) 'noe 2: tranchant et moment
        Next

        'forces rparties sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (C / L)
            'Dim forc As Double
            'forc = ForL1(1, j, i, n_comb) ' Fl(n_comb, j, 1)
            'FB(1, j) = FB(1, j) - L * forc / 2
            'FB(4, j) = FB(4, j) - L * forc / 2
        Next
        'force //  Y local (perpendiculaire  la barre)  force rpartie suivant Y local
        For i = 1 To Total_ForL(2, j, n_comb)
            a = a_ForL(2, j, i, n_comb) : b = b_ForL(2, j, i, n_comb)
            P1 = ForL1(2, j, i, n_comb) : P2 = ForL2(2, j, i, n_comb)
            If a = 0 And b = L Then
                'Formulaire Courtand-Lebelle Tome 2 page 173 - Charge Trapzoidale
                Reaction(1) = (7 * P1 + 3 * P2) * L / 20 : Reaction(3) = (3 * P1 + 7 * P2) * L / 20
                Reaction(2) = -(3 * P1 + 2 * P2) * L ^ 2 / 60 : Reaction(4) = -(2 * P1 + 3 * P2) * L ^ 2 / 60
                FB(2, j) = FB(2, j) - Reaction(1) : FB(3, j) = FB(3, j) + Reaction(2) 'noe 1: tranchant et moment
                FB(5, j) = FB(5, j) - Reaction(3) : FB(6, j) = FB(6, j) - Reaction(4) 'noe 2: tranchant et moment
            ElseIf P1 = P2 Then
                'Formulaire Courtand-Lebelle Tome 2 page 172 - Charge uniforme partielle - attention erreur typographique sur la formule de RA dans le formulaire
                Reaction(1) = P1 * b * (2 * L * (L ^ 2 - b ^ 2) + b ^ 3) / (2 * L ^ 3) : Reaction(3) = P1 * b ^ 3 * (2 * L - b) / (2 * L ^ 3)
                Reaction(2) = -(P1 * b ^ 2) * (6 * L ^ 2 - 8 * b * L + 3 * b ^ 2) / (12 * L ^ 2) : Reaction(4) = -(P1 * b ^ 3) * (4 * L - 3 * b) / (12 * L ^ 2)
                If a > 0.1 Then 'pour dire a<> de 0
                    'application du principe de superposition
                    Reaction(1) = Reaction(1) - (P1 * a * (2 * L * (L ^ 2 - a ^ 2) + a ^ 3) / (2 * L ^ 3))
                    Reaction(3) = Reaction(3) - (P1 * a ^ 3 * (2 * L - a) / (2 * L ^ 3))
                    Reaction(2) = Reaction(2) + ((P1 * a ^ 2) * (6 * L ^ 2 - 8 * a * L + 3 * a ^ 2) / (12 * L ^ 2))
                    Reaction(4) = Reaction(4) + ((P1 * a ^ 3) * (4 * L - 3 * a) / (12 * L ^ 2))
                End If
                FB(2, j) = FB(2, j) - Reaction(1) : FB(3, j) = FB(3, j) + Reaction(2) 'noe 1: tranchant et moment
                FB(5, j) = FB(5, j) - Reaction(3) : FB(6, j) = FB(6, j) - Reaction(4)
            Else
                msg = "Calcul des ractions provoques par forces rparties sur lment:" & vbCrLf & _
                                   "La force doit s'appliquer sur l'ensemble de la longueur de l'lment." & vbCrLf & _
                                   "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                                   "de la barre sur le noeud."
                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
            End If
        Next

        'couples rparties sur lment
        If CpleL1(j, n_comb) <> 0 Or CpleL1(j, n_comb) <> 0 Then
            msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
                         "Non pris en charge dans cette version logicielle." & vbCrLf & _
                         "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                           "de la barre sur le noeud."
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
        End If
    End Sub
    Private Sub Charge_travee_gauche_relaxe(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByRef FB(,) As Double)
        Dim reaction(4), a, b, P, P1, P2, C As Double
        Dim msg As String
        Dim i As Integer
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - a) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForP(2, j, n_comb)
            a = a_ForP(2, j, i, n_comb) : P = ForP(2, j, i, n_comb)
            reaction(1) = P * (L - a) ^ 2 * (2 * L + a) / (2 * L ^ 3)
            reaction(3) = P * a * (3 * L ^ 2 - a ^ 2) / (2 * L ^ 3)
            reaction(2) = 0 : reaction(4) = P * a * (L ^ 2 - a ^ 2) / (2 * L ^ 2)
            FB(2, j) = FB(2, j) - reaction(1) : FB(3, j) = FB(3, j) - reaction(2) 'noe 1: tranchant et moment
            FB(5, j) = FB(5, j) - reaction(3) : FB(6, j) = FB(6, j) + reaction(4) 'noe 2: tranchant et moment
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            a = a_CpleP(j, i, n_comb) : C = CpleP(j, i, n_comb)
            reaction(1) = 3 * C * (L ^ 2 - a ^ 2) / (2 * L ^ 3) : reaction(3) = -reaction(1)
            reaction(2) = 0 : reaction(4) = C * (L ^ 2 - 3 * a ^ 2) / (2 * L ^ 2)
            FB(2, j) = FB(2, j) + reaction(1) : FB(3, j) = FB(3, j) - reaction(2) 'noe 1: tranchant 
            FB(5, j) = FB(5, j) + reaction(3) : FB(6, j) = FB(6, j) + reaction(4) 'noe 2: tranchant et moment
        Next

        'forces rparties sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - C) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForL(2, j, n_comb)
            a = a_ForL(2, j, i, n_comb) : b = b_ForL(2, j, i, n_comb)
            P1 = ForL1(2, j, i, n_comb) : P2 = ForL2(2, j, i, n_comb)
            If a = 0 And b = L Then
                'Formulaire Courtand-Lebelle Tome 2 page 164 - Charge Trapzoidale
                reaction(1) = (11 * P1 + 4 * P2) * L / 40 : reaction(3) = (9 * P1 + 16 * P2) * L / 40
                reaction(2) = 0 : reaction(4) = -(7 * P1 + 8 * P2) * L ^ 2 / 120
                FB(2, j) = FB(2, j) - reaction(1) : FB(3, j) = FB(3, j) + reaction(2) 'noe 1: tranchant et moment
                FB(5, j) = FB(5, j) - reaction(3) : FB(6, j) = FB(6, j) - reaction(4) 'noe 2: tranchant et moment
            ElseIf P1 = P2 Then
                'Formulaire Courtand-Lebelle Tome 2 page 161 - Charge uniforme partielle
                reaction(1) = P1 * (8 * L ^ 3 - 6 * b * L ^ 2 + b ^ 3) / (8 * L ^ 3) : reaction(3) = P1 * b * (6 * L ^ 2 - b ^ 2) / (8 * L ^ 3)
                reaction(2) = 0 : reaction(4) = -(P1 * b) * (2 * L ^ 2 - b ^ 2) / (8 * L ^ 2)
                If a > 0.1 Then 'pour dire a<> de 0
                    'application du principe de superposition
                    reaction(1) = reaction(1) - (P1 * (8 * L ^ 3 - 6 * a * L ^ 2 + a ^ 3) / (8 * L ^ 3))
                    reaction(3) = reaction(3) - (P1 * a * (6 * L ^ 2 - a ^ 2) / (8 * L ^ 3))
                    reaction(4) = reaction(4) + (P1 * a) * (2 * L ^ 2 - a ^ 2) / (8 * L ^ 2)
                End If
                FB(2, j) = FB(2, j) - reaction(1) : FB(3, j) = FB(3, j) + reaction(2) 'noe 1: tranchant et moment
                FB(5, j) = FB(5, j) - reaction(3) : FB(6, j) = FB(6, j) - reaction(4)
            Else
                msg = "Calcul des ractions suite  sollicitation par forces rparties sur lment:" & vbCrLf & _
                                    "La force doit s'appliquer sur l'ensemble de la longueur de l'lment." & vbCrLf & _
                                    "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                                    "de la barre sur le noeud."
                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
            End If
        Next
        'couples rparties sur lment
        If CpleL1(j, n_comb) <> 0 And CpleL1(j, n_comb) <> 0 Then
            msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
                         "Non pris en charge dans cette version logicielle." & vbCrLf & _
                         "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                           "de la barre sur le noeud."
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
        End If
    End Sub
    Private Sub Charge_travee_droite_relaxe(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByRef FB(,) As Double)
        Dim reaction(4), a, b, P, P1, P2, C As Double
        Dim msg As String
        Dim i As Integer
        'forces ponctuelles sur lment
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - a) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForP(2, j, n_comb)
            a = L - a_ForP(2, j, i, n_comb) : P = ForP(2, j, i, n_comb)
            reaction(3) = P * (L - a) ^ 2 * (2 * L + a) / (2 * L ^ 3)
            reaction(1) = P * a * (3 * L ^ 2 - a ^ 2) / (2 * L ^ 3)
            reaction(4) = 0 : reaction(2) = P * a * (L ^ 2 - a ^ 2) / (2 * L ^ 2)
            FB(2, j) = FB(2, j) - reaction(1) : FB(3, j) = FB(3, j) - reaction(2) 'noe 1: tranchant et moment
            FB(5, j) = FB(5, j) - reaction(3) : FB(6, j) = FB(6, j) + reaction(4) 'noe 2: tranchant 
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            a = L - a_CpleP(j, i, n_comb) : C = CpleP(j, i, n_comb)
            reaction(1) = 3 * C * (L ^ 2 - a ^ 2) / (2 * L ^ 3) : reaction(3) = -reaction(1)
            reaction(4) = 0 : reaction(2) = -C * (L ^ 2 - 3 * a ^ 2) / (2 * L ^ 2)
            FB(2, j) = FB(2, j) + reaction(1) : FB(3, j) = FB(3, j) - reaction(2) 'noe 1: tranchant et moment
            FB(5, j) = FB(5, j) + reaction(3) : FB(6, j) = FB(6, j) + reaction(4) 'noe 2: tranchant
        Next

        'forces rparties sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - C) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForL(2, j, n_comb)
            a = a_ForL(2, j, i, n_comb) : b = b_ForL(2, j, i, n_comb)
            P1 = ForL1(2, j, i, n_comb) : P2 = ForL2(2, j, i, n_comb)
            If a = 0 And b = L Then
                'Formulaire Courtand-Lebelle Tome 2 page 164 - Charge Trapzoidale (en inversant les indices)
                reaction(3) = (11 * P1 + 4 * P2) * L / 40 : reaction(1) = (9 * P1 + 16 * P2) * L / 40
                reaction(4) = 0 : reaction(2) = -(7 * P1 + 8 * P2) * L ^ 2 / 120
                FB(2, j) = FB(2, j) - reaction(1) : FB(3, j) = FB(3, j) + reaction(2) 'noe 1: tranchant et moment
                FB(5, j) = FB(5, j) - reaction(3) : FB(6, j) = FB(6, j) - reaction(4) 'noe 2: tranchant et moment
            ElseIf P1 = P2 Then
                'Formulaire Courtand-Lebelle Tome 2 page 161 - Charge uniforme partielle
                reaction(1) = P1 * (2 * L - b) * (4 * L ^ 2 + b * (2 * L - b)) / (8 * L ^ 3) : reaction(3) = P1 * b ^ 2 * (4 * L - b) / (8 * L ^ 3)
                reaction(2) = -(P1 * b) * (2 * L - b) ^ 2 / (8 * L ^ 2) : reaction(4) = 0
                If a > 0.1 Then 'pour dire a<> de 0
                    'application du principe de superposition
                    reaction(1) = reaction(1) - (P1 * (2 * L - a) * (4 * L ^ 2 + a * (2 * L - b)) / (8 * L ^ 3))
                    reaction(3) = reaction(3) - (P1 * a ^ 2 * (4 * L - a) / (8 * L ^ 3))
                    reaction(2) = reaction(2) + (P1 * a) * (2 * L - a) ^ 2 / (8 * L ^ 2)
                End If
                FB(2, j) = FB(2, j) - reaction(1) : FB(3, j) = FB(3, j) + reaction(2) 'noe 1: tranchant et moment
                FB(5, j) = FB(5, j) - reaction(3) : FB(6, j) = FB(6, j) - reaction(4)
            Else
                msg = "Calcul des ractions suite  sollicitation par forces rparties sur lment:" & vbCrLf & _
                                    "La force doit s'appliquer sur l'ensemble de la longueur de l'lment." & vbCrLf & _
                                    "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                                    "de la barre sur le noeud."
                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
            End If
        Next
        'couples rparties sur lment
        If CpleL1(j, n_comb) <> 0 And CpleL1(j, n_comb) <> 0 Then
            msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
                           "Non pris en charge dans cette version logicielle." & vbCrLf & _
                           "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                             "de la barre sur le noeud."
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
        End If
    End Sub
    Private Sub Charge_travee_tout_relaxe(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByRef FB(,) As Double)
        Dim a, b, C, P, P1, P2, Reaction(4) As Double
        Dim msg As String
        Dim i As Integer
        'Rappel: FB = effort  appliquer sur les extrmits de la barre pour viter tout dplacement ou rotation
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - a) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForP(2, j, n_comb)
            a = a_ForP(2, j, i, n_comb) : P = ForP(2, j, i, n_comb)
            Reaction(1) = P * (1 - a / L) : Reaction(3) = P - Reaction(1)
            FB(2, j) = FB(2, j) + Reaction(1)  'noe 1: tranchant 
            FB(5, j) = FB(5, j) + Reaction(3) 'noe 2: tranchant 
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            a = a_CpleP(j, i, n_comb) : C = CpleP(j, i, n_comb)
            Reaction(1) = C / L : Reaction(3) = -Reaction(1)
            Reaction(4) = 0 : Reaction(2) = 0
            FB(2, j) = FB(2, j) + Reaction(1)  'noe 1: tranchant
            FB(5, j) = FB(5, j) + Reaction(3)  'noe 2: tranchant
        Next

        'forces rparties sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - C) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)       
        For i = 1 To Total_ForL(2, j, n_comb)
            a = a_ForL(2, j, i, n_comb) : C = L - b_ForL(2, j, i, n_comb) : b = b_ForL(2, j, i, n_comb) - a
            P1 = ForL1(2, j, i, n_comb) : P2 = ForL2(2, j, i, n_comb) : P = (P1 + P2) * b / 2
            Reaction(1) = b * (P1 * (2 * b + 3 * C) + P2 * (b + 3 * C)) / (6 * L)
            Reaction(3) = P - Reaction(1) '!!!!!!!!!!!!!!!!!   attention : diffrent de Thonier  voir
            FB(2, j) = FB(2, j) - Reaction(1)  'noe 1: tranchant 
            FB(5, j) = FB(5, j) - Reaction(3) 'noe 2: tranchant 
        Next
        'couples rparties sur lment
        If CpleL1(j, n_comb) <> 0 And CpleL1(j, n_comb) <> 0 Then
            msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
                          "Non pris en charge dans cette version logicielle." & vbCrLf & _
                          "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                            "de la barre sur le noeud."
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
        End If
    End Sub
    Private Sub Charge_Console_gauche(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByRef FB(,) As Double)
        Dim a, b, P, P1, P2, Reaction(4) As Double
        Dim msg As String
        Dim i As Integer
        'Console gauche: le noeud encastr est le noeud de droite (= noeud 2) ->sens de parcours de gauche vers la droite
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            FB(4, j) = FB(4, j) - ForP(1, j, i, n_comb)
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForP(2, j, n_comb)
            Reaction(3) = -ForP(2, j, i, n_comb)
            FB(5, j) = FB(5, j) + Reaction(3)  'noe 2: tranchant
        Next

        'Couples ponctuels sur lment
        If Total_CpleP(j, n_comb) >= 1 Then
            msg = "Calcul des ractions suite  sollicitation par couples sur lment:" & vbCrLf & _
                                 "Non pris en charge dans cette version logicielle." & vbCrLf & _
                                 "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                                   "de la barre sur le noeud."
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
        End If

        'forces rparties sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb)
            FB(4, j) = FB(4, j) - (b - a) * ForL1(1, j, i, n_comb)
        Next
        'force //  Y local (perpendiculaire  la barre)   
        For i = 1 To Total_ForL(2, j, n_comb)
            a = L - b_ForL(2, j, i, n_comb) : b = b_ForL(2, j, i, n_comb) - a_ForL(2, j, i, n_comb)
            P1 = ForL1(2, j, i, n_comb) : P2 = ForL2(2, j, i, n_comb) - P1
            Reaction(3) = P1 * b + P2 * b / 2
            Reaction(4) = -P1 * b * (a + b / 2) - P2 * (b / 2) * (a + 2 * b / 3)
            FB(5, j) = FB(5, j) + Reaction(3) : FB(6, j) = FB(6, j) + Reaction(4) 'noe 1: tranchant et moment 
        Next
        'couples rparties sur lment
        msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
              "Non pris en charge dans cette version logicielle." & vbCrLf & _
              "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                "de la barre sur le noeud."
        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
    End Sub
    Private Sub Charge_Console_droite(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByRef FB(,) As Double)
        Dim a, b, P, P1, P2, Reaction(4) As Double
        Dim msg As String
        Dim i As Integer
        'Console droite: le noeud encastr est le noeud de gauche (= noeud 1)
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            FB(1, j) = FB(1, j) - ForP(1, j, i, n_comb)
        Next
        'force //  Y local (perpendiculaire  la barre)
        For i = 1 To Total_ForP(2, j, n_comb)
            Reaction(1) = -ForP(2, j, i, n_comb)
            FB(2, j) = FB(2, j) + Reaction(1)  'noe 1: tranchant
        Next

        'Couples ponctuels sur lment
        If Total_CpleP(j, n_comb) >= 1 Then
            msg = "Calcul des ractions suite  sollicitation par couples  sur lment:" & vbCrLf & _
                               "Non pris en charge dans cette version logicielle." & vbCrLf & _
                               "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                                 "de la barre sur le noeud."
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
        End If

        'forces rparties sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - (b - a) * ForL1(1, j, i, n_comb)
        Next
        'force //  Y local (perpendiculaire  la barre)       
        For i = 1 To Total_ForL(2, j, n_comb)
            a = a_ForL(2, j, i, n_comb) : b = b_ForL(2, j, i, n_comb) - a
            P1 = ForL1(2, j, i, n_comb) : P2 = ForL2(2, j, i, n_comb) - P1
            Reaction(1) = P1 * b + P2 * b / 2
            Reaction(2) = -P1 * b * (a + b / 2) - P2 * (b / 2) * (a + 2 * b / 3)
            FB(2, j) = FB(2, j) + Reaction(1) : FB(3, j) = FB(3, j) + Reaction(2) 'noe 1: tranchant et moment 
        Next
        'couples rparties sur lment
        msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
              "Non pris en charge dans cette version logicielle." & vbCrLf & _
              "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
                "de la barre sur le noeud."
        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, title)
    End Sub
    Public Sub Second_Membre_Portique_avec_G(ByVal L() As Double, ByVal Rot(,) As Double, ByRef FN(,) As Double, ByRef FB(,) As Double, _
                                 ByVal N_comb As Integer, ByVal Sr() As Double) ', ByVal i_pas As Integer)
        'Calcul du vecteur force
        Dim i, ii, j, jd, jf, jj, N_comb1 As Integer ', Totaux_cas_de_charges

        'mise  zero des vecteurs FN et FB
        For i = 1 To Total_noeud : For j = 1 To 3 : FN(j, i) = 0 : Next : Next
        For i = 1 To Total_element : For j = 1 To 6 : FB(j, i) = 0 : Next : Next

        'calcul  sur les cas de charges
        'forces nodales: elles s'ajoutent directement au vecteur force
        For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
            FN(1, j) = ForPN(1, j, N_comb)
            FN(2, j) = ForPN(2, j, N_comb)
            FN(3, j) = CplePN(j, N_comb)
        Next
        'forces sur lments
        For i = 1 To Total_element
            If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                Call Charge_travee_encastre_avec_G(i, N_comb, L(i), Sr(i), FB)

                ' si noe 1 ou noe 2 libre alors 
                'ElseIf Appui(Ele(1, i)) = True And R_appui(1, Ele(1, i)) = True And R_appui(2, Ele(1, i)) = True And R_appui(6, Ele(1, i)) = True Then
                '    Call K_2D_gauche_libre(i, L(i), Kg0)
                'ElseIf Appui(Ele(2, i)) = True And R_appui(1, Ele(2, i)) = True And R_appui(2, Ele(2, i)) = True And R_appui(6, Ele(2, i)) = True Then
                '    Call K_2D_droit_libre(i, L(i), Kg0)

                ' si noe 1 relax et noe 2 encastr 
            ElseIf Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
                Call Charge_travee_gauche_relaxe_avec_G(i, N_comb, L(i), Sr(i), FB)

                ' si noe 1 encastr et noe 2 relax 
            ElseIf Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
                Call Charge_travee_droite_relaxe_avec_G(i, N_comb, L(i), Sr(i), FB)

                ' si noe 1 relax et noe 2 relax 
            ElseIf Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                Call Charge_travee_tout_relaxe(i, N_comb, L(i), FB)
            End If
        Next
        'Ajout au terme FN du terme FB
        'Passage du repre local au repre global
        For i = 1 To Total_element
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            FN(1, jd) = FN(1, jd) - (Rot(1, i) * FB(1, i) + Rot(4, i) * FB(2, i))
            FN(2, jd) = FN(2, jd) - (Rot(2, i) * FB(1, i) + Rot(5, i) * FB(2, i))
            FN(3, jd) = FN(3, jd) - FB(3, i)
            FN(1, jf) = FN(1, jf) - (Rot(1, i) * FB(4, i) + Rot(4, i) * FB(5, i))
            FN(2, jf) = FN(2, jf) - (Rot(2, i) * FB(4, i) + Rot(5, i) * FB(5, i))
            FN(3, jf) = FN(3, jf) - FB(6, i)
        Next
    End Sub
    Private Sub Charge_travee_encastre_avec_G(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByVal Sr As Double, _
                   ByRef FB(,) As Double)
        'j      = N de l'lment
        'N_comb = N de cas
        Dim a, b, C, P, P1, P2, GammaG, Aux, coef1, coef2, coef3, coef4 As Double
        Dim AA_F(4, 4), AA_C(4, 4), Reaction(4), Effort(4) As Double
        Dim i, i1 As Integer
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - a) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        GammaG = 6 * Ey(j) * Iy(j) / (L ^ 2 * G(j) * Sr)
        Aux = 1 / (L ^ 3 * (1 + 2 * GammaG))
        AA_F(1, 1) = -2 * Aux : AA_F(1, 2) = 3 * L * Aux : AA_F(1, 3) = 2 * L ^ 2 * GammaG * Aux : AA_F(1, 4) = -L ^ 3 * (1 + 2 * GammaG) * Aux
        AA_F(2, 1) = -L * Aux : AA_F(2, 2) = L ^ 2 * (GammaG + 2) * Aux : AA_F(2, 3) = -L ^ 3 * (GammaG + 1) * Aux : AA_F(2, 4) = 0
        AA_F(3, 1) = 2 * Aux : AA_F(3, 2) = -3 * L * Aux : AA_F(3, 3) = -2 * L ^ 2 * GammaG * Aux : AA_F(3, 4) = 0
        AA_F(4, 1) = -L * Aux : AA_F(4, 2) = L ^ 2 * (1 - GammaG) * Aux : AA_F(4, 3) = L ^ 3 * GammaG * Aux : AA_F(4, 4) = 0
        For i = 1 To Total_ForP(2, j, n_comb)
            Effort(1) = a_ForP(2, j, i, n_comb) ^ 3 * ForP(2, j, i, n_comb)
            Effort(2) = a_ForP(2, j, i, n_comb) ^ 2 * ForP(2, j, i, n_comb)
            Effort(3) = a_ForP(2, j, i, n_comb) * ForP(2, j, i, n_comb) : Effort(4) = ForP(2, j, i, n_comb)
            Call MatVect(AA_F, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            AA_C(1, 1) = 0 : AA_C(1, 2) = -6 * Aux : AA_C(1, 3) = 6 * L * Aux : AA_C(1, 4) = 2 * L ^ 2 * GammaG * Aux
            AA_C(2, 1) = 0 : AA_C(2, 2) = -3 * L * Aux : AA_C(2, 3) = 2 * L ^ 2 * (GammaG + 2) * Aux : AA_C(2, 4) = -L ^ 3 * (GammaG + 1) * Aux
            AA_C(3, 1) = 0 : AA_C(3, 2) = 6 * Aux : AA_C(3, 3) = -6 * L * Aux : AA_C(3, 4) = -2 * L ^ 2 * GammaG * Aux
            AA_C(4, 1) = 0 : AA_C(4, 2) = -3 * L * Aux : AA_C(4, 3) = 2 * L ^ 2 * (1 - GammaG) * Aux : AA_C(4, 4) = L ^ 3 * GammaG * Aux
            Effort(1) = a_CpleP(j, i, n_comb) ^ 3 * CpleP(j, i, n_comb) : Effort(2) = a_CpleP(j, i, n_comb) ^ 2 * CpleP(j, i, n_comb)
            Effort(3) = a_CpleP(j, i, n_comb) * CpleP(j, i, n_comb) : Effort(4) = CpleP(j, i, n_comb)
            Call MatVect(AA_C, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'Forces rparties sur lments
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - C) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)  force rpartie suivant Y local
        Dim aP, bP, Pa, Pb, Cfor(5) As Double
        For i = 1 To Total_ForL(2, j, n_comb)
            aP = a_ForL(2, j, i, n_comb)
            bP = b_ForL(2, j, i, n_comb)
            'calcul des efforts dus aux forces rparties
            Pa = ForL1(2, j, i, n_comb)
            Pb = ForL2(2, j, i, n_comb)
            coef1 = (Pb - Pa) / (bP - aP)
            coef3 = (bP * Pa - aP * Pb) / (bP - aP)
            For i1 = 1 To 5
                Cfor(i1) = (bP ^ (6 - i1) - aP ^ (6 - i1)) / (6 - i1)
            Next
            'dtermination du vecteur sollicitant dduit des pressions
            For i1 = 1 To 4
                Effort(i1) = Cfor(i1) * coef1 + Cfor(i1 + 1) * coef3
            Next
            Call MatVect(AA_F, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'couples rparties sur lment
        Dim aC, bC, Ca, Cb, Ccple(5) As Double
        aC = a_CpleL(j, n_comb)
        bC = b_CpleL(j, n_comb)
        If (aC = 0 And bC = 0) = False Then
            'calcul des efforts dus aux couples
            Ca = CpleL1(j, n_comb)
            Cb = CpleL2(j, n_comb)
            coef2 = (Cb - Ca) / (bC - aC)
            coef4 = (bC * Ca - aC * Cb) / (bC - aC)
            For i = 1 To 5
                Ccple(i) = (bC ^ (6 - i) - aC ^ (6 - i)) / (6 - i)
            Next
            'dtermination du vecteur sollicitant dduit des couples
            For i = 1 To 4
                Effort(i) = Ccple(i) * coef2 + Ccple(i + 1) * coef4
            Next
            Call MatVect(AA_C, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        End If
    End Sub
    Private Sub MatVect(ByVal A(,) As Double, ByVal Va() As Double, ByRef Vb() As Double)
        'Multiplication d'une matrice 4x4 par un vecteur
        Dim j, k As Integer
        Dim sum As Double
        For j = 1 To 4
            sum = 0
            For k = 1 To 4
                sum = sum + A(j, k) * Va(k)
            Next
            Vb(j) = sum
        Next
    End Sub
    Private Sub Charge_travee_gauche_relaxe_avec_G(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByVal Sr As Double, _
                         ByRef FB(,) As Double)
        'j      = N de l'lment
        'N_comb = N de cas
        Dim a, b, C, P, P1, P2, GammaG, Aux, coef1, coef2, coef3, coef4 As Double
        Dim AA_F(4, 4), AA_C(4, 4), Reaction(4), Effort(4) As Double
        Dim i, i1 As Integer
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - a) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        GammaG = 6 * Ey(j) * Iy(j) / (L ^ 2 * G(j) * Sr)
        Aux = 1 / (L ^ 3 * (2 + GammaG))
        AA_F(1, 1) = -1 * Aux : AA_F(1, 2) = 0 : AA_F(1, 3) = (3 + GammaG) * L ^ 2 * Aux : AA_F(1, 4) = -L ^ 3 * (2 + GammaG) * Aux
        AA_F(2, 1) = 0 : AA_F(2, 2) = 0 : AA_F(2, 3) = 0 : AA_F(2, 4) = 0
        AA_F(3, 1) = 1 * Aux : AA_F(3, 2) = 0 : AA_F(3, 3) = -L ^ 2 * (3 + GammaG) * Aux : AA_F(3, 4) = 0
        AA_F(4, 1) = -L * Aux : AA_F(4, 2) = 0 : AA_F(4, 3) = L ^ 3 * Aux : AA_F(4, 4) = 0
        For i = 1 To Total_ForP(2, j, n_comb)
            Effort(1) = a_ForP(2, j, i, n_comb) ^ 3 * ForP(2, j, i, n_comb)
            Effort(2) = a_ForP(2, j, i, n_comb) ^ 2 * ForP(2, j, i, n_comb)
            Effort(3) = a_ForP(2, j, i, n_comb) * ForP(2, j, i, n_comb) : Effort(4) = ForP(2, j, i, n_comb)
            Call MatVect(AA_F, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            AA_C(1, 1) = 0 : AA_C(1, 2) = -3 * Aux : AA_C(1, 3) = 0 : AA_C(1, 4) = L ^ 2 * (3 + GammaG) * Aux
            AA_C(2, 1) = 0 : AA_C(2, 2) = 0 : AA_C(2, 3) = 0 : AA_C(2, 4) = 0
            AA_C(3, 1) = 0 : AA_C(3, 2) = 3 * Aux : AA_C(3, 3) = 0 : AA_C(3, 4) = -L ^ 2 * (3 + GammaG) * Aux
            AA_C(4, 1) = 0 : AA_C(4, 2) = -3 * L * Aux : AA_C(4, 3) = 0 : AA_C(4, 4) = L ^ 3 * Aux
            Effort(1) = a_CpleP(j, i, n_comb) ^ 3 * CpleP(j, i, n_comb)
            Effort(2) = a_CpleP(j, i, n_comb) ^ 2 * CpleP(j, i, n_comb)
            Effort(3) = a_CpleP(j, i, n_comb) * CpleP(j, i, n_comb) : Effort(4) = CpleP(j, i, n_comb)
            Call MatVect(AA_C, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'Forces rparties sur lments
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - C) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)  force rpartie suivant Y local
        Dim aP, bP, Pa, Pb, Cfor(5) As Double
        For i = 1 To Total_ForL(2, j, n_comb)
            aP = a_ForL(2, j, i, n_comb)
            bP = b_ForL(2, j, i, n_comb)
            If (aP = 0 And bP = 0) = False Then
                'calcul des efforts dus aux forces rparties
                Pa = ForL1(2, j, i, n_comb)
                Pb = ForL2(2, j, i, n_comb)
                For i1 = 1 To 5
                    Cfor(i1) = (bP ^ (6 - i1) - aP ^ (6 - i1)) / (6 - i1)
                Next
                coef1 = (Pb - Pa) / (bP - aP)
                coef3 = (bP * Pa - aP * Pb) / (bP - aP)
                'dtermination du vecteur sollicitant dduit des pressions
                For i1 = 1 To 4
                    Effort(i1) = Cfor(i1) * coef1 + Cfor(i1 + 1) * coef3
                Next
                Call MatVect(AA_F, Effort, Reaction)
                FB(2, j) = FB(2, j) + Reaction(1)
                FB(3, j) = FB(3, j) + Reaction(2)
                FB(5, j) = FB(5, j) + Reaction(3)
                FB(6, j) = FB(6, j) + Reaction(4)
            End If
        Next

        'couples rparties sur lment
        Dim aC, bC, Ca, Cb, Ccple(5) As Double
        aC = a_CpleL(j, n_comb)
        bC = b_CpleL(j, n_comb)
        If (aC = 0 And bC = 0) = False Then
            'calcul des efforts dus aux couples
            Ca = CpleL1(j, n_comb)
            Cb = CpleL2(j, n_comb)
            For i = 1 To 5
                Ccple(i) = (bC ^ (6 - i) - aC ^ (6 - i)) / (6 - i)
            Next
            coef2 = (Cb - Ca) / (bC - aC)
            coef4 = (bC * Ca - aC * Cb) / (bC - aC)
            'dtermination du vecteur sollicitant dduit des couples
            For i = 1 To 4
                Effort(i) = Ccple(i) * coef2 + Ccple(i + 1) * coef4
            Next
            Call MatVect(AA_C, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        End If

    End Sub
    Private Sub Charge_travee_droite_relaxe_avec_G(ByVal j As Integer, ByVal n_comb As Integer, ByVal L As Double, ByVal Sr As Double, _
                      ByRef FB(,) As Double)
        'j      = N de l'lment
        'N_comb = N de cas
        Dim a, b, C, P, P1, P2, GammaG, Aux, coef1, coef2, coef3, coef4 As Double
        Dim AA_F(4, 4), AA_C(4, 4), Reaction(4), Effort(4) As Double
        Dim i, i1 As Integer
        'forces ponctuelles sur lment
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForP(1, j, n_comb)
            a = a_ForP(1, j, i, n_comb) : P = ForP(1, j, i, n_comb)
            FB(1, j) = FB(1, j) - ((L - a) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - a) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)
        GammaG = 6 * Ey(j) * Iy(j) / (L ^ 2 * G(j) * Sr)
        Aux = 1 / (L ^ 3 * (2 + GammaG))
        AA_F(1, 1) = -1 * Aux : AA_F(1, 2) = 3 * L * Aux : AA_F(1, 3) = GammaG * L ^ 2 * Aux : AA_F(1, 4) = -L ^ 3 * (2 + GammaG) * Aux
        AA_F(2, 1) = -L * Aux : AA_F(2, 2) = 3 * L ^ 2 * Aux : AA_F(2, 3) = -2 * L ^ 3 * Aux : AA_F(2, 4) = 0
        AA_F(3, 1) = 1 * Aux : AA_F(3, 2) = -3 * L * Aux : AA_F(3, 3) = -L ^ 2 * GammaG * Aux : AA_F(3, 4) = 0
        AA_F(4, 1) = 0 : AA_F(4, 2) = 0 : AA_F(4, 3) = 0 : AA_F(4, 4) = 0
        For i = 1 To Total_ForP(2, j, n_comb)
            Effort(1) = a_ForP(2, j, i, n_comb) ^ 3 * ForP(2, j, i, n_comb)
            Effort(2) = a_ForP(2, j, i, n_comb) ^ 2 * ForP(2, j, i, n_comb)
            Effort(3) = a_ForP(2, j, i, n_comb) * ForP(2, j, i, n_comb) : Effort(4) = ForP(2, j, i, n_comb)
            Call MatVect(AA_F, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'Couples ponctuels sur lment
        For i = 1 To Total_CpleP(j, n_comb)
            AA_C(1, 1) = 0 : AA_C(1, 2) = -3 * Aux : AA_C(1, 3) = 6 * L * Aux : AA_C(1, 4) = L ^ 2 * GammaG * Aux
            AA_C(2, 1) = 0 : AA_C(2, 2) = -3 * L * Aux : AA_C(2, 3) = 6 * L ^ 2 * Aux : AA_C(2, 4) = -2 * L ^ 3 * Aux
            AA_C(3, 1) = 0 : AA_C(3, 2) = 3 * Aux : AA_C(3, 3) = -6 * L * Aux : AA_C(3, 4) = -L ^ 2 * GammaG * Aux
            AA_C(4, 1) = 0 : AA_C(4, 2) = 0 : AA_C(4, 3) = 0 : AA_C(4, 4) = 0
            Effort(1) = a_CpleP(j, i, n_comb) ^ 3 * CpleP(j, i, n_comb)
            Effort(2) = a_CpleP(j, i, n_comb) ^ 2 * CpleP(j, i, n_comb)
            Effort(3) = a_CpleP(j, i, n_comb) * CpleP(j, i, n_comb) : Effort(4) = CpleP(j, i, n_comb)
            Call MatVect(AA_C, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        Next

        'Forces rparties sur lments
        'force //  X local (parallle  la barre)
        For i = 1 To Total_ForL(1, j, n_comb)
            a = a_ForL(1, j, i, n_comb) : b = b_ForL(1, j, i, n_comb) - a
            P1 = ForL1(1, j, i, n_comb) : P2 = ForL2(1, j, i, n_comb) : P = (P1 + P2) * b / 2
            If Abs(P2) = Abs(P1) Then C = b / 2
            If Abs(P2) > Abs(P1) Then C = 2 / 3 * b
            If Abs(P2) < Abs(P1) Then C = 1 / 3 * b
            C = C + a
            FB(1, j) = FB(1, j) - ((L - C) / L) * P
            FB(4, j) = FB(4, j) - P * (1 - ((L - C) / L))
        Next
        'force //  Y local (perpendiculaire  la barre)  force rpartie suivant Y local
        Dim aP, bP, Pa, Pb, Cfor(5) As Double
        For i = 1 To Total_ForL(2, j, n_comb)
            aP = a_ForL(2, j, i, n_comb)
            bP = b_ForL(2, j, i, n_comb)
            If (aP = 0 And bP = 0) = False Then
                'calcul des efforts dus aux forces rparties
                Pa = ForL1(2, j, i, n_comb)
                Pb = ForL2(2, j, i, n_comb)
                coef1 = (Pb - Pa) / (bP - aP)
                coef3 = (bP * Pa - aP * Pb) / (bP - aP)
                For i1 = 1 To 5
                    Cfor(i1) = (bP ^ (6 - i1) - aP ^ (6 - i1)) / (6 - i1)
                Next
                'dtermination du vecteur sollicitant dduit des pressions
                For i1 = 1 To 4
                    Effort(i1) = Cfor(i1) * coef1 + Cfor(i1 + 1) * coef3
                Next
                Call MatVect(AA_F, Effort, Reaction)
                FB(2, j) = FB(2, j) + Reaction(1)
                FB(3, j) = FB(3, j) + Reaction(2)
                FB(5, j) = FB(5, j) + Reaction(3)
                FB(6, j) = FB(6, j) + Reaction(4)
            End If
        Next

        'couples rparties sur lment
        Dim aC, bC, Ca, Cb, Ccple(5) As Double
        aC = a_CpleL(j, n_comb)
        bC = b_CpleL(j, n_comb)
        If (aC = 0 And bC = 0) = False Then
            'calcul des efforts dus aux couples
            Ca = CpleL1(j, n_comb)
            Cb = CpleL2(j, n_comb)
            coef2 = (Cb - Ca) / (bC - aC)
            coef4 = (bC * Ca - aC * Cb) / (bC - aC)
            For i = 1 To 5
                Ccple(i) = (bC ^ (6 - i) - aC ^ (6 - i)) / (6 - i)
            Next
            'dtermination du vecteur sollicitant dduit des couples
            For i = 1 To 4
                Effort(i) = Ccple(i) * coef2 + Ccple(i + 1) * coef4
            Next
            Call MatVect(AA_C, Effort, Reaction)
            FB(2, j) = FB(2, j) + Reaction(1)
            FB(3, j) = FB(3, j) + Reaction(2)
            FB(5, j) = FB(5, j) + Reaction(3)
            FB(6, j) = FB(6, j) + Reaction(4)
        End If

    End Sub

    Public Sub C_Limit_Kg(ByRef Kg(,) As Double, ByRef Fapp(,) As Double, ByRef structure_OK As Boolean)
        'Prise en compte des conditions d'appui et des relaxations
        Dim i, i3, jj As Integer
        For i = 1 To Total_noeud
            Fapp(1, i) = 1 : Fapp(2, i) = 1 : Fapp(3, i) = 1
            If Appui(i) = True Then 'test si noeud est un appui
                i3 = (i - 1) * 3
                If R_appui(1, i) = False Then
                    'Dplacement non autorise suivant X -> Ux=0
                    For jj = 1 To 3 * Total_noeud
                        Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
                    Next
                    Kg(i3 + 1, i3 + 1) = 1 : Fapp(1, i) = 0
                End If
                If R_appui(2, i) = False Then
                    'Dplacement non autorise suivant Y -> Uy=0
                    For jj = 1 To 3 * Total_noeud
                        Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
                    Next
                    Kg(i3 + 2, i3 + 2) = 1 : Fapp(2, i) = 0
                End If
                If Type_probleme = 2 Then
                    'ce test n'est valable uniquement que pour les structures de type portique
                    If R_appui(6, i) = False Then
                        'Rotation non autorise  ->  ttaZ=0
                        For jj = 1 To 3 * Total_noeud
                            Kg(i3 + 3, jj) = 0 : Kg(jj, i3 + 3) = 0
                        Next
                        Kg(i3 + 3, i3 + 3) = 1 : Fapp(3, i) = 0
                    End If
                End If
            End If
        Next
    End Sub

    Public Sub Resol_2D(ByRef FN(,) As Double, ByVal Fapp(,) As Double, ByVal Kg(,) As Double, ByRef Dp(,) As Double, _
                        ByRef structure_OK As Boolean, ByVal i_pas As Integer)
        'Rsolution du systme linaire d'quation [K]*{U}={F}
        Dim i, j, jj As Integer
        Dim F(3 * Total_noeud), U(3 * Total_noeud) As Double
        Dim akg(3 * Total_noeud, 3 * Total_noeud) As Double
        ''affectation de tableaux
        For i = 1 To 3 * Total_noeud
            For j = 1 To 3 * Total_noeud
                akg(i, j) = Kg(i, j)
            Next
        Next
        'mise dans F du tableau FN
        jj = 0
        For i = 1 To Total_noeud
            If Appui(i) = True Then 'test si noeud est un appui
                For j = 1 To 3
                    jj = jj + 1
                    If Fapp(j, i) = 1 Then
                        'dplacement autorise sur l'appui suivant X ou Y ou rotation libre
                        F(jj) = FN(j, i)
                    Else
                        'dplacement non autoris suivant X ou Y ou rotation bloqu, F(jj)=0 pour forcer U(jj)=0
                        F(jj) = 0
                    End If
                Next
            Else
                For j = 1 To 3
                    jj = jj + 1
                    F(jj) = FN(j, i)
                Next
            End If

        Next
        Call Gauss_Pivot_Max(3 * Total_noeud, akg, F, U, structure_OK, i_pas)
        If structure_OK = False Then Exit Sub

        'mise du vecteur U dans DP
        jj = 0
        For i = 1 To Total_noeud
            For j = 1 To 3
                jj = jj + 1
                Dp(j, i) = U(jj)
            Next
        Next
        'affectation des rsultats
        'dplacements des noeuds dans le repre global
        For i = 1 To Total_noeud
            Depl(i_pas, i, 1) = Dp(1, i) : Depl(i_pas, i, 2) = Dp(2, i) : Depl(i_pas, i, 3) = Dp(3, i)
        Next
        Erase U, F, akg
    End Sub
    Public Sub Resultat(ByVal Dp(,) As Double, ByVal Rot(,) As Double, ByVal L() As Double, ByVal Kg0(,) As Double, _
                        ByVal FB(,) As Double, ByVal i_pas As Integer)
        'calcul des efforts dans les barres et des ractions d'appui
        Dim Efb(6, Total_element), FN(3, Total_noeud), Dpp(3), K1(3, 3), Tg(3, 3), L1(3, 3), A0, A1, X0, X1, Y0, Y1, F0, F1 As Double
        Dim i, ii, j, jj, jd, jf As Integer

        'Phase 1 : calcul des efforts dans les barres
        For i = 1 To Total_element
            'mise  zro de Efb
            For j = 1 To 6
                Efb(j, i) = 0
            Next
            'dplacement absolu des noeuds dans le repre local pour chaque lment
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            X0 = Dp(1, jd) * Rot(1, i) + Dp(2, jd) * Rot(2, i)
            Y0 = Dp(1, jd) * Rot(4, i) + Dp(2, jd) * Rot(5, i)
            A0 = Dp(3, jd)
            X1 = Dp(1, jf) * Rot(1, i) + Dp(2, jf) * Rot(2, i)
            Y1 = Dp(1, jf) * Rot(4, i) + Dp(2, jf) * Rot(5, i)
            A1 = Dp(3, jf)
            'calcul des dplacements relatifs
            Dpp(1) = X1 - X0
            Dpp(2) = Y1 - Y0 - A0 * L(i) 'relation valable car hypothse petit dplacement
            Dpp(3) = A1 - A0
            'calcul de la matrice K1 et L1: utilisation de la matrice de rigidit initiale sans la prise en compte 
            'des conditions aux limites
            j = 0
            For ii = 1 To 3
                For jj = 1 To 3
                    j = j + 1
                    K1(ii, jj) = Kg0(j, i)
                Next
            Next
            'matrice de transposition
            For ii = 1 To 3
                For jj = 1 To 3
                    Tg(ii, jj) = 0
                Next
                Tg(ii, ii) = -1
            Next
            Tg(3, 2) = -L(i)
            'calcul de la matrice L1
            Call Matmul(Tg, K1, L1)
            'Efforts dus aux dplacements
            For ii = 1 To 3
                F0 = 0 : F1 = 0
                For jj = 1 To 3
                    F0 = F0 + L1(ii, jj) * Dpp(jj)
                    F1 = F1 + K1(ii, jj) * Dpp(jj)
                Next
                Efb(ii, i) = Efb(ii, i) + F0
                Efb(ii + 3, i) = Efb(ii + 3, i) + F1
            Next
            'Ajout des termes dus aux forces sur les barres
            For ii = 1 To 6
                Efb(ii, i) = Efb(ii, i) + FB(ii, i)
            Next
        Next
        'efforts dans les barres ramen dans le repre local de la barre
        For i = 1 To Total_element
            eFBarre(i_pas, i, 1) = Efb(1, i) : eFBarre(i_pas, i, 2) = Efb(2, i) : eFBarre(i_pas, i, 3) = Efb(3, i)
            eFBarre(i_pas, i, 4) = Efb(4, i) : eFBarre(i_pas, i, 5) = Efb(5, i) : eFBarre(i_pas, i, 6) = Efb(6, i)
        Next
        '----------------------------------------------
        'phase 2 :  raction d'appui
        For ii = 1 To Total_noeud
            For jj = 1 To 3
                FN(jj, ii) = 0
            Next
        Next
        'boucle sur les barres: dtermination des efforts nodaux - repre global
        For i = 1 To Total_element
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            FN(1, jd) = FN(1, jd) + Rot(1, i) * Efb(1, i) + Rot(4, i) * Efb(2, i)
            FN(2, jd) = FN(2, jd) + Rot(2, i) * Efb(1, i) + Rot(5, i) * Efb(2, i)
            FN(3, jd) = FN(3, jd) + Efb(3, i)
            FN(1, jf) = FN(1, jf) + Rot(1, i) * Efb(4, i) + Rot(4, i) * Efb(5, i)
            FN(2, jf) = FN(2, jf) + Rot(2, i) * Efb(4, i) + Rot(5, i) * Efb(5, i)
            FN(3, jf) = FN(3, jf) + Efb(6, i)
        Next
        'affectation des rsultats
        'ractions d'appui dans le repre global: calcul par le cumul des efforts nodaux sur le noeuds et sosutrait
        'des ventuels efforts appliqus directemnt aux noeuds
        For i = 1 To Total_noeud
            If Appui(i) = True Then
                FNodal(i_pas, i, 1) = FN(1, i) - ForPN(1, i, i_pas)
                FNodal(i_pas, i, 2) = FN(2, i) - ForPN(2, i, i_pas)
                FNodal(i_pas, i, 3) = FN(3, i) - CplePN(i, i_pas)
            End If
        Next

        Erase Efb, FN, Dpp, K1, Tg, L1

    End Sub
    Private Sub Combinaison()
        Dim N_comb1, i, i_pas, j, total As Integer
        total = 0 : For i = 1 To 4 : total = total + Total_cas_de_charge(i) : Next i
        'calcul sur les combinaisons
        For i_pas = total + 1 To total + Total_combinaison(1)
            N_comb1 = i_pas - total '= N de combinaison
            For j = 1 To dim_Cas_comb(N_comb1) 'balayage du vecteur ensemble des cas pour la comb i
                'coef_pond(N de comb, N de cas de charge)
                For i = 1 To Total_noeud
                    'dplacements des noeuds dans le repre global
                    Depl(i_pas, i, 1) = Depl(i_pas, i, 1) + Depl(Cas_comb(j, N_comb1), i, 1) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    Depl(i_pas, i, 2) = Depl(i_pas, i, 2) + Depl(Cas_comb(j, N_comb1), i, 2) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    Depl(i_pas, i, 3) = Depl(i_pas, i, 3) + Depl(Cas_comb(j, N_comb1), i, 3) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    'ractions d'appui dans le repre global
                    FNodal(i_pas, i, 1) = FNodal(i_pas, i, 1) + FNodal(Cas_comb(j, N_comb1), i, 1) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 2) = FNodal(i_pas, i, 2) + FNodal(Cas_comb(j, N_comb1), i, 2) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 3) = FNodal(i_pas, i, 3) + FNodal(Cas_comb(j, N_comb1), i, 3) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                Next
                'efforts dans les barres dans le repre local de la barre
                For i = 1 To Total_element
                    eFBarre(i_pas, i, 1) = eFBarre(i_pas, i, 1) + eFBarre(Cas_comb(j, N_comb1), i, 1) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 2) = eFBarre(i_pas, i, 2) + eFBarre(Cas_comb(j, N_comb1), i, 2) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 3) = eFBarre(i_pas, i, 3) + eFBarre(Cas_comb(j, N_comb1), i, 3) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 4) = eFBarre(i_pas, i, 4) + eFBarre(Cas_comb(j, N_comb1), i, 4) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 5) = eFBarre(i_pas, i, 5) + eFBarre(Cas_comb(j, N_comb1), i, 5) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 6) = eFBarre(i_pas, i, 6) + eFBarre(Cas_comb(j, N_comb1), i, 6) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                Next
            Next
        Next
    End Sub
    Private Sub Gauss_Pivot_Max(ByVal n As Integer, ByVal Akg(,) As Double, ByVal F() As Double, ByRef U() As Double, _
     ByRef structure_OK As Boolean, ByVal i_pas As Integer)
        ' RESOLUTION DE SYSTEME LINEAIRE par la METHODE DE LA TRIANGULATION DE GAUSS AVEC RECHERCHE DU PIVOT MAXIMUM
        ' "PREMIER MEMBRE DU SYSTEME : MATRICE A"
        '"SECOND  MEMBRE DU SYSTEME : MATRICE B"
        'matrice de dimension nxn
        Dim msg As String
        Dim i, j, L, Lmax, k, ns As Integer
        Dim m, S, m1, A(n, n), B(n) As Double
        For i = 1 To n
            B(i) = F(i)
            For j = 1 To n
                A(i, j) = Akg(i, j)
            Next
        Next
        ns = n
        For k = 1 To ns - 1
            m = A(k, k)
            Lmax = k
            For L = k + 1 To ns
                If Abs(A(L, k)) >= Abs(m) Then
                    m = A(L, k)
                    Lmax = L
                End If
            Next L
            If Abs(m) < 9.999999E-21 Then 'pivot nul
                msg = "Cas n" & CStr(i_pas) & " - calcul du terme diagonal n" & CStr(k) & vbCrLf & _
                                " matrice de rigidit singulire"
                MsgBox(msg, style, title)
                structure_OK = False
                Exit Sub
            End If
            If Lmax <> k Then
                If Abs(A(Lmax, k)) >= 10 * Abs(A(k, k)) Then
                    For L = k To ns
                        m1 = A(k, L)
                        A(k, L) = A(Lmax, L)
                        A(Lmax, L) = m1
                    Next
                    m1 = B(k)
                    B(k) = B(Lmax)
                    B(Lmax) = m1
                End If
            End If
            For i = k + 1 To ns
                B(i) = B(i) - A(i, k) / A(k, k) * B(k)
                For j = k + 1 To ns
                    A(i, j) = A(i, j) - A(i, k) / A(k, k) * A(k, j)
                Next j
            Next i
        Next k
        '
        'CALCUL DES SOLUTIONS
        '
        If Abs(A(ns, ns)) < 9.999999E-21 Then 'pivot nul
            msg = "Cas n" & CStr(i_pas) & " - calcul du dernier terme diagonal" & vbCrLf & _
                        " matrice de rigidit singulire"
            MsgBox(msg, style, title)
            structure_OK = False
            Exit Sub
        End If
        U(ns) = B(ns) / A(ns, ns)
        For i = ns - 1 To 1 Step -1
            S = 0
            For k = i + 1 To ns
                S = S + A(i, k) * U(k)
            Next k
            U(i) = (B(i) - S) / A(i, i)
        Next i
        Erase A, B
    End Sub
    Public Sub Result_intermediaire(ByVal i_pas As Integer, ByRef Mfz(,) As Double, ByRef Tfy(,) As Double, ByRef Mmax As Double, _
                                    ByRef Tfmax As Double, ByRef Fle(,) As Double, ByRef Flmax As Double)
        Dim i, j, k, cas, n, nMax As Integer
        Dim (), T(), fl() As Double
        Dim a, b0, L, x As Double
        Tfmax = 0 : Mmax = 0 : Flmax = 0 : nMax = 0
        For i = 1 To Total_element
            a = X_noe(Ele(2, i)) - X_noe(Ele(1, i))
            b0 = Y_noe(Ele(2, i)) - Y_noe(Ele(1, i))
            L = Sqrt(a ^ 2 + b0 ^ 2) 'longueur de l'lment
            n = CInt(Fix(L / 0.1))
            If n > nMax Then nMax = n
        Next
        ReDim Mfz(Total_element, nMax + 1), Tfy(Total_element, nMax + 1), Fle(Total_element, nMax + 1) 'ReDim (n + 1), T(n + 1), fl(n + 1)
        For i = 1 To Total_element
            a = X_noe(Ele(2, i)) - X_noe(Ele(1, i))
            b0 = Y_noe(Ele(2, i)) - Y_noe(Ele(1, i))
            L = Sqrt(a ^ 2 + b0 ^ 2) 'longueur de l'lment
            n = CInt(Fix(L / 0.1))
            ReDim (n + 1), T(n + 1), fl(n + 1)
            Call Charge_travee_Iso(i, i_pas, L, T, , fl)
            n = 0
            Mfz(i, n) = eFBarre(i_pas, i, 3) : Tfy(i, n) = -eFBarre(i_pas, i, 2)
            x = 0.1
            Do
                n = n + 1
                Tfy(i, n) = T(n) - (eFBarre(i_pas, i, 3) + eFBarre(i_pas, i, 6)) / L
                If Abs(Tfy(i, n)) > Tfmax Then Tfmax = Abs(Tfy(i, n))
                Mfz(i, n) = (n) + eFBarre(i_pas, i, 3) * (1 - x / L) - eFBarre(i_pas, i, 6) * x / L
                If Abs(Mfz(i, n)) > Mmax Then Mmax = Abs(Mfz(i, n))
                Fle(i, n) = fl(n) + eFBarre(i_pas, i, 3) * (x * (L - x) * (2 * L - x)) / (6 * L * Ey(i) * Iy(i)) - eFBarre(i_pas, i, 6) * (x * (L - x) * (L + x)) / (6 * L * Ey(i) * Iy(i))
                If Abs(Fle(i, n)) > Flmax Then Flmax = Abs(Fle(i, n))
                x = x + 0.1
            Loop While x <= L + 0.09
        Next
    End Sub
    Private Sub Charge_travee_Iso(ByVal j As Integer, ByVal n_cas As Integer, ByVal L As Double, ByRef T() As Double, ByRef () As Double, ByRef fl() As Double)
        'Variables:
        '   j = n de l'lment
        '   n_cas = n de cas de charge ou de combinaison
        '   L = longueur de l'lment j
        '   T = effort tranchant
        '    = moment de flexion
        '   Coef_pond(incrment i, N de combinaison)= coefficient de pondration s'appliquant au cas de charge i de la combinaison j
        '   Cas_comb(indice d'ordre dans le vecteur colonne dim_Cas_comb, N de combinaison) = N de cas de charge sur lequel s'applique le I ieme coefficient de pondration pour la combinaison j
        '   dim_Cas_comb(N_comb)= nombre total de coefficient de pondration pour la combinaison N_comb = nbre de cas de charge dans la combinaison

        Dim a, b, C, P, P1, P2, Va, Vd, x, coef_ponderation(), w0, wC As Double
        Dim msg As String
        Dim i, i1, k, n, total, total_n, K_charge() As Integer
        total_n = CInt(L / 0.1) + 1
        Dim 1(total_n), T1(total_n), 2(total_n), T2(total_n), fl1(total_n), fl2(total_n) As Double
        total = 0 : For i = 1 To 4 : total = total + Total_cas_de_charge(i) : Next i
        'calcul sur les cas de charges ou les combinaisons
        If n_cas < total Then 'n_cas est un cas de charge
            i1 = 1
            ReDim coef_ponderation(1), K_charge(1)
            coef_ponderation(1) = 1 : K_charge(1) = n_cas
        Else
            i1 = dim_Cas_comb(n_cas) 'nbre total de cas de charge dans la combinaison n_cas
            ReDim coef_ponderation(i1), K_charge(i1)
            For i = 1 To i1
                coef_ponderation(i) = Coef_pond(i, n_cas) : K_charge(i) = Cas_comb(i, n_cas)
            Next
        End If

        For i = 1 To i1
            ReDim 1(total_n), T1(total_n), fl1(total_n), 2(total_n), T2(total_n), fl2(total_n) 'rinitialisation
            'forces ponctuelles sur lment
            'force //  X local (parallle  la barre)-->  Effort normal

            'force //  Y local (perpendiculaire  la barre)-->  Effort tranchant et moment de flexion
            For k = 1 To Total_ForP(2, j, K_charge(i))
                a = a_ForP(2, j, k, K_charge(i)) : P = ForP(2, j, k, K_charge(i)) * coef_ponderation(i)
                x = 0.1 : n = 1 : Va = P * (1 - a / L)
                Do
                    Select Case x
                        Case Is <= a
                            T1(n) = T1(n) + Va
                            1(n) = 1(n) + P * x * (1 - a / L)
                            fl1(n) = fl1(n) + ((P * x * (1 - a / L) * (x ^ 2 - 2 * a * L + a ^ 2)) / (6 * Ey(j) * Iy(j)))
                        Case Else
                            T1(n) = T1(n) + (Va - P)
                            1(n) = 1(n) + P * a * (1 - x / L)
                            fl1(n) = fl1(n) + ((P * a * (1 - x / L) * (a ^ 2 - 2 * x * L + x ^ 2)) / (6 * Ey(j) * Iy(j)))
                    End Select
                    n = n + 1
                    x = x + 0.1
                Loop While x < L + 0.09 'pour tenir compte des erreurs d'arrondis
            Next
            'forces rparties sur lment
            'force //  X local (parallle  la barre)-->  Effort normal 

            'force //  Y local (perpendiculaire  la barre) -->  Effort tranchant et moment de flexion
            For k = 1 To Total_ForL(2, j, K_charge(i))
                a = a_ForL(2, j, k, K_charge(i)) : C = L - b_ForL(2, j, k, K_charge(i)) : b = b_ForL(2, j, k, K_charge(i)) - a
                P1 = ForL1(2, j, k, K_charge(i)) : P2 = ForL2(2, j, k, K_charge(i))
                P1 = P1 * coef_ponderation(i) : P2 = P2 * coef_ponderation(i)
                P = (P1 + P2) * b / 2
                Va = b * (P1 * (2 * b + 3 * C) + P2 * (b + 3 * C)) / (6 * L)
                Vd = Va - P
                w0 = (b ^ 3 * (P1 * (4 * b + 15 * C) + P2 * (b + 5 * C)) / (120 * L) + Vd * C ^ 3 / (3 * L) - Va * (a + b) ^ 2 * (L + 2 * C) / (6 * L)) / (Ey(j) * Iy(j))
                wC = w0 - (3 * P1 + P2) * b ^ 3 / (24 * Ey(j) * Iy(j)) + Va * (a + b) ^ 2 / (2 * Ey(j) * Iy(j))
                x = 0.1 : n = 1
                Do
                    Select Case x
                        Case Is <= a
                            T2(n) = T2(n) + Va
                            2(n) = 2(n) + Va * x
                            fl2(n) = fl2(n) + Va * x ^ 3 / (6 * Ey(j) * Iy(j)) + w0 * x
                        Case Is <= a + b
                            T2(n) = T2(n) + (Va - P1 * (x - a) - ((P2 - P1) * (x - a) ^ 2 / (2 * b)))
                            2(n) = 2(n) + (Va * x - P1 * (x - a) ^ 2 / 2 - ((P2 - P1) * (x - a) ^ 3 / (6 * b)))
                            fl2(n) = fl2(n) + Va * x ^ 3 / (6 * Ey(j) * Iy(j)) + w0 * x - P1 * (x - a) ^ 4 / (24 * Ey(j) * Iy(j)) - (P2 - P1) * (x - a) ^ 5 / (120 * b * Ey(j) * Iy(j))
                        Case Else
                            T2(n) = T2(n) + Vd
                            2(n) = 2(n) + Vd * (x - L)
                            fl2(n) = fl2(n) + Vd * (x - L) ^ 3 / (6 * Ey(j) * Iy(j)) + (Ey(j) * Iy(j) * wC - Vd * C ^ 2 / 2) * (x - L) / (Ey(j) * Iy(j))
                    End Select
                    n = n + 1
                    x = x + 0.1
                Loop While x < L + 0.09 'pour tenir compte des erreurs d'arrondis
            Next
            'addition des efforts tranchants et moments de flexions dus aux forces ponctuelles et rparties
            n = 1
            Do
                T(n) = T(n) + T1(n) + T2(n)
                (n) = (n) + 1(n) + 2(n)
                fl(n) = fl(n) + fl1(n) + fl2(n)
                n = n + 1
            Loop While n < total_n
        Next

    End Sub
    Private Sub poubelle()
        'Public Sub C_Limit_Kg(ByRef Kg(,) As Double, ByRef Fapp(,) As Double, ByRef structure_OK As Boolean)
        '    'Prise en compte des conditions d'appui et des relaxations
        '    Dim i, ii, i3, j, jj As Integer
        '    Dim msg As String
        '    Select Case Type_probleme
        '        Case 1 'treillis plan
        '            For i = 1 To Total_noeud
        '                If Appui(i) = True Then 'test si noeud est un appui
        '                    i3 = (i - 1) * 3
        '                    If (R_appui(1, i) = True Or R_appui(7, i) = True) Then
        '                        'Dplacement autorise suivant X
        '                        For jj = 1 To 3 * Total_noeud
        '                            Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
        '                        Next
        '                        Kg(i3 + 2, i3 + 2) = 1

        '                    ElseIf (R_appui(2, i) = True Or R_appui(8, i) = True) Then
        '                        'Dplacement autorise suivant Y
        '                        For jj = 1 To 3 * Total_noeud
        '                            Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
        '                        Next
        '                        Kg(i3 + 1, i3 + 1) = 1

        '                    Else
        '                        'aucun Dplacement autorise 
        '                        For ii = 1 To 2
        '                            For jj = 1 To 3 * Total_noeud
        '                                Kg(i3 + ii, jj) = 0 : Kg(jj, i3 + ii) = 0
        '                            Next
        '                        Next
        '                        'mise d'un 1 sur la diagonale
        '                        For ii = 1 To 2
        '                            Kg(i3 + ii, i3 + ii) = 1
        '                        Next
        '                    End If

        '                End If
        '            Next
        '        Case 2 'portique plan
        '            For i = 1 To Total_noeud
        '                Fapp(1, i) = 1 : Fapp(2, i) = 1 : Fapp(3, i) = 1
        '                If Appui(i) = True Then 'test si noeud est un appui
        '                    i3 = (i - 1) * 3
        '                    Select Case n_barre_appui(i)
        '                        Case 1 '1 barre sur l'appui
        '                            If R_appui(1, i) = False Then
        '                                'Dplacement non autorise suivant X -> Ux=0
        '                                For jj = 1 To 3 * Total_noeud
        '                                    Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
        '                                Next
        '                                Kg(i3 + 1, i3 + 1) = 1 : Fapp(1, i) = 0
        '                            End If
        '                            If R_appui(2, i) = False Then
        '                                'Dplacement non autorise suivant Y -> Uy=0
        '                                For jj = 1 To 3 * Total_noeud
        '                                    Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
        '                                Next
        '                                Kg(i3 + 2, i3 + 2) = 1 : Fapp(2, i) = 0
        '                            End If
        '                            If R_appui(3, i) = False Then
        '                                'Rotation non autorise  -> Rz=0
        '                                For jj = 1 To 3 * Total_noeud
        '                                    Kg(i3 + 3, jj) = 0 : Kg(jj, i3 + 3) = 0
        '                                Next
        '                                Kg(i3 + 3, i3 + 3) = 1 : Fapp(3, i) = 0
        '                            End If

        '                        Case Is > 1 'plusieurs barres sur appuis et les barres peuvent tre encastres les unes
        '                            ' sur les autres comme dans le cas d'une poutre continue
        '                            If R_appui(1, i) = False Then
        '                                'Dplacement non autorise suivant X -> Ux=0
        '                                For jj = 1 To 3 * Total_noeud
        '                                    Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
        '                                Next
        '                                Kg(i3 + 1, i3 + 1) = 1 : Fapp(1, i) = 0
        '                            End If
        '                            If R_appui(2, i) = False Then
        '                                'Dplacement non autorise suivant Y -> Uy=0
        '                                For jj = 1 To 3 * Total_noeud
        '                                    Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
        '                                Next
        '                                Kg(i3 + 2, i3 + 2) = 1 : Fapp(2, i) = 0
        '                            End If
        '                            'If (R_appui(1, i) = True Or R_appui(7, i) = True) And (R_appui(2, i) = False And R_appui(8, i) = False) Then
        '                            '    'Dplacement autorise suivant X uniquement, on conserve la ligne et la colonne correspondant
        '                            '    ' Ux car Ux est different de 0. Par contre, Fn=0
        '                            '    For jj = 1 To 3 * Total_noeud
        '                            '        Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
        '                            '    Next
        '                            '    Kg(i3 + 2, i3 + 2) = 1

        '                            'ElseIf (R_appui(1, i) = False And R_appui(7, i) = False) And (R_appui(2, i) = True Or R_appui(8, i) = True) Then
        '                            '    'Dplacement autorise suivant Y uniquement
        '                            '    For jj = 1 To 3 * Total_noeud
        '                            '        Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
        '                            '    Next
        '                            '    Kg(i3 + 1, i3 + 1) = 1

        '                            'ElseIf R_appui(1, i) = True And R_appui(2, i) = True Then
        '                            '    'Dplacement autorise suivant X et Y
        '                            '    msg = "En modlisation 2D, vous ne pouvez pas dfinir un noeud APPUI avec des dplacements " & vbCrLf & _
        '                            '          "libres suivant X et Y simultanment. Votre noeud appui n'a pas de sens physique " & vbCrLf & _
        '                            '          "pour une structure de Gnie Civil. L' appui ne comporte aucune raction --> ILLOGIQUE" & vbCrLf & _
        '                            '          "Veuillez modifier votre modlisation de structure !"
        '                            '    MsgBox(msg, style, title)
        '                            '    structure_OK = False
        '                            '    Exit Sub

        '                            'ElseIf R_appui(1, i) = False And R_appui(2, i) = False Then
        '                            '    'Dplacement interdit suivant X et Y
        '                            '    For jj = 1 To 3 * Total_noeud
        '                            '        Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
        '                            '        Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
        '                            '    Next
        '                            '    Kg(i3 + 1, i3 + 1) = 1 : Kg(i3 + 2, i3 + 2) = 1

        '                            'ElseIf R_appui(7, i) = True And R_appui(8, i) = True Then
        '                            '    'A voir pour 2 dplacements lastiques autoriss
        '                            '    Stop

        '                            'End If
        '                            'ii = 0
        '                            'For j = 1 To Total_element
        '                            '    If Ele(1, j) = i Then 'si le noeud 1 de l'lment j est l'appui i
        '                            '        If Rel_ele(1, j) = False Then 'le noeud 1 de l'lment j est dfini encastr
        '                            '            ii = ii + 1
        '                            '        End If
        '                            '    ElseIf Ele(2, j) = i Then 'si le noeud 2 de l'lment j est l'appui i
        '                            '        If Rel_ele(2, j) = False Then
        '                            '            ii = ii + 1
        '                            '        End If
        '                            '    End If
        '                            'Next
        '                            'If ii > 1 Then
        '                            '    'on conserve la ligne et la colonne correspondant au moment, ce dernier est un
        '                            '    'constituant interne de la structure
        '                            'Else
        '                            '    For jj = 1 To 3 * Total_noeud
        '                            '        Kg(i3 + 3, jj) = 0 : Kg(jj, i3 + 3) = 0
        '                            '    Next
        '                            '    'mise d'un 1 sur la diagonale
        '                            '    Kg(i3 + 3, i3 + 3) = 1
        '                            'End If
        '                    End Select
        '                End If
        '            Next
        '    End Select

        ''--> Module de dbogage:
        '''affichage dans le fichier de dtails du calcul des dplacements des noeuds
        'msgg = msgg & "Dplacements des noeuds:" & vbCrLf
        'msgg = msgg & "Noeud     Depl. X          Depl. Y            rotation" & vbCrLf
        'Dim F_i, F_dp(3, Total_noeud) As String
        'For i = 1 To Total_noeud
        '    F_dp(1, i) = Format(Dp(1, i) * 1000, "###0.0") : F_dp(2, i) = Format(Dp(2, i) * 1000, "###0.0")
        '    F_i = Format(i, "##") : F_dp(3, i) = Format(Dp(3, i), "###0.0")
        '    msgg = msgg & F_i & "   " & F_dp(1, i) & "   " & F_dp(2, i) & "     " & F_dp(3, i) & vbCrLf
        'Next
        'msgg = msgg & vbCrLf 'permet de passer  la ligne suivante

        ''--> Module de dbogage:
        '''affichage dans le fichier de dtails du calcul des efforts dans les barres et des ractions d'appui
        'Dim F_i, F_efb(6, Total_element), F_fn(3, Total_noeud) As String
        'msgg = msgg & "Efforts dans les barres:" & vbCrLf & _
        '"Barre      Normal      Tranchant   Flexion      Normal      Tranchant     Flexion" & vbCrLf
        'For i = 1 To Total_element
        '    F_efb(1, i) = Format(Efb(1, i), "###0.0") : F_efb(2, i) = Format(Efb(2, i), "###0.0")
        '    F_i = Format(i, "##") : F_efb(3, i) = Format(Efb(3, i), "###0.0")
        '    F_efb(4, i) = Format(Efb(4, i), "###0.0") : F_efb(5, i) = Format(Efb(5, i), "###0.0") : F_efb(6, i) = Format(Efb(6, i), "###0.0")
        '    msgg = msgg & F_i & "   " & F_efb(1, i) & "   " & F_efb(2, i) & "     " & F_efb(3, i) & "   " & F_efb(4, i) & "   " & F_efb(5, i) & "     " & F_efb(6, i) & vbCrLf
        'Next
        'msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'msgg = msgg & "Raction des appuis:" & vbCrLf & _
        '       "Noeuds      Force X      Force Y      Moment Z" & vbCrLf
        'For i = 1 To Total_noeud
        '    If Appui(i) = True Then
        '        F_fn(1, i) = Format(FN(1, i), "###0.0") : F_fn(2, i) = Format(FN(2, i), "###0.0")
        '        F_i = Format(i, "##") : F_fn(3, i) = Format(FN(3, i), "###0.0")
        '        msgg = msgg & F_i & "   " & F_fn(1, i) & "   " & F_fn(2, i) & "     " & F_fn(3, i) & vbCrLf
        '    End If
        'Next
        'msgg = msgg & vbCrLf 'permet de passer  la ligne suivante

        ''--> Module de dbogage:
        ''''affichage dans le fichier de dtails du calcul de la matrice globale Kg
        'Dim F_kg(3 * Total_noeud, 3 * Total_noeud) As String
        'msgg = msgg & "Matrice globale de rigidit Kg:" & vbCrLf
        'For i = 1 To 3 * Total_noeud
        '    For j = 1 To 3 * Total_noeud
        '        F_kg(i, j) = Format(Kg(i, j), "###0.0")
        '        msgg = msgg & "  " & F_kg(i, j)
        '    Next
        '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'Next
        'msgg = msgg & "FN" & vbCrLf




        'Public Sub Resol(ByRef FN(,) As Double, ByVal Kg(,) As Double, ByRef Dp(,) As Double, ByRef structure_OK As Boolean, ByVal i_pas As Integer)
        '    'Rsolution du systme linaire d'quation [K]*{U}={F}
        ''phase 1: triangularisation de la matrice
        'n3 = 3 * Total_noeud
        'nm3 = n3 - 1
        'For i = 1 To nm3
        '    'test si terme diagonal non nul
        '    If Abs(akg(i, i)) < 0.00000001 Then
        '        msg = "Cas n" & CStr(i_pas) & " - calcul du terme diagonal n" & CStr(i) & vbCrLf & _
        '        " matrice de rigidit singulire"
        '        MsgBox(msg, style, title)
        '        structure_OK = False
        '        Exit Sub
        '    End If
        '    'calcul des termes sur ligne j
        '    ip1 = i + 1
        '    For j = ip1 To n3
        '        F(j) = F(j) - (akg(j, i) / akg(i, i)) * F(i)
        '        'boucle sur les termes de la ligne j
        '        For k = ip1 To n3
        '            akg(j, k) = akg(j, k) - (akg(j, i) / akg(i, i)) * akg(i, k)
        '        Next
        '        akg(j, i) = 0
        '    Next
        'Next
        ''calcul du dernier terme
        ''test si terme diagonal non nul
        'If Abs(akg(n3, n3)) < 0.00000001 Then
        '    msg = "Cas n" & CStr(i_pas) & " - calcul du dernier terme diagonal" & vbCrLf & _
        '    " matrice de rigidit singulire"
        '    MsgBox(msg, style, title)
        '    structure_OK = False
        '    Exit Sub
        'End If
        'U(n3) = F(n3) / akg(n3, n3)
        ''phase2 : rsolution du systme
        'For jj = 1 To n3
        '    i = n3 - jj
        '    'calcul de U(i)
        '    U(i) = F(i) / akg(i, i)
        '    ip1 = i + 1
        '    For j = ip1 To n3
        '        U(i) = U(i) - akg(i, j) * U(j) / akg(i, i)
        '    Next
        'Next
        'End Sub

        'Public Sub C_Limit_FN(ByRef FN(,) As Double)
        '    'Prise en compte des conditions d'appui et des relaxations pour l'tablissement du vecteur Force
        '    Dim i, ii, i3, j, jj As Integer
        '    Select Case Type_probleme
        '        Case 1 'treillis plan
        '            '        For i = 1 To Total_noeud
        '            '            If Appui(i) = True Then 'test si noeud est un appui
        '            '                'mise  zero du vecteur force
        '            '                For ii = 1 To 3
        '            '                    FN(ii, i) = 0
        '            '                Next
        '            '            End If
        '            '        Next
        '        Case 2 'portique plan
        '            For i = 1 To Total_noeud
        '                If Appui(i) = True Then 'test si noeud est un appui
        '                    If R_appui(2, i) = False Then FN(2, i) = 0
        '                    If R_appui(1, i) = False Then FN(1, i) = 0
        '                    'FN(2, i) = 0 : FN(3, i) = 0

        '                    '                'mise  zero du vecteur force
        '                    '                Select Case n_barre_appui(i)
        '                    '                    Case 1 '1 barre sur l'appui
        '                    '                        If R_appui(2, i) = True Or R_appui(8, i) = True Then
        '                    '                            FN(1, i) = 0 : FN(3, i) = 0
        '                    '                        ElseIf R_appui(1, i) = True Or R_appui(7, i) = True Then
        '                    '                            FN(2, i) = 0 : FN(3, i) = 0
        '                    '                        Else
        '                    '                            For ii = 1 To 3
        '                    '                                FN(ii, i) = 0
        '                    '                            Next
        '                    '                        End If


        '                    '                    Case Is > 1 'plusieurs barres sur appuis et les barres sont encastres les unes sur les 
        '                    '                        'autres, cas de la poutre continue
        '                    '                        'le test ci-dessous verifie qu'au moins 2 barres sont encastres entr-elles sur l'appui
        '                    '                        'dans ce cas, FN(3,i)<>0 sinon le noeud est considr compltement articule et
        '                    '                        'FN(3,i)=0. Ceci est logique car il ne peut dvelopper de moment, le noeud tant libre de
        '                    '                        'de tourner.
        '                    '                        ii = 0
        '                    '                        For j = 1 To Total_element
        '                    '                            If Ele(1, j) = i Then 'si le noeud 1 de l'lment j est l'appui i
        '                    '                                If Rel_ele(1, j) = False Then 'le noeud 1 de l'lment j est dfini encastr
        '                    '                                    ii = ii + 1
        '                    '                                End If
        '                    '                            ElseIf Ele(2, j) = i Then 'si le noeud 2 de l'lment j est l'appui i
        '                    '                                If Rel_ele(2, j) = False Then
        '                    '                                    ii = ii + 1
        '                    '                                End If
        '                    '                            End If
        '                    '                        Next
        '                    '                        If ii > 1 Then
        '                    '                            '2 barres sont au moins encastres l'une sur l'autre;dans ce cas, FN(3,i)<>0
        '                    '                            If R_appui(2, i) = True Or R_appui(8, i) = True Then
        '                    '                                'FN(1, i) = 0
        '                    '                            ElseIf R_appui(1, i) = True Or R_appui(7, i) = True Then
        '                    '                                'FN(2, i) = 0
        '                    '                            Else
        '                    '                                For ii = 1 To 2
        '                    '                                    FN(ii, i) = 0
        '                    '                                Next
        '                    '                            End If
        '                    '                        Else
        '                    '                            'l'appui comporte plusieurs barres mais toutes les barres sont articules.
        '                    '                            For ii = 1 To 3
        '                    '                                FN(ii, i) = 0
        '                    '                            Next
        '                    '                        End If
        '                    '                End Select
        '                End If
        '            Next
        '    End Select


        '    ''--> Module de dbogage:
        '    ''''affichage dans le fichier de dtails du calcul de 
        '    'msgg = msgg & "FN" & vbCrLf
        '    'Dim F_fn(3, Total_noeud) As String
        '    'For j = 1 To Total_noeud
        '    '    For i = 1 To 3
        '    '        F_fn(i, j) = Format(FN(i, j), "###0.0")
        '    '        msgg = msgg & "  " & F_fn(i, j)
        '    '    Next
        '    '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        '    'Next
        'End Sub
    End Sub
End Module
