Imports System.Math
Imports System.IO
Module Lineaire_3D
    'Variables publiques  l'ensemble du module
    Dim title As String = "STRUCTURE : module de calcul Analyse Lineaire 3D"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly
    Dim msgg As String
    Public Sub Analyse_Lineaire_3D(ByRef structure_OK As Boolean, ByRef Kg(,) As Double, ByRef kg0(,) As Double, _
                                    ByRef L() As Double, ByRef Rot(,) As Double, ByVal j1 As Integer, ByVal j2 As Integer)
        'j1 et j2 sont les indices pour les cas de charges non linaires
        'nouvelles variables
        Dim i, total As Integer
        Dim FN(6, Total_noeud) As Double
        Dim FB(12, Total_element), Dp(6, Total_noeud) As Double
        Dim Fapp(6, Total_noeud) As Double
        Call Matrice_Rigidite_3D(Kg, L, Rot, kg0)
        Call Appui_elastique_3D(Kg)
        'dtermination des ractions d'appui, des efforts sur les barres et des dplacements pour chaque cas de charge
        For i = Total_cas_de_charge(j1) + 1 To Total_cas_de_charge(j1) + Total_cas_de_charge(j2)
            Select Case Type_probleme
                Case 3 'treillis spatial
                    Call Second_Membre_Treillis_spatial(L, FN, i)
                Case 4 'portique spatial
                    'calcul du vecteur force sans prise en compte de l'effort tranchant
                    'Call Second_Membre_Portique_spatial(L, Rot, FN, FB, i)
                    'Call Second_Membre(L, Rot, FN, FB, i, 1)
            End Select
            Call C_Limit_3D(Kg, FN)
            Call Resol_3D(FN, Fapp, Kg, Dp, structure_OK, i)
            If structure_OK = False Then
                '--> Debogage de l'application:
                'sw.Write(msgg) : sw.Close()
                Exit Sub
            End If
            Call Resultat(Dp, Rot, L, kg0, FB, i)
        Next
        'Sommation des lments prcdements dtermins (efforts nodaux, dplacements,efforts sur les lments) 
        'suivant les valeurs de la combinaison: application du principe de superposition
        Call Combinaison()
        Erase FN, FB, Dp ', Sr, Fapp

    End Sub
    Public Sub Matrice_Rigidite_3D(ByRef Kg(,) As Double, ByRef L() As Double, ByRef Rot(,) As Double, ByRef Kg0(,) As Double)
        Dim i, j, jD, jF, k, k11 As Integer
        Dim a, alpha, beta, b0, c0, d1, d2, long1, x1, x2 As Double
        Dim k0(6, 6), Td(6, 6), Tg(6, 6), R(6, 6), Rt(6, 6) As Double
        Dim k1(6, 6), l0(6, 6), l1(6, 6), BB(6, 6) As Double
        Dim msg As String
        'Matrice de rigidit globale en repre global de la structure = Kg
        'Variables : kg0(36,total_element ) = matrice de rigidit locale pour tous les lments
        '            k0(6, 6) = matrice de rigidit suprieure gauche
        '            k1(6, 6) = matrice de rigidit infrieure droite
        '            l0(6, 6) = matrice de rigidit infrieure gauche
        '            l1(6, 6) = matrice de rigidit suprieure droite
        '            Td(6,6) = matrice de transformation droite
        '            Tg(6,6) = matrice de transformation gauche
        '            R(6, 6) = matrice de rotation
        '            Rt(6, 6) = transpos de la matrice de rotation

        'composition de toutes les matrices lmentaires, lment par lment
        '1- construction de la matrice de rigidit locale kg0
        For i = 1 To Total_element
            a = X_noe(Ele(2, i)) - X_noe(Ele(1, i))
            b0 = Y_noe(Ele(2, i)) - Y_noe(Ele(1, i))
            c0 = Z_noe(Ele(2, i)) - Z_noe(Ele(1, i))
            L(i) = Sqrt(a ^ 2 + b0 ^ 2 + c0 ^ 2) 'longueur de l'lment
            'calcul de l'angle Alpha: rotation autour de l'axe Z
            long1 = Sqrt(a ^ 2 + b0 ^ 2)
            If long1 = 0 Then
                d1 = 0 : d2 = 0
            Else
                d1 = Acos(a / long1)
                d2 = Asin(b0 / long1)
            End If
            'l'angle alpha doit tre compris entre 0 et 2pi ce qui oblige  la gymnastique ci-dessous sinon
            'l'angle allait tre compris entre 0 et pi ou pi/2 et -pi/2 suivant si le calcul tait fait en
            'cosinus ou sinus
            If a >= 0 And b0 >= 0 Then  'quadrant 1
                alpha = d1
            ElseIf a <= 0 And b0 >= 0 Then 'quadrant 2
                alpha = d1
            ElseIf a <= 0 And b0 <= 0 Then 'quadrant 3
                alpha = PI - d2  'd2 est ngatif
            ElseIf a >= 0 And b0 <= 0 Then 'quadrant 4
                alpha = 2 * PI + d2
            End If
            'Projection des nouvelles coordonnes dans le repre Ox1y1z1
            x1 = Cos(alpha) * X_noe(Ele(1, i)) + Sin(alpha) * Y_noe(Ele(1, i))
            x2 = Cos(alpha) * X_noe(Ele(2, i)) + Sin(alpha) * Y_noe(Ele(2, i))
            a = x2 - x1
            'calcul de l'angle beta: rotation autour de l'axe Y1
            long1 = Sqrt(a ^ 2 + c0 ^ 2)
            If long1 = 0 Then
                d1 = 0 : d2 = 0
            Else
                d1 = Acos(a / long1)
                d2 = Asin(c0 / long1)
            End If
            'l'angle beta doit tre compris entre 0 et 2pi ce qui oblige  la gymnastique ci-dessous sinon
            'l'angle allait tre compris entre 0 et pi ou pi/2 et -pi/2 suivant si le calcul tait fait en
            'cosinus ou sinus
            If a >= 0 And c0 >= 0 Then  'quadrant 1
                beta = d1
            ElseIf a <= 0 And c0 >= 0 Then 'quadrant 2
                beta = d1
            ElseIf a <= 0 And c0 <= 0 Then 'quadrant 3
                beta = PI - d2  'd2 est ngatif
            ElseIf a >= 0 And c0 <= 0 Then 'quadrant 4
                beta = 2 * PI + d2
            End If
            ' si element a tous ses noeuds encastrs alors Call K_3D_tout_encastre avec I constant ou variable
            If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                'If Inert_Variable(i) = True Then
                '    Select Case Type_profile(i)
                '        Case 1 'profil en I
                '            If H(1, i) <> H(2, i) Then 'inertie variable sur la hauteur du profil
                '                Call K_2D_tout_encastre_I_variable(i, alpha, L(i), Kg0, H(1, i), H(2, i), ea(i), es(i), B(i))
                '            Else
                '                msg = "Caractristiques de l'lment poutre en dehors du domaine" & vbCrLf & _
                '                "de modlisation du logiciel"
                '                MsgBox(msg, style, title)
                '                Exit Sub
                '            End If
                '        Case 2 'profil en tube rond
                '            msg = "Caractristiques de l'lment poutre en dehors du domaine" & vbCrLf & _
                '                                           "de modlisation du logiciel"
                '            MsgBox(msg, style, title)
                '            Exit Sub
                '        Case 3 'profil en tube rectangulaire
                '            msg = "Caractristiques de l'lment poutre en dehors du domaine" & vbCrLf & _
                '                                           "de modlisation du logiciel"
                '            MsgBox(msg, style, title)
                '            Exit Sub
                '    End Select
                'Else
                Call K_3D_tout_encastre(i, L(i), Kg0)
                'End If
            End If
            '' si noe 1 relax et noe 2 encastr 
            'If Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
            '    Call K_3D_gauche_relaxe(i, alpha, L(i), Kg0)
            'End If
            '' si noe 1 encastr et noe 2 relax alors Call R_2D_droit_relaxe(alpha, longueur)
            'If Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
            '    Call K_3D_droit_relaxe(i, alpha, L(i), Kg0)
            'End If
            ' si noe 1 relax et noe 2 relax
            If Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                Call K_3D_tout_relaxe(i, L(i), Kg0)
            End If
            Call Rotation(i, alpha, beta, Rot)
        Next i
        '2 - Assemblage de la matrice
        'mise  zro de la matrice de rigidit globale
        For i = 1 To 6 * Total_noeud
            For j = 1 To 6 * Total_noeud
                Kg(i, j) = 0
            Next
        Next
        'assemblage matrice
        For i = 1 To Total_element
            'assemblage matrice rigidit locale infrieure droite = k1
            j = 0
            For k = 1 To 6
                For k11 = 1 To 6
                    j = j + 1
                    k1(k, k11) = Kg0(j, i)
                Next
            Next
            'calcul des matrices transfert Td et Tg
            For k = 1 To 6
                For k11 = 1 To 6
                    Td(k, k11) = 0 : Tg(k, k11) = 0
                Next
                Td(k, k) = -1 : Tg(k, k) = -1
            Next
            Td(2, 6) = -L(i) : Td(3, 5) = L(i)
            Tg(6, 2) = -L(i) : Tg(5, 3) = L(i)
            ''--> Debogage de l'application: 
            ''    affichage dans le fichier de dtails du calcul de la matrice globale Tg et Td de l'lment
            'Dim F_tg(6, 6) As String
            'Dim i6, i7 As Integer
            'msgg = msgg & "Matrice Tg:" & vbCrLf
            'For i6 = 1 To 6
            '    For i7 = 1 To 6
            '        F_tg(i6, i7) = Format(Tg(i6, i7), "###0.00")
            '        msgg = msgg & "  " & F_tg(i6, i7)
            '    Next
            '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
            'Next
            'msgg = msgg & vbCrLf
            'msgg = msgg & "Matrice Td:" & vbCrLf
            'For i6 = 1 To 6
            '    For i7 = 1 To 6
            '        F_tg(i6, i7) = Format(Td(i6, i7), "###0.00")
            '        msgg = msgg & "  " & F_tg(i6, i7)
            '    Next
            '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
            'Next
            'msgg = msgg & vbCrLf

            'mise de rot dans R et Rt
            j = 0
            For k = 1 To 6
                For k11 = 1 To 6
                    j = j + 1
                    R(k, k11) = Rot(j, i) : Rt(k11, k) = Rot(j, i)
                Next
            Next
            ''--> Debogage de l'application: 
            ''    affichage dans le fichier de dtails du calcul des matrices de rotation de l'lment
            'Dim F_r(6, 6) As String
            'Dim i6, i7 As Integer
            'msgg = msgg & "Element " & CStr(i) & " - Matrice R:" & vbCrLf
            'For i6 = 1 To 6
            '    For i7 = 1 To 6
            '        F_r(i6, i7) = Format(R(i6, i7), "###0.00")
            '        msgg = msgg & "  " & F_r(i6, i7)
            '    Next
            '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
            'Next
            'msgg = msgg & vbCrLf
            'msgg = msgg & "Matrice Rt:" & vbCrLf
            'For i6 = 1 To 6
            '    For i7 = 1 To 6
            '        F_r(i6, i7) = Format(Rt(i6, i7), "###0.00")
            '        msgg = msgg & "  " & F_r(i6, i7)
            '    Next
            '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
            'Next
            'msgg = msgg & vbCrLf

            'calcul des matrices K0,L0 et L1
            Call Matmul(Tg, k1, l1)
            Call Matmul(l1, Td, k0)
            Call Matmul(k1, Td, l0)
            'rotation et addition
            jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
            Call Matmul(Rt, k0, BB)
            Call Matmul(BB, R, k0)      'transformation k0 -> K0
            Call MatAdd(Kg, k0, jD, jD) 'entre de K0 dans la matrice globale

            Call Matmul(Rt, k1, BB)
            Call Matmul(BB, R, k1)
            Call MatAdd(Kg, k1, jF, jF)

            Call Matmul(Rt, l0, BB)
            Call Matmul(BB, R, l0)
            Call MatAdd(Kg, l0, jF, jD)

            Call Matmul(Rt, l1, BB)
            Call Matmul(BB, R, l1)
            Call MatAdd(Kg, l1, jD, jF)
            ''--> Debogage de l'application: 
            ''    affichage dans le fichier de dtails du calcul de la matrice globale Kg de l'lment
            'Dim F_kg(6 * Total_noeud, 6 * Total_noeud) As String
            'msgg = msgg & "Matrice globale de rigidit Kg:" & vbCrLf
            'For i6 = 1 To 6 * Total_noeud
            '    For i7 = 1 To 6 * Total_noeud
            '        F_kg(i6, i7) = Format(Kg(i6, i7), "###0.00")
            '        msgg = msgg & "  " & F_kg(i6, i7)
            '    Next
            '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
            'Next
            'msgg = msgg & vbCrLf
        Next
        'Pour viter la matrice singulire et continuer le calcul 
        For i = 1 To Total_noeud * 6
            If Kg(i, i) = 0 Then
                Kg(i, i) = 1
            End If
        Next
        'Libration de mmoire
        Erase k0, Td, Tg, k1, l0, l1, BB, R, Rt

    End Sub
    Private Sub K_3D_tout_encastre(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)


        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0 : A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = (12 * Ey(k) * Iy(k)) / l ^ 3 : A(9, k) = 0 : A(10, k) = 0 : A(11, k) = 0 : A(12, k) = (-6 * Ey(k) * Iy(k)) / l ^ 2
        A(13, k) = 0 : A(14, k) = 0 : A(15, k) = (12 * Ey(k) * Iz(k)) / l ^ 3 : A(16, k) = 0 : A(17, k) = (6 * Ey(k) * Iz(k)) / l ^ 2 : A(18, k) = 0
        A(19, k) = 0 : A(20, k) = 0 : A(21, k) = 0 : A(22, k) = G(k) * It(k) / l : A(23, k) = 0 : A(24, k) = 0
        A(25, k) = 0 : A(26, k) = 0 : A(27, k) = (6 * Ey(k) * Iz(k)) / l ^ 2 : A(28, k) = 0 : A(29, k) = (4 * Ey(k) * Iz(k)) / l : A(30, k) = 0
        A(31, k) = 0 : A(32, k) = (-6 * Ey(k) * Iy(k)) / l ^ 2 : A(33, k) = 0 : A(34, k) = 0 : A(35, k) = 0 : A(36, k) = (4 * Ey(k) * Iy(k)) / l

        'A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0 : A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        'A(7, k) = 0 : A(8, k) = (12 * Ey(k) * Iz(k)) / l ^ 3 : A(9, k) = 0 : A(10, k) = 0 : A(11, k) = 0 : A(12, k) = (-6 * Ey(k) * Iz(k)) / l ^ 2
        'A(13, k) = 0 : A(14, k) = 0 : A(15, k) = (12 * Ey(k) * Iy(k)) / l ^ 3 : A(16, k) = 0 : A(17, k) = (6 * Ey(k) * Iy(k)) / l ^ 2 : A(18, k) = 0
        'A(19, k) = 0 : A(20, k) = 0 : A(21, k) = 0 : A(22, k) = G(k) * It(k) / l : A(23, k) = 0 : A(24, k) = 0
        'A(25, k) = 0 : A(26, k) = 0 : A(27, k) = (6 * Ey(k) * Iy(k)) / l ^ 2 : A(28, k) = 0 : A(29, k) = (4 * Ey(k) * Iy(k)) / l : A(30, k) = 0
        'A(31, k) = 0 : A(32, k) = (-6 * Ey(k) * Iz(k)) / l ^ 2 : A(33, k) = 0 : A(34, k) = 0 : A(35, k) = 0 : A(36, k) = (4 * Ey(k) * Iz(k)) / l

        ''--> Debogage de l'application: 
        ''    criture de la matrice de rigidit lmentaire dans un fichier
        'Dim F_A(36) As String
        'Dim k1 As Integer
        'For k1 = 1 To 36
        '    F_A(k1) = Format(A(k1, k), "###0.000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & "  " & F_A(4) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & "  " & F_A(10) & "  " & F_A(11) & "  " & F_A(12) & vbCrLf
        'msgg = msgg & F_A(13) & "  " & F_A(14) & "  " & F_A(15) & "  " & F_A(16) & "  " & F_A(17) & "  " & F_A(18) & vbCrLf
        'msgg = msgg & F_A(19) & "  " & F_A(20) & "  " & F_A(21) & "  " & F_A(22) & "  " & F_A(23) & "  " & F_A(24) & vbCrLf
        'msgg = msgg & F_A(25) & "  " & F_A(26) & "  " & F_A(27) & "  " & F_A(28) & "  " & F_A(29) & "  " & F_A(30) & vbCrLf
        'msgg = msgg & F_A(31) & "  " & F_A(32) & "  " & F_A(33) & "  " & F_A(34) & "  " & F_A(35) & "  " & F_A(36) & vbCrLf
    End Sub
    Private Sub K_3D_tout_encastre_I_variable(ByVal k As Integer, ByVal alpha As Double, ByVal l As Double, ByRef A(,) As Double, _
    ByVal h1 As Double, ByVal h2 As Double, ByVal ea As Double, ByVal es As Double, ByVal b As Double)
        '    'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '    '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)
        '    Dim F_A(9) As String
        '    Dim i, k1 As Integer
        '    Dim aa, bb, cc, dd, hx, S, x, FF, FFb, pas As Double  '
        '    'dtermination du coefficient aa
        '    'calcul de l'intgration numrique par la mthode des trapzes
        '    'calcul du pas - dcoupage de la longueur en 20 fois
        '    pas = l / 20
        '    'calcul de f(x0) initial
        '    S = 1 / (ea * h1 + 2 * b * es)
        '    S = S / 2
        '    x = 0
        '    i = 1
        '    Do
        '        'calcul du x+pas
        '        x = x + pas
        '        'calcul de f(x+pas)
        '        hx = h1 + x * (h2 - h1) / l
        '        'sommation de f(x+pas) au f(x) prcdent
        '        S = S + (1 / (ea * hx + 2 * b * es))
        '        i = i + 1
        '    Loop Until i = 19
        '    x = x + pas
        '    FF = h1 + x * (h2 - h1) / l
        '    FF = 1 / (ea * FF + 2 * b * es)
        '    FFb = h2
        '    FFb = 1 / (ea * FFb + 2 * b * es)
        '    'sommation gnrale sur tous les pas de calcul
        '    S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        '    aa = S

        '    'dtermination du coefficient bb
        '    hx = h1
        '    S = 12 * l ^ 2 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3)
        '    S = S / 2
        '    x = 0
        '    i = 1
        '    Do
        '        x = x + pas
        '        hx = (h1 + x * ((h2 - h1) / l))
        '        S = S + (12 * (l - x) ^ 2 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3))
        '        i = i + 1
        '    Loop Until i = 19
        '    x = x + pas
        '    FF = (h1 + x * ((h2 - h1) / l))
        '    FF = 12 * (l - x) ^ 2 / (ea * FF ^ 3 + 6 * b * es * FF ^ 2 + 12 * b * es ^ 3 * FF + 8 * b * es ^ 3)
        '    FFb = 0
        '    S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        '    bb = S

        '    'dtermination du coefficient cc
        '    hx = h1
        '    S = 12 * l / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3)
        '    S = S / 2
        '    x = 0
        '    i = 1
        '    Do
        '        x = x + pas
        '        hx = (h1 + x * ((h2 - h1) / l))
        '        S = S + (12 * (l - x) / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3))
        '        i = i + 1
        '    Loop Until i = 19
        '    x = x + pas
        '    FF = (h1 + x * ((h2 - h1) / l))
        '    FF = 12 * (l - x) / (ea * FF ^ 3 + 6 * b * es * FF ^ 2 + 12 * b * es ^ 3 * FF + 8 * b * es ^ 3)
        '    FFb = 0
        '    S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        '    cc = S

        '    'dtermination du coefficient dd
        '    hx = h1
        '    S = 12 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3)
        '    S = S / 2
        '    x = 0
        '    i = 1
        '    Do
        '        x = x + pas
        '        hx = (h1 + x * ((h2 - h1) / l))
        '        S = S + (12 / (ea * hx ^ 3 + 6 * b * es * hx ^ 2 + 12 * b * es ^ 3 * hx + 8 * b * es ^ 3))
        '        i = i + 1
        '    Loop Until i = 19
        '    x = x + pas
        '    FF = (h1 + x * ((h2 - h1) / l))
        '    FF = 12 / (ea * FF ^ 3 + 6 * b * es * FF ^ 2 + 12 * b * es ^ 3 * FF + 8 * b * es ^ 3)
        '    FFb = h2
        '    FF = 12 / (ea * FFb ^ 3 + 6 * b * es * FFb ^ 2 + 12 * b * es ^ 3 * FFb + 8 * b * es ^ 3)
        '    S = pas * (S + FF / 2) + (l - x) * (FF + FFb) / 2
        '    dd = S

        '    A(1, k) = Ey(k) / aa : A(2, k) = 0 : A(3, k) = 0
        '    A(4, k) = 0 : A(5, k) = Ey(k) * (dd / (bb * dd - cc ^ 2)) : A(6, k) = (-cc * Ey(k)) / (bb * dd - cc ^ 2)
        '    A(7, k) = 0 : A(8, k) = (-cc * Ey(k)) / (bb * dd - cc ^ 2) : A(9, k) = bb * Ey(k) / (bb * dd - cc ^ 2)

        '    'For k1 = 1 To 9
        '    '    F_A(k1) = Format(A(k1, k), "###0.00000")
        '    'Next
        '    'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        '    'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        '    'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        '    'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_3D_gauche_relaxe(ByVal k As Integer, ByVal alpha As Double, ByVal l As Double, ByRef A(,) As Double)
        '    'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '    '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)
        '    Dim F_A(9) As String
        '    Dim k1 As Integer
        '    A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        '    A(4, k) = 0 : A(5, k) = (3 * Ey(k) * Iz(k)) / l ^ 3 : A(6, k) = (-3 * Ey(k) * Iz(k)) / l ^ 2
        '    A(7, k) = 0 : A(8, k) = (-3 * Ey(k) * Iz(k)) / l ^ 2 : A(9, k) = (3 * Ey(k) * Iz(k)) / l

        '    'For k1 = 1 To 9
        '    '    F_A(k1) = Format(A(k1, k), "###0.00000")
        '    'Next
        '    'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        '    'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        '    'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        '    'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_3D_droit_relaxe(ByVal k As Integer, ByVal alpha As Double, ByVal l As Double, ByRef A(,) As Double)
        '    'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '    '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)
        '    Dim F_A(9) As String
        '    Dim k1 As Integer

        '    A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0
        '    A(4, k) = 0 : A(5, k) = (3 * Ey(k) * Iz(k)) / l ^ 3 : A(6, k) = 0
        '    A(7, k) = 0 : A(8, k) = 0 : A(9, k) = 0

        '    'For k1 = 1 To 9
        '    '    F_A(k1) = Format(A(k1, k), "###0.00000")
        '    'Next
        '    'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        '    'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        '    'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        '    'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub K_3D_tout_relaxe(ByVal k As Integer, ByVal l As Double, ByRef A(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        A(1, k) = Ey(k) * Sx(k) / l : A(2, k) = 0 : A(3, k) = 0 : A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = 0 : A(10, k) = 0 : A(11, k) = 0 : A(12, k) = 0
        A(13, k) = 0 : A(14, k) = 0 : A(15, k) = 0 : A(16, k) = 0 : A(17, k) = 0 : A(18, k) = 0
        A(19, k) = 0 : A(20, k) = 0 : A(21, k) = 0 : A(22, k) = 0 : A(23, k) = 0 : A(24, k) = 0
        A(25, k) = 0 : A(26, k) = 0 : A(27, k) = 0 : A(28, k) = 0 : A(29, k) = 0 : A(30, k) = 0
        A(31, k) = 0 : A(32, k) = 0 : A(33, k) = 0 : A(34, k) = 0 : A(35, k) = 0 : A(36, k) = 0

        '--> Module de dbogage:
        'Dim F_A(9) As String
        ' Dim k1 As Integer
        'For k1 = 1 To 9
        '    F_A(k1) = Format(A(k1, k), "###0.00000")
        'Next
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  matrice de rigidit lmentaire:" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & vbCrLf
        'msgg = msgg & F_A(5) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & vbCrLf
    End Sub
    Private Sub Rotation(ByVal k As Integer, ByVal alpha As Double, ByVal beta As Double, ByRef A(,) As Double)
        Dim k1 As Integer
        'matrice de rotation R pour passer du repre global au repre local: {x}= [R] {X}
        'k=N de l'lment
        For k1 = 1 To 36
            A(k1, k) = 0
        Next
        Gamma(k) = Gamma(k) * PI / 180 'transformation degr->radian

        A(1, k) = Cos(alpha) * Cos(beta)
        A(2, k) = Sin(alpha) * Cos(beta)
        A(3, k) = Sin(beta)
        A(7, k) = -Cos(Gamma(k)) * Sin(alpha) - Sin(Gamma(k)) * Sin(beta) * Cos(alpha)
        A(8, k) = Cos(Gamma(k)) * Cos(alpha) - Sin(Gamma(k)) * Sin(alpha) * Sin(beta)
        A(9, k) = Sin(Gamma(k)) * Cos(beta)
        A(13, k) = Sin(Gamma(k)) * Sin(alpha) - Cos(Gamma(k)) * Sin(beta) * Cos(alpha)
        A(14, k) = -Sin(Gamma(k)) * Cos(alpha) - Cos(Gamma(k)) * Sin(alpha) * Sin(beta)
        A(15, k) = Cos(Gamma(k)) * Cos(beta)
        '----
        A(22, k) = A(1, k)
        A(23, k) = A(2, k)
        A(24, k) = A(3, k)
        A(28, k) = A(7, k)
        A(29, k) = A(8, k)
        A(30, k) = A(9, k)
        A(34, k) = A(13, k)
        A(35, k) = A(14, k)
        A(36, k) = A(15, k)

        'Dim angle As String
        'Dim F_A(36) As String
        'Dim i, j As Integer
        'angle = Format(alpha * 180 / PI, "##0.00")
        'For k1 = 1 To 36
        '    F_A(k1) = Format(A(k1, k), "###0.00")
        'Next
        'i = Ele(1, k) : j = Ele(2, k)
        'msgg = msgg & vbCrLf & "Elment " & CStr(k) & "  sens " & CStr(i) & " --> " & CStr(j) & _
        '"  angle: " & angle & vbCrLf & "matrice Rot lmentaire" & vbCrLf
        'msgg = msgg & F_A(1) & "  " & F_A(2) & "  " & F_A(3) & "  " & F_A(4) & "  " & F_A(5) & "  " & F_A(6) & vbCrLf
        'msgg = msgg & F_A(7) & "  " & F_A(8) & "  " & F_A(9) & "  " & F_A(10) & "  " & F_A(11) & "  " & F_A(12) & vbCrLf
        'msgg = msgg & F_A(13) & "  " & F_A(14) & "  " & F_A(15) & "  " & F_A(16) & "  " & F_A(17) & "  " & F_A(18) & vbCrLf
        'msgg = msgg & F_A(19) & "  " & F_A(20) & "  " & F_A(21) & "  " & F_A(22) & "  " & F_A(23) & "  " & F_A(24) & vbCrLf
        'msgg = msgg & F_A(25) & "  " & F_A(26) & "  " & F_A(27) & "  " & F_A(28) & "  " & F_A(29) & "  " & F_A(30) & vbCrLf
        'msgg = msgg & F_A(31) & "  " & F_A(32) & "  " & F_A(33) & "  " & F_A(34) & "  " & F_A(35) & "  " & F_A(36) & vbCrLf
    End Sub
    Private Sub Matmul(ByVal AA(,) As Double, ByVal BB(,) As Double, ByRef CC(,) As Double)
        'Sous-programme de multiplication de matrice 6x6
        Dim i, j, k As Integer
        Dim sum As Double
        For i = 1 To 6
            For j = 1 To 6
                sum = 0
                For k = 1 To 6
                    sum = sum + AA(i, k) * BB(k, j)
                Next
                CC(i, j) = sum
            Next
        Next
    End Sub
    Private Sub MatAdd(ByRef AK(,) As Double, ByVal A(,) As Double, ByVal Jlig As Integer, ByVal Jcol As Integer)
        'Sous-programme d'addition de la matrice A en ligne Jlig et colonne jcol dans la matrice Kg
        Dim i, j, ii, jj, il, ic As Integer
        ii = 6 * (Jlig - 1)
        jj = 6 * (Jcol - 1)
        For i = 1 To 6
            For j = 1 To 6
                il = ii + i
                ic = jj + j
                AK(il, ic) = AK(il, ic) + A(i, j)
            Next
        Next
    End Sub
    Public Sub Appui_elastique_3D(ByRef Kg(,) As Double)
        'Modification de la matrice gnrale de rigidit en fonction des appuis lastiques
        'voir p95 "Calcul des structures et informatique"
        'programme d'addition des coefficients K en ligne Jlig et colonne jcol dans la matrice Kg
        'si l'appui n'est pas lastique, K=0 ce qui ne modifie pas la matrice Kg initiale
        Dim i, i3 As Integer

        For i = 1 To Total_noeud
            If Appui(i) = True Then 'test si noeud est un appui
                i3 = (i - 1) * 6
                Kg(i3 + 1, i3 + 1) = Kg(i3 + 1, i3 + 1) + Kux(i)
                Kg(i3 + 2, i3 + 2) = Kg(i3 + 2, i3 + 2) + Kuy(i)
                Kg(i3 + 3, i3 + 3) = Kg(i3 + 3, i3 + 3) + Kuz(i)
                Kg(i3 + 4, i3 + 4) = Kg(i3 + 4, i3 + 4) + Krx(i)
                Kg(i3 + 5, i3 + 5) = Kg(i3 + 5, i3 + 5) + Kry(i)
                Kg(i3 + 6, i3 + 6) = Kg(i3 + 6, i3 + 6) + Krz(i)
            End If
        Next
    End Sub

    Public Sub Second_Membre_Treillis_Spatial(ByVal L() As Double, ByRef FN(,) As Double, ByVal N_comb As Integer)                                   ', ByVal i_pas As Integer)
        'Calcul du vecteur force
        Dim i, j As Integer
        'mise  zero des vecteurs FN et FB
        For i = 1 To Total_noeud : For j = 1 To 6 : FN(j, i) = 0 : Next : Next
        'calcul  sur les cas de charges
        'forces nodales: elles s'ajoutent directement au vecteur force
        For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
            FN(1, j) = ForPN(1, j, N_comb) 'suivant X
            FN(2, j) = ForPN(2, j, N_comb) 'suivant Y
            FN(3, j) = ForPN(3, j, N_comb) 'suivant Z
        Next

    End Sub
    Private Sub Second_Membre(ByVal L() As Double, ByVal Rot(,) As Double, ByRef FN(,) As Double, ByRef FB(,) As Double, _
    ByVal N_comb As Integer, ByVal i_pas As Integer)
        'Calcul du vecteur force
        Dim i, ii, j, jd, jf, jj, N_comb1, Totaux_cas_de_charges As Integer
        Dim forc As Double
        'mise  zero des vecteurs FN et FB
        For i = 1 To Total_noeud : For j = 1 To 6 : FN(j, i) = 0 : Next : Next
        For i = 1 To Total_element : For j = 1 To 12 : FB(j, i) = 0 : Next : Next
        Totaux_cas_de_charges = 0
        For i = 1 To i_pas - 1
            Totaux_cas_de_charges = Totaux_cas_de_charges + Total_cas_de_charge(i) + Total_combinaison(i)
        Next
        'boucle sur les charges
        If N_comb > Totaux_cas_de_charges + Total_cas_de_charge(i_pas) Then
            'calcul sur les combinaisons
            N_comb1 = N_comb - Totaux_cas_de_charges - Total_cas_de_charge(i_pas)
            For i = 1 To dim_Cas_comb(N_comb1) 'balayage du vecteur ensemble des cas pour la comb i 
                '--> forces nodales dans repre global
                For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
                    'If fn_noe_cas(1, j, Cas_comb(i, N_comb1)) = True Then 'force nodale suivant X
                    '                     FN(1, j) = FN(1, j) + F(1, 1, j, Cas_comb(i, N_comb1)) * Coef_pond(Cas_comb(i, N_comb1), N_comb1) 'coef_pond(N de cas de charge,N de comb )
                    'End If
        'If fn_noe_cas(2, j, Cas_comb(i, N_comb1)) = True Then 'force nodale suivant Y
        '             FN(2, j) = FN(2, j) + F(1, 2, j, Cas_comb(i, N_comb1)) * Coef_pond(Cas_comb(i, N_comb1), N_comb1)
                    ' End If
        'If fn_noe_cas(3, j, Cas_comb(i, N_comb1)) = True Then 'force nodale suivant Z
        '                FN(3, j) = FN(3, j) + F(1, 3, j, Cas_comb(i, N_comb1)) * Coef_pond(Cas_comb(i, N_comb1), N_comb1)
                    'End If
                Next
                '--> forces uniformement rparties dans repre local
                For j = 1 To Total_element      'balayage de l'ensemble des lments de la structure
                    'If p_cas(1, j, Cas_comb(i, N_comb1)) = True Then 'force rpartie suivant X local  --> force //  la barre
                    '    Stop '    forc = ForL(Cas_comb(i, N_comb1), j, 1) * Coef_pond(Cas_comb(i, N_comb1), N_comb1)
                    '    FB(1, j) = FB(1, j) - L(j) * forc / 2
                    '    FB(7, j) = FB(7, j) - L(j) * forc / 2
                    'End If
                    'If p_cas(2, j, Cas_comb(i, N_comb1)) = True Then 'force rpartie suivant Y -->
                    '    Stop '         forc = ForL(Cas_comb(i, N_comb1), j, 2) * Coef_pond(Cas_comb(i, N_comb1), N_comb1)
                    '    ' si noe 1 et noe 2 encastrs
                    '    If Rel_ele(1, j) = False And Rel_ele(2, j) = False Then
                    '        FB(2, j) = FB(2, j) - L(j) * forc / 2
                    '        FB(5, j) = FB(5, j) - L(j) ^ 2 * forc / 12
                    '        FB(8, j) = FB(8, j) - L(j) * forc / 2
                    '        FB(11, j) = FB(11, j) + L(j) ^ 2 * forc / 12
                    '    End If
                    '    ' si noe 1 relax et noe 2 encastr 
                    '    If Rel_ele(1, j) = True And Rel_ele(2, j) = False Then
                    '        FB(2, j) = FB(2, j) - 3 * L(j) * forc / 8
                    '        FB(5, j) = FB(5, j) + 0
                    '        FB(8, j) = FB(8, j) - 5 * L(j) * forc / 8
                    '        FB(11, j) = FB(11, j) + L(j) ^ 2 * forc / 8
                    '    End If
                    '    ' si noe 1 encastr et noe 2 relax alors 
                    '    If Rel_ele(1, j) = False And Rel_ele(2, j) = True Then
                    '        FB(2, j) = FB(2, j) - 5 * L(j) * forc / 8
                    '        FB(5, j) = FB(5, j) - L(j) ^ 2 * forc / 8
                    '        FB(8, j) = FB(8, j) - 3 * L(j) * forc / 8
                    '        FB(11, j) = FB(11, j) + 0
                    '    End If
                    'End If
                    'If p_cas(3, j, Cas_comb(i, N_comb1)) = True Then 'force rpartie suivant Z -->
                    '    Stop ' forc = ForL(Cas_comb(i, N_comb1), j, 3) * Coef_pond(Cas_comb(i, N_comb1), N_comb1)
                    '    ' si noe 1 et noe 2 encastrs
                    '    If Rel_ele(1, j) = False And Rel_ele(2, j) = False Then
                    '        FB(3, j) = FB(3, j) - L(j) * forc / 2
                    '        FB(6, j) = FB(6, j) - L(j) ^ 2 * forc / 12
                    '        FB(9, j) = FB(9, j) - L(j) * forc / 2
                    '        FB(12, j) = FB(12, j) + L(j) ^ 2 * forc / 12
                    '    End If
                    '    ' si noe 1 relax et noe 2 encastr 
                    '    If Rel_ele(1, j) = True And Rel_ele(2, j) = False Then
                    '        FB(3, j) = FB(3, j) - 3 * L(j) * forc / 8
                    '        FB(6, j) = FB(6, j) + 0
                    '        FB(9, j) = FB(9, j) - 5 * L(j) * forc / 8
                    '        FB(12, j) = FB(12, j) + L(j) ^ 2 * forc / 8
                    '    End If
                    '    ' si noe 1 encastr et noe 2 relax alors 
                    '    If Rel_ele(1, j) = False And Rel_ele(2, j) = True Then
                    '        FB(3, j) = FB(3, j) - 5 * L(j) * forc / 8
                    '        FB(6, j) = FB(6, j) - L(j) ^ 2 * forc / 8
                    '        FB(9, j) = FB(9, j) - 3 * L(j) * forc / 8
                    '        FB(12, j) = FB(12, j) + 0
                    '    End If
                    'End If
                Next
            Next
        Else
            'calcul  sur les cas de charges
            '--> forces nodales dans repre global
            For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
                'If fn_noe_cas(1, j, N_comb) = True Then 'force nodale suivant X
                '               FN(1, j) = FN(1, j) + F(1, 1, j, N_comb)
                ' End If
                'If fn_noe_cas(2, j, N_comb) = True Then 'force nodale suivant Y
                '               FN(2, j) = FN(2, j) + F(1, 2, j, N_comb)
                'End If
                'If fn_noe_cas(3, j, N_comb) = True Then 'force nodale suivant Z
                '               FN(3, j) = FN(3, j) + F(1, 3, j, N_comb)
                '    End If
            Next
            'forces uniformement rparties - repre Local
            For j = 1 To Total_element      'balayage de l'ensemble des lments de la structure
                'If p_cas(1, j, N_comb) = True Then 'force rpartie suivant X local
                '    Stop '        forc = ForL(N_comb, j, 1)
                '    FB(1, j) = FB(1, j) - L(j) * forc / 2
                '    FB(7, j) = FB(7, j) - L(j) * forc / 2
                'End If
                'If p_cas(2, j, N_comb) = True Then 'force rpartie suivant Y local
                '    Stop '    forc = ForL(N_comb, j, 2)
                '    ' si noe 1 et noe 2 encastrs
                '    If Rel_ele(1, j) = False And Rel_ele(2, j) = False Then
                '        FB(2, j) = FB(2, j) - L(j) * forc / 2
                '        FB(5, j) = FB(5, j) - L(j) ^ 2 * forc / 12
                '        FB(8, j) = FB(8, j) - L(j) * forc / 2
                '        FB(11, j) = FB(11, j) + L(j) ^ 2 * forc / 12
                '    End If
                '    ' si noe 1 relax et noe 2 encastr 
                '    If Rel_ele(1, j) = True And Rel_ele(2, j) = False Then
                '        FB(2, j) = FB(2, j) - 3 * L(j) * forc / 8
                '        FB(5, j) = FB(5, j) + 0
                '        FB(8, j) = FB(8, j) - 5 * L(j) * forc / 8
                '        FB(11, j) = FB(11, j) + L(j) ^ 2 * forc / 8
                '    End If
                '    ' si noe 1 encastr et noe 2 relax alors 
                '    If Rel_ele(1, j) = False And Rel_ele(2, j) = True Then
                '        FB(2, j) = FB(2, j) - 5 * L(j) * forc / 8
                '        FB(5, j) = FB(5, j) - L(j) ^ 2 * forc / 8
                '        FB(8, j) = FB(8, j) - 3 * L(j) * forc / 8
                '        FB(11, j) = FB(11, j) + 0
                '    End If
                'End If
                'If p_cas(3, j, N_comb) = True Then 'force rpartie suivant Z -->
                '    Stop '            forc = ForL(N_comb, j, 3)
                '    ' si noe 1 et noe 2 encastrs
                '    If Rel_ele(1, j) = False And Rel_ele(2, j) = False Then
                '        FB(3, j) = FB(3, j) - L(j) * forc / 2
                '        FB(6, j) = FB(6, j) - L(j) ^ 2 * forc / 12
                '        FB(9, j) = FB(9, j) - L(j) * forc / 2
                '        FB(12, j) = FB(12, j) + L(j) ^ 2 * forc / 12
                '    End If
                '    ' si noe 1 relax et noe 2 encastr 
                '    If Rel_ele(1, j) = True And Rel_ele(2, j) = False Then
                '        FB(3, j) = FB(3, j) - 3 * L(j) * forc / 8
                '        FB(6, j) = FB(6, j) + 0
                '        FB(9, j) = FB(9, j) - 5 * L(j) * forc / 8
                '        FB(12, j) = FB(12, j) + L(j) ^ 2 * forc / 8
                '    End If
                '    ' si noe 1 encastr et noe 2 relax alors 
                '    If Rel_ele(1, j) = False And Rel_ele(2, j) = True Then
                '        FB(3, j) = FB(3, j) - 5 * L(j) * forc / 8
                '        FB(6, j) = FB(6, j) - L(j) ^ 2 * forc / 8
                '        FB(9, j) = FB(9, j) - 3 * L(j) * forc / 8
                '        FB(12, j) = FB(12, j) + 0
                '    End If
                'End If
            Next
        End If
        'Ajout au terme FN du terme FB - repre Global
        For i = 1 To Total_element
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            FN(1, jd) = FN(1, jd) - (Rot(1, i) * FB(1, i) + Rot(7, i) * FB(2, i) + Rot(13, i) * FB(3, i))
            FN(2, jd) = FN(2, jd) - (Rot(2, i) * FB(1, i) + Rot(8, i) * FB(2, i) + Rot(14, i) * FB(3, i))
            FN(3, jd) = FN(3, jd) - (Rot(3, i) * FB(1, i) + Rot(9, i) * FB(2, i) + Rot(15, i) * FB(3, i))
            FN(4, jd) = FN(4, jd) - (Rot(22, i) * FB(4, i) + Rot(28, i) * FB(5, i) + Rot(34, i) * FB(6, i))
            FN(5, jd) = FN(5, jd) - (Rot(23, i) * FB(4, i) + Rot(29, i) * FB(5, i) + Rot(35, i) * FB(6, i))
            FN(6, jd) = FN(6, jd) - (Rot(24, i) * FB(4, i) + Rot(30, i) * FB(5, i) + Rot(36, i) * FB(6, i))
            FN(1, jf) = FN(1, jf) - (Rot(1, i) * FB(7, i) + Rot(7, i) * FB(8, i) + Rot(13, i) * FB(9, i))
            FN(2, jf) = FN(2, jf) - (Rot(2, i) * FB(7, i) + Rot(8, i) * FB(8, i) + Rot(14, i) * FB(9, i))
            FN(3, jf) = FN(3, jf) - (Rot(3, i) * FB(7, i) + Rot(9, i) * FB(8, i) + Rot(15, i) * FB(9, i))
            FN(4, jf) = FN(4, jf) - (Rot(22, i) * FB(10, i) + Rot(28, i) * FB(11, i) + Rot(34, i) * FB(12, i))
            FN(5, jf) = FN(5, jf) - (Rot(23, i) * FB(10, i) + Rot(29, i) * FB(11, i) + Rot(35, i) * FB(12, i))
            FN(6, jf) = FN(6, jf) - (Rot(24, i) * FB(10, i) + Rot(30, i) * FB(11, i) + Rot(36, i) * FB(12, i))
        Next
    End Sub
    Public Sub C_Limit_3D(ByRef Kg(,) As Double, ByRef FN(,) As Double)
        'Prise en compte des conditions d'appui et des relaxations
        Dim i, ii, i3, j, jj As Integer
        For i = 1 To Total_noeud
            If Appui(i) = True Then 'test si noeud est un appui
                i3 = (i - 1) * 6
                'Conditions aux limites modifies suivant les ddl Bloques
                'test pour tenir compte que les barres sont initialises encastres dans une ossature. Or, une barre seule sur 
                'un appui rotul (articulation libre) ne produit pas de moment  son extrmit. Par contre, plusieurs barres
                'concourrantes sur un noeuds peuvent tre encastres entre elles et articules vis  vis de l'appui ce qui est
                'le cas pour des poutres continues. Si on ne veut pas de moment en bout de barre, il sufira alors de relacher 
                'le noeud (ce qui relaxera toutes les extrmites de barres aboutissant  ce noeud) ou alors de dclarer un 
                'relachement sur cette barre pour le noeud concern - Voir notice pour l'entre des donnes

                '--> ddl suivant X Y Z bloqus, rotation libre
                If R_appui(1, i) = False And R_appui(2, i) = False And R_appui(3, i) = False _
                And R_appui(4, i) = True And R_appui(5, i) = True And R_appui(6, i) = True Then  'le noeud est articule
                    'mise  zro ligne et colonne sur Kg
                    For ii = 1 To 6
                        For jj = 1 To 6 * Total_noeud
                            Kg(i3 + ii, jj) = 0
                            Kg(jj, i3 + ii) = 0
                        Next
                    Next
                    Select Case Type_probleme
                        Case 3 'Treillis 
                            For ii = 1 To 6
                                Kg(i3 + ii, i3 + ii) = 1
                            Next
                        Case 4 'portique 
                            Select Case n_barre_appui(i)
                                Case 1 '1 barre sur l'appui
                                    For ii = 1 To 6
                                        Kg(i3 + ii, i3 + ii) = 1
                                    Next

                                Case Is > 1
                                    'pas de relaxation du noeud sauf si cela est indiqu de faon explicite
                                    For ii = 1 To 3
                                        Kg(i3 + ii, i3 + ii) = 1
                                    Next

                            End Select
                    End Select
                    'mise  zero du vecteur force
                    For ii = 1 To 6
                        FN(ii, i) = 0
                    Next


                    '--> ddl suivant X Y Z bloqus, rotation bloque
                ElseIf R_appui(1, i) = False And R_appui(2, i) = False And R_appui(3, i) = False _
                And R_appui(4, i) = False And R_appui(5, i) = False And R_appui(6, i) = False Then  'le noeud est encastre
                    'mise  zro ligne et colonne sur Kg
                    For ii = 1 To 6
                        For jj = 1 To 6 * Total_noeud
                            Kg(i3 + ii, jj) = 0
                            Kg(jj, i3 + ii) = 0
                        Next
                    Next
                    'mise d'un 1 sur la diagonale
                    For ii = 1 To 6
                        Kg(i3 + ii, i3 + ii) = 1
                    Next
                    'mise  zero du vecteur force
                    For ii = 1 To 6
                        FN(ii, i) = 0
                    Next

                    'ElseIf R_appui(1, i) = True And R_appui(2, i) = False Then 'le noeud est un appui rouleau suivant X et bloqu suivant Y
                    '    'mise  zro ligne et colonne sur Kg mais on conserve la ligne et la colonne correspondant  dx pour pouvoir
                    '    'calculer le dplacement de l'appui suivant X.
                    '    For ii = 2 To 3
                    '        For jj = 1 To 3 * Total_noeud
                    '            Kg(i3 + ii, jj) = 0
                    '            Kg(jj, i3 + ii) = 0
                    '        Next
                    '    Next
                    '    'mise d'un 1 sur la diagonale
                    '    For ii = 2 To 3
                    '        Kg(i3 + ii, i3 + ii) = 1
                    '    Next
                    '    'mise  zero du vecteur force
                    '    For ii = 2 To 3
                    '        FN(ii, i) = 0
                    '    Next

                    'ElseIf R_appui(1, i) = False And R_appui(2, i) = True Then 'le noeud est un appui rouleau suivant Y et bloqu suivant x
                    '    For jj = 1 To 3 * Total_noeud
                    '        Kg(i3 + 1, jj) = 0 : Kg(i3 + 3, jj) = 0
                    '        Kg(jj, i3 + 1) = 0 : Kg(jj, i3 + 3) = 0
                    '    Next
                    '    'mise d'un 1 sur la diagonale
                    '    Kg(i3 + 1, i3 + 1) = 1 : Kg(i3 + 3, i3 + 3) = 1
                    '    'mise  zero du vecteur force
                    '    FN(1, i) = 0 : FN(3, i) = 0

                End If

            Else
                Select Case Type_probleme
                    Case 3 'Treillis 
                        'tous les noeuds sont relachs (articulation)
                        i3 = i * 6
                        Kg(i3, i3) = 1 'mise d'un 1 sur la diagonale
                        Kg(i3 - 1, i3 - 1) = 1
                        Kg(i3 - 2, i3 - 2) = 1
                        FN(4, i) = 0 'mise  zero du moment dans le vecteur force
                        FN(5, i) = 0
                        FN(6, i) = 0
                    Case 4 'Portique 

                End Select

            End If
        Next

        ''affichage dans le fichier de dtails du calcul de la matrice globale Kg
        'Dim F_kg(6 * Total_noeud, 6 * Total_noeud) As String
        'msgg = msgg & "Matrice globale de rigidit Kg:" & vbCrLf
        'For i = 1 To 6 * Total_noeud
        '    For j = 1 To 6 * Total_noeud
        '        F_kg(i, j) = Format(Kg(i, j), "###0.0")
        '        msgg = msgg & "  " & F_kg(i, j)
        '    Next
        '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'Next
        'msgg = msgg & "FN" & vbCrLf
        'Dim F_fn(6, Total_noeud) As String
        'For j = 1 To Total_noeud
        '    For i = 1 To 6
        '        F_fn(i, j) = Format(FN(i, j), "###0.0")
        '        msgg = msgg & "  " & F_fn(i, j)
        '    Next
        '    msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'Next
    End Sub
    Public Sub Resol_3D(ByRef FN(,) As Double, ByVal Fapp(,) As Double, ByVal Kg(,) As Double, ByRef Dp(,) As Double, _
                        ByRef structure_OK As Boolean, ByVal i_pas As Integer)
        'Rsolution du systme linaire d'quation [K]*{U}={F}
        Dim i, ip1, j, jj, k, n3, nm3 As Integer
        Dim F(6 * Total_noeud), U(6 * Total_noeud) As Double
        Dim akg(6 * Total_noeud, 6 * Total_noeud) As Double
        'affectation de tableaux
        For i = 1 To 6 * Total_noeud
            For j = 1 To 6 * Total_noeud
                akg(i, j) = Kg(i, j)
            Next
        Next
        'mise dans F du tableau FN
        jj = 0
        For i = 1 To Total_noeud
            For j = 1 To 6
                jj = jj + 1
                F(jj) = FN(j, i)
            Next
        Next
        Call Gauss_Pivot_Max(6 * Total_noeud, akg, F, U, structure_OK, i_pas)
        If structure_OK = False Then Exit Sub
        ''phase 1: triangularisation de la matrice
        'n3 = 6 * Total_noeud
        'nm3 = n3 - 1
        'For i = 1 To nm3
        '    'test si terme diagonal non nul
        '    If Abs(akg(i, i)) < 0.00000001 Then
        '        msg = "Cas n" & CStr(i_pas) & " - calcul du terme diagonal n" & CStr(i) & vbCrLf & _
        '        " matrice de rigidit singulire"
        '        MsgBox(msg, style, title)
        '        structure_OK = False
        '        Exit Sub
        '    End If
        '    'calcul des termes sur ligne j
        '    ip1 = i + 1
        '    For j = ip1 To n3
        '        F(j) = F(j) - (akg(j, i) / akg(i, i)) * F(i)
        '        'boucle sur les termes de la ligne j
        '        For k = ip1 To n3
        '            akg(j, k) = akg(j, k) - (akg(j, i) / akg(i, i)) * akg(i, k)
        '        Next k
        '        akg(j, i) = 0
        '    Next j
        'Next i
        ''calcul du dernier terme
        ''test si terme diagonal non nul
        'If Abs(akg(n3, n3)) < 0.00000001 Then
        '    msg = "Cas n" & CStr(i_pas) & " - calcul du dernier terme diagonal" & vbCrLf & _
        '    " matrice de rigidit singulire"
        '    MsgBox(msg, style, title)
        '    structure_OK = False
        '    Exit Sub
        'End If
        'U(n3) = F(n3) / akg(n3, n3)
        ''phase2 : rsolution du systme
        'For jj = 1 To n3
        '    i = n3 - jj
        '    'calcul de U(i)
        '    U(i) = F(i) / akg(i, i)
        '    ip1 = i + 1
        '    For j = ip1 To n3
        '        U(i) = U(i) - akg(i, j) * U(j) / akg(i, i)
        '    Next
        'Next
        'mise du vecteur U dans DP
        jj = 0
        For i = 1 To Total_noeud
            For j = 1 To 6
                jj = jj + 1
                Dp(j, i) = U(jj)
            Next
        Next
        'affectation des rsultats
        'dplacements des noeuds dans le repre Global
        For i = 1 To Total_noeud
            Depl(i_pas, i, 1) = Dp(1, i) : Depl(i_pas, i, 2) = Dp(2, i) : Depl(i_pas, i, 3) = Dp(3, i)
            Depl(i_pas, i, 4) = Dp(4, i) : Depl(i_pas, i, 5) = Dp(5, i) : Depl(i_pas, i, 6) = Dp(6, i)
        Next
        Erase U, F, akg
    End Sub
    Private Sub Gauss_Pivot_Max(ByVal n As Integer, ByVal Akg(,) As Double, ByVal F() As Double, ByRef U() As Double, _
         ByRef structure_OK As Boolean, ByVal i_pas As Integer)
        ' RESOLUTION DE SYSTEME LINEAIRE par la METHODE DE LA TRIANGULATION DE GAUSS AVEC RECHERCHE DU PIVOT MAXIMUM
        ' "PREMIER MEMBRE DU SYSTEME : MATRICE A"
        '"SECOND  MEMBRE DU SYSTEME : MATRICE B"
        'matrice de dimension nxn
        Dim msg As String
        Dim i, j, L, Lmax, k, ns As Integer
        Dim m, S, m1, A(n, n), B(n) As Double
        For i = 1 To n
            B(i) = F(i)
            For j = 1 To n
                A(i, j) = Akg(i, j)
            Next
        Next
        ns = n
        For k = 1 To ns - 1
            m = A(k, k)
            Lmax = k
            For L = k + 1 To ns
                If Abs(A(L, k)) >= Abs(m) Then
                    m = A(L, k)
                    Lmax = L
                End If
            Next L
            If Abs(m) < 9.999999E-21 Then 'pivot nul
                msg = "Cas n" & CStr(i_pas) & " - calcul du terme diagonal n" & CStr(k) & vbCrLf & _
                                " matrice de rigidit singulire"
                MsgBox(msg, style, title)
                structure_OK = False
                Exit Sub
            End If
            If Lmax <> k Then
                If Abs(A(Lmax, k)) >= 10 * Abs(A(k, k)) Then
                    For L = k To ns
                        m1 = A(k, L)
                        A(k, L) = A(Lmax, L)
                        A(Lmax, L) = m1
                    Next
                    m1 = B(k)
                    B(k) = B(Lmax)
                    B(Lmax) = m1
                End If
            End If
            For i = k + 1 To ns
                B(i) = B(i) - A(i, k) / A(k, k) * B(k)
                For j = k + 1 To ns
                    A(i, j) = A(i, j) - A(i, k) / A(k, k) * A(k, j)
                Next j
            Next i
        Next k
        '
        'CALCUL DES SOLUTIONS
        '
        If Abs(A(ns, ns)) < 9.999999E-21 Then 'pivot nul
            msg = "Cas n" & CStr(i_pas) & " - calcul du dernier terme diagonal" & vbCrLf & _
                        " matrice de rigidit singulire"
            MsgBox(msg, style, title)
            structure_OK = False
            Exit Sub
        End If
        U(ns) = B(ns) / A(ns, ns)
        For i = ns - 1 To 1 Step -1
            S = 0
            For k = i + 1 To ns
                S = S + A(i, k) * U(k)
            Next k
            U(i) = (B(i) - S) / A(i, i)
        Next i
        Erase A, B
    End Sub
    Private Sub Resultat(ByVal Dp(,) As Double, ByVal Rot(,) As Double, ByVal L() As Double, ByVal Kg0(,) As Double, ByVal FB(,) As Double, _
    ByVal i_pas As Integer)
        'calcul des efforts dans les barres et des ractions d'appui
        Dim Efb(12, Total_element), FN(6, Total_noeud), Dpp(6), K1(6, 6), Tg(6, 6), L1(6, 6) As Double
        Dim A0, A1, B0, B1, C0, C1, X0, X1, Y0, Y1, Z0, Z1, F0, F1 As Double
        Dim i, ii, j, jj, jd, jf As Integer

        'Phase 1 : calcul des efforts dans les barres
        For i = 1 To Total_element
            'mise  zro de Efb
            For j = 1 To 12
                Efb(j, i) = 0
            Next
            'dplacement absolu des noeuds dans le repre local pour chaque lment
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            X0 = Dp(1, jd) * Rot(1, i) + Dp(2, jd) * Rot(2, i) + Dp(3, jd) * Rot(3, i)
            Y0 = Dp(1, jd) * Rot(7, i) + Dp(2, jd) * Rot(8, i) + Dp(3, jd) * Rot(9, i)
            Z0 = Dp(1, jd) * Rot(13, i) + Dp(2, jd) * Rot(14, i) + Dp(3, jd) * Rot(15, i)
            A0 = Dp(4, jd) * Rot(22, i) + Dp(5, jd) * Rot(23, i) + Dp(6, jd) * Rot(24, i)
            B0 = Dp(4, jd) * Rot(28, i) + Dp(5, jd) * Rot(29, i) + Dp(6, jd) * Rot(30, i)
            C0 = Dp(4, jd) * Rot(34, i) + Dp(5, jd) * Rot(35, i) + Dp(6, jd) * Rot(36, i)

            X1 = Dp(1, jf) * Rot(1, i) + Dp(2, jf) * Rot(2, i) + Dp(3, jf) * Rot(3, i)
            Y1 = Dp(1, jf) * Rot(7, i) + Dp(2, jf) * Rot(8, i) + Dp(3, jf) * Rot(9, i)
            Z1 = Dp(1, jf) * Rot(13, i) + Dp(2, jf) * Rot(14, i) + Dp(3, jf) * Rot(15, i)
            A1 = Dp(4, jf) * Rot(22, i) + Dp(5, jf) * Rot(23, i) + Dp(6, jf) * Rot(24, i)
            B1 = Dp(4, jf) * Rot(28, i) + Dp(5, jf) * Rot(29, i) + Dp(6, jf) * Rot(30, i)
            C1 = Dp(4, jf) * Rot(34, i) + Dp(5, jf) * Rot(35, i) + Dp(6, jf) * Rot(36, i)
            'calcul des dplacements relatifs
            Dpp(1) = X1 - X0
            Dpp(2) = Y1 - Y0 - C0 * L(i)
            Dpp(3) = Z1 - Z0 + B0 * L(i)
            Dpp(4) = A1 - A0
            Dpp(5) = B1 - B0
            Dpp(6) = C1 - C0
            'calcul de la matrice K1 et L1
            j = 0
            For ii = 1 To 6
                For jj = 1 To 6
                    j = j + 1
                    K1(ii, jj) = Kg0(j, i)
                Next
            Next
            'matrice de transposition
            For ii = 1 To 6
                For jj = 1 To 6
                    Tg(ii, jj) = 0
                Next
                Tg(ii, ii) = -1
            Next
            Tg(6, 2) = -L(i) : Tg(5, 3) = L(i)
            'calcul de la matrice L1
            Call Matmul(Tg, K1, L1)
            'Efforts dus aux dplacements
            For ii = 1 To 6
                F0 = 0 : F1 = 0
                For jj = 1 To 6
                    F0 = F0 + L1(ii, jj) * Dpp(jj)
                    F1 = F1 + K1(ii, jj) * Dpp(jj)
                Next
                Efb(ii, i) = Efb(ii, i) + F0
                Efb(ii + 6, i) = Efb(ii + 6, i) + F1
            Next
            'Ajout des termes dus aux forces sur les barres
            For ii = 1 To 12
                Efb(ii, i) = Efb(ii, i) + FB(ii, i)
            Next
        Next

        'phase 2 :  raction d'appui
        For ii = 1 To Total_noeud
            For jj = 1 To 6
                FN(jj, ii) = 0
            Next
        Next
        'boucle sur les barres
        For i = 1 To Total_element
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            FN(1, jd) = FN(1, jd) + Rot(1, i) * Efb(1, i) + Rot(7, i) * Efb(2, i) + Rot(13, i) * Efb(3, i)
            FN(2, jd) = FN(2, jd) + Rot(2, i) * Efb(1, i) + Rot(8, i) * Efb(2, i) + Rot(14, i) * Efb(3, i)
            FN(3, jd) = FN(3, jd) + Rot(3, i) * Efb(1, i) + Rot(9, i) * Efb(2, i) + Rot(15, i) * Efb(3, i)
            FN(4, jd) = FN(4, jd) + Rot(22, i) * Efb(4, i) + Rot(28, i) * Efb(5, i) + Rot(34, i) * Efb(6, i)
            FN(5, jd) = FN(5, jd) + Rot(23, i) * Efb(4, i) + Rot(29, i) * Efb(5, i) + Rot(35, i) * Efb(6, i)
            FN(6, jd) = FN(6, jd) + Rot(24, i) * Efb(4, i) + Rot(30, i) * Efb(5, i) + Rot(36, i) * Efb(6, i)

            FN(1, jf) = FN(1, jf) + Rot(1, i) * Efb(7, i) + Rot(7, i) * Efb(8, i) + Rot(13, i) * Efb(9, i)
            FN(2, jf) = FN(2, jf) + Rot(2, i) * Efb(7, i) + Rot(8, i) * Efb(8, i) + Rot(14, i) * Efb(9, i)
            FN(3, jf) = FN(3, jf) + Rot(3, i) * Efb(7, i) + Rot(9, i) * Efb(8, i) + Rot(15, i) * Efb(9, i)
            FN(4, jf) = FN(4, jf) + Rot(22, i) * Efb(10, i) + Rot(28, i) * Efb(11, i) + Rot(34, i) * Efb(12, i)
            FN(5, jf) = FN(5, jf) + Rot(23, i) * Efb(10, i) + Rot(29, i) * Efb(11, i) + Rot(35, i) * Efb(12, i)
            FN(6, jf) = FN(6, jf) + Rot(24, i) * Efb(10, i) + Rot(30, i) * Efb(11, i) + Rot(36, i) * Efb(12, i)

        Next
        'affectation des rsultats
        'ractions d'appui
        For i = 1 To Total_noeud
            If Appui(i) = True Then
                FNodal(i_pas, i, 1) = FN(1, i) : FNodal(i_pas, i, 2) = FN(2, i) : FNodal(i_pas, i, 3) = FN(3, i)
                FNodal(i_pas, i, 4) = FN(4, i) : FNodal(i_pas, i, 5) = FN(5, i) : FNodal(i_pas, i, 6) = FN(6, i)
            End If
        Next
        'efforts dans les barres
        For i = 1 To Total_element
            eFBarre(i_pas, i, 1) = Efb(1, i) : eFBarre(i_pas, i, 2) = Efb(2, i) : eFBarre(i_pas, i, 3) = Efb(3, i)
            eFBarre(i_pas, i, 4) = Efb(4, i) : eFBarre(i_pas, i, 5) = Efb(5, i) : eFBarre(i_pas, i, 6) = Efb(6, i)
            eFBarre(i_pas, i, 7) = Efb(7, i) : eFBarre(i_pas, i, 8) = Efb(8, i) : eFBarre(i_pas, i, 9) = Efb(9, i)
            eFBarre(i_pas, i, 10) = Efb(10, i) : eFBarre(i_pas, i, 11) = Efb(11, i) : eFBarre(i_pas, i, 12) = Efb(12, i)
        Next
        ''affichage dans le fichier de dtails du calcul des efforts dans les barres et des ractions d'appui
        'Dim F_i, F_efb(6, Total_element), F_fn(3, Total_noeud) As String
        'msgg = msgg & "Efforts dans les barres:" & vbCrLf & _
        '"Barre      Normal      Tranchant   Flexion      Normal      Tranchant     Flexion" & vbCrLf
        'For i = 1 To Total_element
        '    F_efb(1, i) = Format(Efb(1, i), "###0.0") : F_efb(2, i) = Format(Efb(2, i), "###0.0")
        '    F_i = Format(i, "##") : F_efb(3, i) = Format(Efb(3, i), "###0.0")
        '    F_efb(4, i) = Format(Efb(4, i), "###0.0") : F_efb(5, i) = Format(Efb(5, i), "###0.0") : F_efb(6, i) = Format(Efb(6, i), "###0.0")
        '    msgg = msgg & F_i & "   " & F_efb(1, i) & "   " & F_efb(2, i) & "     " & F_efb(3, i) & "   " & F_efb(4, i) & "   " & F_efb(5, i) & "     " & F_efb(6, i) & vbCrLf
        'Next
        'msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
        'msgg = msgg & "Raction des appuis:" & vbCrLf & _
        '       "Noeuds      Force X      Force Y      Moment Z" & vbCrLf
        'For i = 1 To Total_noeud
        '    If Appui(i) = True Then
        '        F_fn(1, i) = Format(FN(1, i), "###0.0") : F_fn(2, i) = Format(FN(2, i), "###0.0")
        '        F_i = Format(i, "##") : F_fn(3, i) = Format(FN(3, i), "###0.0")
        '        msgg = msgg & F_i & "   " & F_fn(1, i) & "   " & F_fn(2, i) & "     " & F_fn(3, i) & vbCrLf
        '    End If
        'Next
        'msgg = msgg & vbCrLf 'permet de passer  la ligne suivante
    End Sub
    Private Sub Combinaison()
        Dim N_comb1, i, i_pas, j, total As Integer
        total = 0 : For i = 1 To 4 : total = total + Total_cas_de_charge(i) : Next i
        'calcul sur les combinaisons
        For i_pas = total + 1 To total + Total_combinaison(1)
            N_comb1 = i_pas - total '= N de combinaison
            For j = 1 To dim_Cas_comb(N_comb1) 'balayage du vecteur ensemble des cas pour la comb i
                'coef_pond(N de comb, N de cas de charge)
                For i = 1 To Total_noeud
                    'dplacements des noeuds dans le repre global
                    Depl(i_pas, i, 1) = Depl(i_pas, i, 1) + Depl(Cas_comb(j, N_comb1), i, 1) * Coef_pond(Cas_comb(j, N_comb1), N_comb1) 'Ux
                    Depl(i_pas, i, 2) = Depl(i_pas, i, 2) + Depl(Cas_comb(j, N_comb1), i, 2) * Coef_pond(Cas_comb(j, N_comb1), N_comb1) 'Uy
                    Depl(i_pas, i, 3) = Depl(i_pas, i, 3) + Depl(Cas_comb(j, N_comb1), i, 3) * Coef_pond(Cas_comb(j, N_comb1), N_comb1) 'Uz
                    Depl(i_pas, i, 4) = Depl(i_pas, i, 4) + Depl(Cas_comb(j, N_comb1), i, 4) * Coef_pond(Cas_comb(j, N_comb1), N_comb1) 'Rx
                    Depl(i_pas, i, 5) = Depl(i_pas, i, 5) + Depl(Cas_comb(j, N_comb1), i, 5) * Coef_pond(Cas_comb(j, N_comb1), N_comb1) 'Ry
                    Depl(i_pas, i, 6) = Depl(i_pas, i, 6) + Depl(Cas_comb(j, N_comb1), i, 6) * Coef_pond(Cas_comb(j, N_comb1), N_comb1) 'Rz
                    'ractions d'appui dans le repre global
                    FNodal(i_pas, i, 1) = FNodal(i_pas, i, 1) + FNodal(Cas_comb(j, N_comb1), i, 1) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 2) = FNodal(i_pas, i, 2) + FNodal(Cas_comb(j, N_comb1), i, 2) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 3) = FNodal(i_pas, i, 3) + FNodal(Cas_comb(j, N_comb1), i, 3) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 4) = FNodal(i_pas, i, 4) + FNodal(Cas_comb(j, N_comb1), i, 4) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 5) = FNodal(i_pas, i, 5) + FNodal(Cas_comb(j, N_comb1), i, 5) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    FNodal(i_pas, i, 6) = FNodal(i_pas, i, 6) + FNodal(Cas_comb(j, N_comb1), i, 6) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                Next
                'efforts dans les barres dans le repre local de la barre
                For i = 1 To Total_element
                    eFBarre(i_pas, i, 1) = eFBarre(i_pas, i, 1) + eFBarre(Cas_comb(j, N_comb1), i, 1) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 2) = eFBarre(i_pas, i, 2) + eFBarre(Cas_comb(j, N_comb1), i, 2) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 3) = eFBarre(i_pas, i, 3) + eFBarre(Cas_comb(j, N_comb1), i, 3) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 4) = eFBarre(i_pas, i, 4) + eFBarre(Cas_comb(j, N_comb1), i, 4) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 5) = eFBarre(i_pas, i, 5) + eFBarre(Cas_comb(j, N_comb1), i, 5) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 6) = eFBarre(i_pas, i, 6) + eFBarre(Cas_comb(j, N_comb1), i, 6) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 7) = eFBarre(i_pas, i, 7) + eFBarre(Cas_comb(j, N_comb1), i, 7) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 8) = eFBarre(i_pas, i, 8) + eFBarre(Cas_comb(j, N_comb1), i, 8) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 9) = eFBarre(i_pas, i, 9) + eFBarre(Cas_comb(j, N_comb1), i, 9) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 10) = eFBarre(i_pas, i, 10) + eFBarre(Cas_comb(j, N_comb1), i, 10) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 11) = eFBarre(i_pas, i, 11) + eFBarre(Cas_comb(j, N_comb1), i, 11) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                    eFBarre(i_pas, i, 12) = eFBarre(i_pas, i, 12) + eFBarre(Cas_comb(j, N_comb1), i, 12) * Coef_pond(Cas_comb(j, N_comb1), N_comb1)
                Next
            Next
        Next
    End Sub
End Module
