Imports System.Math
Imports System.IO
Module Non_Lineaire_3D
    Public Sub Analyse_Non_Lineaire_3D(ByRef structure_OK As Boolean)
        Call Analyse_Non_Lin_3D(structure_OK) 'calcul Flambement coef Cr
    End Sub
    Private Sub Analyse_Non_Lin_3D(ByRef structure_OK As Boolean)
        'Dtermination du coefficient d'amplification critique et de la valeur de la dforme sous le mode de
        'flambement correspondant
        '--> Dclarations de variables:
        'Kgt = matrice globale de ridit tangente de la structure
        'Kgt0 = matrice de rigidit tangente de l'lment
        Dim i, i1, j, k As Integer
        Dim Kgt(6 * Total_noeud, 6 * Total_noeud), L(Total_element), Rot(36, Total_element) As Double
        'Dim FN(3, Total_noeud), kt0(9, Total_element), kt1(9, Total_element), lt0(9, Total_element), lt1(9, Total_element) As Double
        Dim FN(6, Total_noeud), kt1(36, Total_element) As Double ', lt1(9, Total_element)
        Dim FB(12, Total_element), Dp(6, Total_noeud), Dp1(3, Total_noeud), Du As Double
        Dim Sr(Total_element) As Double
        Dim Fapp(3, Total_noeud) As Double
        ReDim IterPdeltaTol(Total_cas_de_charge(1) + Total_cas_de_charge(2)), PdeltaTol(Total_cas_de_charge(1) + Total_cas_de_charge(2))
        Dim Anl1(,), Anl2(,) As Double
        'dterminations des efforts normaux initiaux dans la structure pour chaque cas de charge de l'Analyse non linaire
        Call Analyse_Lineaire_3D(structure_OK, Kgt, kt1, L, Rot, 1, 2)
        Erase Kgt, kt1, L, Rot
        'Analyse non linaire dvelopp pour chaque cas de charge
        For i = Total_cas_de_charge(1) + 1 To Total_cas_de_charge(1) + Total_cas_de_charge(2)
            ReDim Dp(6, Total_noeud), Dp1(3, Total_noeud) 'remise  zro des variables
            ReDim Anl1(36, Total_element), Anl2(36, Total_element)
            IterPdeltaTol(i) = 0 : PdeltaTol(i) = 1 'reponse = 0 :
            Do
                For j = 1 To Total_noeud
                    Dp1(1, j) = Dp(1, j) : Dp1(2, j) = Dp(2, j) : Dp1(3, j) = Dp(3, j)
                Next
                'Remise  0 de Kgt, kt0, L, Rot
                ReDim Kgt(6 * Total_noeud, 6 * Total_noeud), L(Total_element), Rot(36, Total_element)
                ReDim kt1(36, Total_element)
                'Calcul de la matrice globale tangente de la structure
                Call Matrice_Rigidite_tangente_3D(Kgt, L, Rot, kt1, Anl1, Anl2, i, structure_OK) : If structure_OK = False Then Exit Sub
                Call Appui_elastique(Kgt)
                Call C_Limit_3D(Kgt, FN) ': If structure_OK = False Then Exit Sub
                'calcul du vecteur force
                If IterPdeltaTol(i) = 0 Then
                    Select Case Type_probleme
                        Case 3 'treillis
                            Call Second_Membre_Treillis_Spatial(L, FN, i)
                        Case 4 'portique
                            'If Def_Tranchant = True Then
                            '    'calcul du vecteur force avec prise en compte de l'effort tranchant
                            '    'Call Second_Membre_Portique_avec_G(L, Rot, FN, FB, i, Sr)
                            'Else
                            '    'calcul du vecteur force sans prise en compte de l'effort tranchant
                            '    Call Second_Membre_Portique_sans_G(L, Rot, FN, FB, i)
                            'End If
                        Case Else
                            MsgBox("Type de problme non identifi - Arrt des calculs", MsgBoxStyle.Exclamation, _
                            "Analyse non linaire 3D")
                            structure_OK = False : Exit Sub
                    End Select
                End If
                Call Resol_3D(FN, Fapp, Kgt, Dp, structure_OK, i) : If structure_OK = False Then Exit Sub
                Call Resultat_Non_Lin_3D(Dp, Rot, L, kt1, Anl1, Anl2, FB, i) 'ncessaire pour calculer eFBarre(2, 1, 4) et le rentrer dans la prochaine itration sur Kg
                IterPdeltaTol(i) = IterPdeltaTol(i) + 1
                'If IterPdeltaTol(i) = 1 Then Exit Sub
                k = 0 : Du = 0
                For i1 = 1 To Total_noeud
                    For j = 1 To 3
                        If Abs(Dp(j, i1)) > 0.00001 Then
                            k = k + 1
                            Du = Du + (((Dp1(j, i1) - Dp(j, i1)) / Dp(j, i1)) ^ 2) ^ 0.5 'difference de dformation sur itration actuelle
                        End If
                    Next
                Next
                PdeltaTol(i) = (Du / k)  'difference de dformation sur itration prcdente
                Du = PdeltaTol(i)
            Loop Until IterPdeltaTol(i) = MaxIter Or PdeltaTol(i) < MaxPdeltaTol
        Next
        Erase FN, FB, Dp, Sr, Fapp
    End Sub
    Private Sub Matrice_Rigidite_tangente_3D(ByRef Kg(,) As Double, ByRef L() As Double, ByRef Rot(,) As Double, _
                                            ByRef Kg0(,) As Double, ByRef Anl1(,) As Double, ByRef Anl2(,) As Double, _
                                            ByVal i_pas As Integer, ByRef structure_OK As Boolean)
        Dim i, j, jD, jF, k, k11 As Integer
        Dim a, alpha, beta, b0, c0, d1, d2, long1, x1, x2 As Double
        Dim k0(6, 6), Td(6, 6), Tg(6, 6), R(6, 6), Rt(6, 6) As Double
        Dim k1(6, 6), l0(6, 6), l1(6, 6), BB(6, 6) As Double

        'Matrice de rigidit globale en repre global de la structure = Kg
        'Variables : kg0(36,total_element ) = matrice de rigidit locale pour tous les lments
        '            k0(6, 6) = matrice de rigidit suprieure gauche
        '            k1(6, 6) = matrice de rigidit infrieure droite
        '            l0(6, 6) = matrice de rigidit infrieure gauche
        '            l1(6, 6) = matrice de rigidit suprieure droite
        '            Td(6,6) = matrice de transformation droite
        '            Tg(6,6) = matrice de transformation gauche
        '            R(6, 6) = matrice de rotation
        '            Rt(6, 6) = transpos de la matrice de rotation

        'composition de toutes les matrices lmentaires, lment par lment
        '1- construction de la matrice de rigidit locale kg0
        For i = 1 To Total_element
            a = X_noe(Ele(2, i)) - X_noe(Ele(1, i))
            b0 = Y_noe(Ele(2, i)) - Y_noe(Ele(1, i))
            c0 = Z_noe(Ele(2, i)) - Z_noe(Ele(1, i))
            L(i) = Sqrt(a ^ 2 + b0 ^ 2 + c0 ^ 2) 'longueur de l'lment
            'calcul de l'angle Alpha: rotation autour de l'axe Z
            long1 = Sqrt(a ^ 2 + b0 ^ 2)
            If long1 = 0 Then
                d1 = 0 : d2 = 0
            Else
                d1 = Acos(a / long1)
                d2 = Asin(b0 / long1)
            End If
            'l'angle alpha doit tre compris entre 0 et 2pi ce qui oblige  la gymnastique ci-dessous sinon
            'l'angle allait tre compris entre 0 et pi ou pi/2 et -pi/2 suivant si le calcul tait fait en
            'cosinus ou sinus
            If a >= 0 And b0 >= 0 Then  'quadrant 1
                alpha = d1
            ElseIf a <= 0 And b0 >= 0 Then 'quadrant 2
                alpha = d1
            ElseIf a <= 0 And b0 <= 0 Then 'quadrant 3
                alpha = PI - d2  'd2 est ngatif
            ElseIf a >= 0 And b0 <= 0 Then 'quadrant 4
                alpha = 2 * PI + d2
            End If
            'Projection des nouvelles coordonnes dans le repre Ox1y1z1
            x1 = Cos(alpha) * X_noe(Ele(1, i)) + Sin(alpha) * Y_noe(Ele(1, i))
            x2 = Cos(alpha) * X_noe(Ele(2, i)) + Sin(alpha) * Y_noe(Ele(2, i))
            a = x2 - x1
            'calcul de l'angle beta: rotation autour de l'axe Y1
            long1 = Sqrt(a ^ 2 + c0 ^ 2)
            If long1 = 0 Then
                d1 = 0 : d2 = 0
            Else
                d1 = Acos(a / long1)
                d2 = Asin(c0 / long1)
            End If
            'l'angle beta doit tre compris entre 0 et 2pi ce qui oblige  la gymnastique ci-dessous sinon
            'l'angle allait tre compris entre 0 et pi ou pi/2 et -pi/2 suivant si le calcul tait fait en
            'cosinus ou sinus
            If a >= 0 And c0 >= 0 Then  'quadrant 1
                beta = d1
            ElseIf a <= 0 And c0 >= 0 Then 'quadrant 2
                beta = d1
            ElseIf a <= 0 And c0 <= 0 Then 'quadrant 3
                beta = PI - d2  'd2 est ngatif
            ElseIf a >= 0 And c0 <= 0 Then 'quadrant 4
                beta = 2 * PI + d2
            End If
            ' si element a tous ses noeuds encastrs alors Call K_3D_tout_encastre avec I constant ou variable
            If Rel_ele(1, i) = False And Rel_ele(2, i) = False Then
                MsgBox("Impossible d'effectuer l'analyse non linaire 3D sur portique spatial" & vbCrLf & _
                        "Analyse hors du domaine de validit du logiciel", MsgBoxStyle.Information, "Analyse linaire 3 D")
                structure_OK = False : Exit Sub
                'Call K_3D_tout_encastre(i, L(i), Kg0)
            End If
            ' si noe 1 relax et noe 2 encastr 
            If Rel_ele(1, i) = True And Rel_ele(2, i) = False Then
                MsgBox("Impossible d'effectuer l'analyse non linaire 3D sur portique spatial" & vbCrLf & _
                                        "Analyse hors du domaine de validit du logiciel", MsgBoxStyle.Information, "Analyse linaire 3 D")
                structure_OK = False : Exit Sub
                'Call K_3D_gauche_relaxe(i, alpha, L(i), Kg0)
            End If
            ' si noe 1 encastr et noe 2 relax alors 
            If Rel_ele(1, i) = False And Rel_ele(2, i) = True Then
                MsgBox("Impossible d'effectuer l'analyse non linaire 3D sur portique spatial" & vbCrLf & _
                                        "Analyse hors du domaine de validit du logiciel", MsgBoxStyle.Information, "Analyse linaire 3 D")
                structure_OK = False : Exit Sub
                'Call K_3D_droit_relaxe(i, alpha, L(i), Kg0)
            End If
            ' si noe 1 relax et noe 2 relax
            If Rel_ele(1, i) = True And Rel_ele(2, i) = True Then
                Call Kt_3D_tout_relaxe(i, L(i), eFBarre(i_pas, i, 7), Kg0, Anl1, Anl2)
            End If
            Call Rotation(i, alpha, beta, Rot)
        Next i
        '2 - Assemblage de la matrice
        'mise  zro de la matrice de rigidit globale
        For i = 1 To 6 * Total_noeud
            For j = 1 To 6 * Total_noeud
                Kg(i, j) = 0
            Next
        Next
        'assemblage matrice
        For i = 1 To Total_element
            'assemblage matrice rigidit locale infrieure droite = k1
            j = 0
            For k = 1 To 6
                For k11 = 1 To 6
                    j = j + 1
                    k1(k, k11) = Kg0(j, i)
                Next
            Next
            'calcul des matrices transfert Td et Tg
            For k = 1 To 6
                For k11 = 1 To 6
                    Td(k, k11) = 0 : Tg(k, k11) = 0
                Next
                Td(k, k) = -1 : Tg(k, k) = -1
            Next
            Td(2, 6) = -L(i) : Td(3, 5) = L(i)
            Tg(6, 2) = -L(i) : Tg(5, 3) = L(i)

            'mise de rot dans R et Rt
            j = 0
            For k = 1 To 6
                For k11 = 1 To 6
                    j = j + 1
                    R(k, k11) = Rot(j, i) : Rt(k11, k) = Rot(j, i)
                Next
            Next

            'calcul des matrices K0,L0 et L1
            Call Matmul(Tg, k1, l1)
            Call Matmul(l1, Td, k0)
            Call Matmul(k1, Td, l0)
            'rotation et addition
            jD = Ele(1, i) : jF = Ele(2, i) 'numro de noeud de dbut et fin de barre
            Call Matmul(Rt, k0, BB)
            Call Matmul(BB, R, k0)      'transformation k0 -> K0
            Call MatAdd(Kg, k0, jD, jD) 'entre de K0 dans la matrice globale

            Call Matmul(Rt, Anl1, BB)
            Call Matmul(BB, R, Anl1)
            Call MatAdd(Kg, Anl1, jD, jD)

            Call Matmul(Rt, k1, BB) ' -> K1
            Call Matmul(BB, R, k1)
            Call MatAdd(Kg, k1, jF, jF)

            Call Matmul(Rt, Anl1, BB)
            Call Matmul(BB, R, Anl1)
            Call MatAdd(Kg, Anl1, jF, jF)

            Call Matmul(Rt, l0, BB) ' -> L0
            Call Matmul(BB, R, l0)
            Call MatAdd(Kg, l0, jF, jD)

            Call Matmul(Rt, Anl2, BB)
            Call Matmul(BB, R, Anl2)
            Call MatAdd(Kg, Anl2, jF, jD)

            Call Matmul(Rt, l1, BB) ' -> L1
            Call Matmul(BB, R, l1)
            Call MatAdd(Kg, l1, jD, jF)

            Call Matmul(Rt, Anl2, BB)
            Call Matmul(BB, R, Anl2)
            Call MatAdd(Kg, Anl2, jD, jF)
        Next
        'Pour viter la matrice singulire et continuer le calcul 
        'For i = 1 To Total_noeud * 6
        '    If Kg(i, i) = 0 Then
        '        Kg(i, i) = 1
        '    End If
        'Next
        'Libration de mmoire
        Erase k0, Td, Tg, k1, l0, l1, BB, R, Rt
    End Sub
    Private Sub Kt_3D_tout_relaxe(ByVal k As Integer, ByVal l As Double, ByVal N As Double, ByRef A(,) As Double, _
    ByRef Anl1(,) As Double, ByRef Anl2(,) As Double)
        'Nota: k=n de l'lment, l=longueur de l'lment et le sous-programme retourne A(,) qui est
        '      la matrice de rigidit lmentaire de l'lment k0 (=ki dans le cours)

        Dim i As Integer
        A(1, k) = (Ey(k) * Sx(k) / l) : A(2, k) = 0 : A(3, k) = 0 : A(4, k) = 0 : A(5, k) = 0 : A(6, k) = 0
        A(7, k) = 0 : A(8, k) = 0 : A(9, k) = 0 : A(10, k) = 0 : A(11, k) = 0 : A(12, k) = 0
        A(13, k) = 0 : A(14, k) = 0 : A(15, k) = 0 : A(16, k) = 0 : A(17, k) = 0 : A(18, k) = 0
        A(19, k) = 0 : A(20, k) = 0 : A(21, k) = 0 : A(22, k) = 0 : A(23, k) = 0 : A(24, k) = 0
        A(25, k) = 0 : A(26, k) = 0 : A(27, k) = 0 : A(28, k) = 0 : A(29, k) = 0 : A(30, k) = 0
        A(31, k) = 0 : A(32, k) = 0 : A(33, k) = 0 : A(34, k) = 0 : A(35, k) = 0 : A(36, k) = 0

        For i = 1 To 36
            Anl1(i, k) = 0 : Anl2(i, k) = 0
        Next
        Anl1(1, k) = (N / l) : Anl1(8, k) = (N / l) : Anl1(15, k) = (N / l)
        Anl2(1, k) = -(N / l) : Anl2(8, k) = -(N / l) : Anl2(15, k) = -(N / l)
        

    End Sub
    Private Sub Rotation(ByVal k As Integer, ByVal alpha As Double, ByVal beta As Double, ByRef A(,) As Double)
        Dim k1 As Integer
        'matrice de rotation R pour passer du repre global au repre local: {x}= [R] {X}
        'k=N de l'lment
        For k1 = 1 To 36
            A(k1, k) = 0
        Next
        Gamma(k) = Gamma(k) * PI / 180 'transformation degr->radian

        A(1, k) = Cos(alpha) * Cos(beta)
        A(2, k) = Sin(alpha) * Cos(beta)
        A(3, k) = Sin(beta)
        A(7, k) = -Cos(Gamma(k)) * Sin(alpha) - Sin(Gamma(k)) * Sin(beta) * Cos(alpha)
        A(8, k) = Cos(Gamma(k)) * Cos(alpha) - Sin(Gamma(k)) * Sin(alpha) * Sin(beta)
        A(9, k) = Sin(Gamma(k)) * Cos(beta)
        A(13, k) = Sin(Gamma(k)) * Sin(alpha) - Cos(Gamma(k)) * Sin(beta) * Cos(alpha)
        A(14, k) = -Sin(Gamma(k)) * Cos(alpha) - Cos(Gamma(k)) * Sin(alpha) * Sin(beta)
        A(15, k) = Cos(Gamma(k)) * Cos(beta)
        '----
        A(22, k) = A(1, k)
        A(23, k) = A(2, k)
        A(24, k) = A(3, k)
        A(28, k) = A(7, k)
        A(29, k) = A(8, k)
        A(30, k) = A(9, k)
        A(34, k) = A(13, k)
        A(35, k) = A(14, k)
        A(36, k) = A(15, k)

    End Sub
    Private Sub Matmul(ByVal AA(,) As Double, ByVal BB(,) As Double, ByRef CC(,) As Double)
        'Sous-programme de multiplication de matrice 6x6
        Dim i, j, k As Integer
        Dim sum As Double
        For i = 1 To 6
            For j = 1 To 6
                sum = 0
                For k = 1 To 6
                    sum = sum + AA(i, k) * BB(k, j)
                Next
                CC(i, j) = sum
            Next
        Next
    End Sub
    Private Sub MatAdd(ByRef AK(,) As Double, ByVal A(,) As Double, ByVal Jlig As Integer, ByVal Jcol As Integer)
        'Sous-programme d'addition de la matrice A en ligne Jlig et colonne jcol dans la matrice Kg
        Dim i, j, ii, jj, il, ic As Integer
        ii = 6 * (Jlig - 1)
        jj = 6 * (Jcol - 1)
        For i = 1 To 6
            For j = 1 To 6
                il = ii + i
                ic = jj + j
                AK(il, ic) = AK(il, ic) + A(i, j)
            Next
        Next
    End Sub
    Private Sub C_Limit_Kgt_3D(ByRef Kg(,) As Double, ByRef Fapp(,) As Double, ByRef structure_OK As Boolean)
        'Prise en compte des conditions d'appui et des relaxations
        Dim i, i3, jj As Integer
        For i = 1 To Total_noeud
            Fapp(1, i) = 1 : Fapp(2, i) = 1 : Fapp(3, i) = 1
            If Appui(i) = True Then 'test si noeud est un appui
                i3 = (i - 1) * 6
                If R_appui(1, i) = False Then
                    'Dplacement non autorise suivant X -> Ux=0
                    For jj = 1 To 6 * Total_noeud
                        Kg(i3 + 1, jj) = 0 : Kg(jj, i3 + 1) = 0
                    Next
                    Kg(i3 + 1, i3 + 1) = 1 : Fapp(1, i) = 0
                End If
                If R_appui(2, i) = False Then
                    'Dplacement non autorise suivant Y -> Uy=0
                    For jj = 1 To 6 * Total_noeud
                        Kg(i3 + 2, jj) = 0 : Kg(jj, i3 + 2) = 0
                    Next
                    Kg(i3 + 2, i3 + 2) = 1 : Fapp(2, i) = 0
                End If
                If R_appui(3, i) = False Then
                    'Dplacement non autorise suivant Z -> Uz=0
                    For jj = 1 To 6 * Total_noeud
                        Kg(i3 + 3, jj) = 0 : Kg(jj, i3 + 3) = 0
                    Next
                    Kg(i3 + 3, i3 + 3) = 1 : Fapp(3, i) = 0
                End If
                'If Type_probleme = 4 Then
                '    'ce test n'est valable uniquement que pour les structures de type portique
                '    If R_appui(6, i) = False Then
                '        'Rotation non autorise  ->  ttaZ=0
                '        For jj = 1 To 3 * Total_noeud
                '            Kg(i3 + 3, jj) = 0 : Kg(jj, i3 + 3) = 0
                '        Next
                '        Kg(i3 + 3, i3 + 3) = 1 : Fapp(3, i) = 0
                '    End If
                'End If
            End If
        Next
    End Sub
    Private Sub Resultat_Non_Lin_3D(ByVal Dp(,) As Double, ByVal Rot(,) As Double, ByVal L() As Double, ByVal Kg0(,) As Double, _
                                     ByVal Anl1(,) As Double, ByVal Anl2(,) As Double, ByVal FB(,) As Double, _
                                     ByVal i_pas As Integer)
        'calcul des efforts dans les barres et des ractions d'appui
        Dim Efb(12, Total_element), FN(6, Total_noeud), Dpp(6), K1(6, 6), Tg(6, 6), L1(6, 6) As Double
        Dim A0, A1, B0, B1, C0, C1, X0, X1, Y0, Y1, Z0, Z1, F0, F1 As Double
        Dim i, ii, j, jj, jd, jf As Integer
        Dim Anl11(6, 6), Anl22(6, 6) As Double
        'Phase 1 : calcul des efforts dans les barres
        For i = 1 To Total_element
            'mise  zro de Efb
            For j = 1 To 12
                Efb(j, i) = 0
            Next
            'dplacement absolu des noeuds dans le repre local pour chaque lment
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            X0 = Dp(1, jd) * Rot(1, i) + Dp(2, jd) * Rot(2, i) + Dp(3, jd) * Rot(3, i)
            Y0 = Dp(1, jd) * Rot(7, i) + Dp(2, jd) * Rot(8, i) + Dp(3, jd) * Rot(9, i)
            Z0 = Dp(1, jd) * Rot(13, i) + Dp(2, jd) * Rot(14, i) + Dp(3, jd) * Rot(15, i)
            A0 = Dp(4, jd) * Rot(22, i) + Dp(5, jd) * Rot(23, i) + Dp(6, jd) * Rot(24, i)
            B0 = Dp(4, jd) * Rot(28, i) + Dp(5, jd) * Rot(29, i) + Dp(6, jd) * Rot(30, i)
            C0 = Dp(4, jd) * Rot(34, i) + Dp(5, jd) * Rot(35, i) + Dp(6, jd) * Rot(36, i)

            X1 = Dp(1, jf) * Rot(1, i) + Dp(2, jf) * Rot(2, i) + Dp(3, jf) * Rot(3, i)
            Y1 = Dp(1, jf) * Rot(7, i) + Dp(2, jf) * Rot(8, i) + Dp(3, jf) * Rot(9, i)
            Z1 = Dp(1, jf) * Rot(13, i) + Dp(2, jf) * Rot(14, i) + Dp(3, jf) * Rot(15, i)
            A1 = Dp(4, jf) * Rot(22, i) + Dp(5, jf) * Rot(23, i) + Dp(6, jf) * Rot(24, i)
            B1 = Dp(4, jf) * Rot(28, i) + Dp(5, jf) * Rot(29, i) + Dp(6, jf) * Rot(30, i)
            C1 = Dp(4, jf) * Rot(34, i) + Dp(5, jf) * Rot(35, i) + Dp(6, jf) * Rot(36, i)
            'calcul des dplacements relatifs
            Dpp(1) = X1 - X0
            Dpp(2) = Y1 - Y0 - C0 * L(i)
            Dpp(3) = Z1 - Z0 + B0 * L(i)
            Dpp(4) = A1 - A0
            Dpp(5) = B1 - B0
            Dpp(6) = C1 - C0
            'calcul de la matrice K1 et L1
            j = 0
            For ii = 1 To 6
                For jj = 1 To 6
                    j = j + 1
                    K1(ii, jj) = Kg0(j, i) : Anl11(ii, jj) = Anl1(j, i) : Anl22(ii, jj) = Anl2(j, i)
                Next
            Next
            'matrice de transposition
            For ii = 1 To 6
                For jj = 1 To 6
                    Tg(ii, jj) = 0
                Next
                Tg(ii, ii) = -1
            Next
            Tg(6, 2) = -L(i) : Tg(5, 3) = L(i)
            'calcul de la matrice L1
            Call Matmul(Tg, K1, L1)
            'Efforts dus aux dplacements
            For ii = 1 To 6
                F0 = 0 : F1 = 0
                For jj = 1 To 6
                    F0 = F0 + L1(ii, jj) * Dpp(jj) + Anl22(ii, jj) * Dpp(jj)
                    F1 = F1 + K1(ii, jj) * Dpp(jj) + Anl11(ii, jj) * Dpp(jj)
                Next
                Efb(ii, i) = Efb(ii, i) + F0
                Efb(ii + 6, i) = Efb(ii + 6, i) + F1
            Next
            'Ajout des termes dus aux forces sur les barres
            For ii = 1 To 12
                Efb(ii, i) = Efb(ii, i) + FB(ii, i)
            Next
        Next

        'phase 2 :  raction d'appui
        For ii = 1 To Total_noeud
            For jj = 1 To 6
                FN(jj, ii) = 0
            Next
        Next
        'boucle sur les barres
        For i = 1 To Total_element
            jd = Ele(1, i) : jf = Ele(2, i) 'numro de noeud de dbut et fin de barre
            FN(1, jd) = FN(1, jd) + Rot(1, i) * Efb(1, i) + Rot(7, i) * Efb(2, i) + Rot(13, i) * Efb(3, i)
            FN(2, jd) = FN(2, jd) + Rot(2, i) * Efb(1, i) + Rot(8, i) * Efb(2, i) + Rot(14, i) * Efb(3, i)
            FN(3, jd) = FN(3, jd) + Rot(3, i) * Efb(1, i) + Rot(9, i) * Efb(2, i) + Rot(15, i) * Efb(3, i)
            FN(4, jd) = FN(4, jd) + Rot(22, i) * Efb(4, i) + Rot(28, i) * Efb(5, i) + Rot(34, i) * Efb(6, i)
            FN(5, jd) = FN(5, jd) + Rot(23, i) * Efb(4, i) + Rot(29, i) * Efb(5, i) + Rot(35, i) * Efb(6, i)
            FN(6, jd) = FN(6, jd) + Rot(24, i) * Efb(4, i) + Rot(30, i) * Efb(5, i) + Rot(36, i) * Efb(6, i)

            FN(1, jf) = FN(1, jf) + Rot(1, i) * Efb(7, i) + Rot(7, i) * Efb(8, i) + Rot(13, i) * Efb(9, i)
            FN(2, jf) = FN(2, jf) + Rot(2, i) * Efb(7, i) + Rot(8, i) * Efb(8, i) + Rot(14, i) * Efb(9, i)
            FN(3, jf) = FN(3, jf) + Rot(3, i) * Efb(7, i) + Rot(9, i) * Efb(8, i) + Rot(15, i) * Efb(9, i)
            FN(4, jf) = FN(4, jf) + Rot(22, i) * Efb(10, i) + Rot(28, i) * Efb(11, i) + Rot(34, i) * Efb(12, i)
            FN(5, jf) = FN(5, jf) + Rot(23, i) * Efb(10, i) + Rot(29, i) * Efb(11, i) + Rot(35, i) * Efb(12, i)
            FN(6, jf) = FN(6, jf) + Rot(24, i) * Efb(10, i) + Rot(30, i) * Efb(11, i) + Rot(36, i) * Efb(12, i)

        Next
        'affectation des rsultats
        'ractions d'appui
        For i = 1 To Total_noeud
            If Appui(i) = True Then
                FNodal(i_pas, i, 1) = FN(1, i) : FNodal(i_pas, i, 2) = FN(2, i) : FNodal(i_pas, i, 3) = FN(3, i)
                FNodal(i_pas, i, 4) = FN(4, i) : FNodal(i_pas, i, 5) = FN(5, i) : FNodal(i_pas, i, 6) = FN(6, i)
            End If
        Next
        'efforts dans les barres
        For i = 1 To Total_element
            eFBarre(i_pas, i, 1) = Efb(1, i) : eFBarre(i_pas, i, 2) = Efb(2, i) : eFBarre(i_pas, i, 3) = Efb(3, i)
            eFBarre(i_pas, i, 4) = Efb(4, i) : eFBarre(i_pas, i, 5) = Efb(5, i) : eFBarre(i_pas, i, 6) = Efb(6, i)
            eFBarre(i_pas, i, 7) = Efb(7, i) : eFBarre(i_pas, i, 8) = Efb(8, i) : eFBarre(i_pas, i, 9) = Efb(9, i)
            eFBarre(i_pas, i, 10) = Efb(10, i) : eFBarre(i_pas, i, 11) = Efb(11, i) : eFBarre(i_pas, i, 12) = Efb(12, i)
        Next
    End Sub
End Module
