﻿Imports System.IO
Public Class frmStructure

    Private Sub frmStructure_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        passage = 0
        Call initialisation()
        MnuNdcPortMetal.Enabled = False
        'Ouverture, une seule fois du fichier Excel contenant les caractéristiques géométriques des profilés
        Try
            IPE = Directory.GetCurrentDirectory.ToString() & "\IPE.txt"
            HE_HL = Directory.GetCurrentDirectory.ToString() & "\HE_HL.txt"
            IPN = Directory.GetCurrentDirectory.ToString() & "\IPN.txt"
        Catch exc As Exception
            Dim msg As String
            msg = "Erreur: " & exc.Message & vbCrLf & "Problème d'accés au fichier des profilés"
            MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Logiciel Structure")
            Exit Sub
        End Try
    End Sub
    Private Sub frmStructure_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Dim reponse As Integer
        reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1, "Structure")
        If reponse = 6 Then
            Dim myProcesses() As Process
            Dim myProcess As Process
            ' Contrôle des process
            ' Si un process EXCEL tourne encore je le flingue...
            myProcesses = Process.GetProcesses()
            For Each myProcess In myProcesses
                If UCase(myProcess.ProcessName) = "EXCEL" Then
                    myProcess.Kill()
                End If
            Next
            e.Cancel = False
            End
        Else
            e.Cancel = True
        End If
    End Sub
    Private Sub frmStructure_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        ' Contrôle des process
        Dim myProcesses() As Process
        Dim myProcess As Process
        ' Si un process EXCEL tourne encore je le flingue...
        myProcesses = Process.GetProcesses()
        For Each myProcess In myProcesses
            If UCase(myProcess.ProcessName) = "EXCEL" Then
                myProcess.Kill()
            End If
        Next
    End Sub
  
    Private Sub Printing()
        'Try
        '    streamToPrint = New StreamReader(filePath)
        '    Try
        '        printFont = New Font("Arial", 10)
        '        Dim pd As New PrintDocument
        '        AddHandler pd.PrintPage, AddressOf pd_PrintPage
        '        pd.PrinterSettings.PrinterName = printer
        '        ' Set the page orientation to landscape.
        '        pd.DefaultPageSettings.Landscape = True
        '        pd.Print()
        '    Finally
        '        streamToPrint.Close()
        '    End Try
        'Catch ex As Exception
        '    MessageBox.Show(ex.Message)
        'End Try
    End Sub

#Region "Gestion des menus"
    Private Sub MnuNouveauProjet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuNouveauProjet.Click
        l_strFileName = ""
    End Sub
    Private Sub MnuOuvrirUnProjetExistant_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuOuvrirUnProjetExistant.Click
        Try
            With OpenFileDialog1
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Fichiers textes (*.rtf)|*.rtf|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        l_strFileName = .FileName
                        Dim toto As String = l_strFileName
                        Call Lecture_chaine(toto)
                        Me.Text = "Structure : [" & toto & " ]"
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try

        'OpenFileDialog1.ShowDialog()
        'If OpenFileDialog1.FileName <> "" Then
        '    l_strFileName = OpenFileDialog1.FileName
        '    Dim toto As String = l_strFileName
        '    Call Lecture_chaine(toto)
        '    Me.Text = "Structure : [" & toto & " ]"
        'End If
        ''MessageBox.Show("You selected """ & OpenFileDialog1.FileName & """")
    End Sub
    Private Sub Lecture_chaine(ByRef toto As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        Try
            Dim i, position As Integer
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            position = InStrRev(toto, "\")
            i = i - position
            toto = Microsoft.VisualBasic.Right(toto, i)
        Catch ex As Exception

        End Try

    End Sub
    Private Sub MnuEnregistrerLeProjetSous_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuEnregistrerLeProjetSous.Click
        Dim SaveFileDialog As New SaveFileDialog
        SaveFileDialog.Title = "Enregistrer le projet sous ..."
        SaveFileDialog.InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
        SaveFileDialog.Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
        SaveFileDialog.FilterIndex = 1
        SaveFileDialog.RestoreDirectory = True
        SaveFileDialog.ShowDialog()
        If SaveFileDialog.FileName <> "" Then
            Stop
            'FileName = SaveFileDialog.FileName
            'Call Ecriture_Fichier() 'ecriture du dallage complet
        End If
    End Sub
    Private Sub MnuQuitter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuQuitter.Click
        Dim reponse As Integer
        reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1, "Structure")
        If reponse = 6 Then
            If (UBound(Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)) > 0) = True Then
                For Each ThisApp As Diagnostics.Process In Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)
                    ThisApp.Kill()
                Next
            End If
            Dim myProcesses() As Process
            Dim myProcess As Process
            myProcesses = Process.GetProcesses()
            For Each myProcess In myProcesses
                If UCase(myProcess.ProcessName) = "EXCEL" Then
                    myProcess.Kill()
                End If
            Next
            End
        End If
    End Sub
    'Private Sub mnuImprimer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    PrintDialog1.ShowDialog()
    'End Sub

    'Private Sub mnuConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    PageSetupDialog1.ShowDialog()
    'End Sub
    Private Sub MnuEditeur_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuEditeur.Click
        Select Case editeur
            Case 1
                'Appel à Notepad pour l'affichage du fichier de données (cela ne sert à rien de réinventer la roue !!!!)
                Dim startInfo As New ProcessStartInfo("notepad.exe")
                startInfo.WindowStyle = ProcessWindowStyle.Normal
                startInfo.Arguments = l_strFileName
                Process.Start(startInfo)
            Case 2
                'Appel à Wordpad pour l'affichage du fichier de données (cela ne sert à rien de réinventer la roue !!!!)
                Dim startInfo As New ProcessStartInfo("wordpad.exe")
                startInfo.WindowStyle = ProcessWindowStyle.Normal
                startInfo.Arguments = l_strFileName
                Process.Start(startInfo)
            Case 3
                Dim frm1 As New frmEdit
                frm1.Affichage_frmEdit(l_strFileName)
        End Select

    End Sub
    Private Sub MnuVisualisation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuVisualisation.Click
        Dim donnee_OK As Boolean
        'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
        'sinon le calcul est arreté.
        Call Lecture_fichier(donnee_OK)
        If donnee_OK = False Then Exit Sub
        My.Forms.frmVisu.MdiParent = Me
        My.Forms.frmVisu.Show()
    End Sub
    Private Sub MnuGenPortMetal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuGenPortMetal.Click
        My.Forms.frmGenPortMetal.MdiParent = Me
        My.Forms.frmGenPortMetal.Show()
    End Sub
    Private Sub MnuGenComb_Click(sender As System.Object, e As System.EventArgs) Handles MnuGenComb.Click
        My.Forms.frmGenComb.MdiParent = Me
        My.Forms.frmGenComb.Show()
    End Sub
    'Private Sub MnuAnalyseStatiqueLinéaire_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAnalyseStatiqueLinéaire.Click
    '    Dim donnee_OK, structure_OK As Boolean
    '    Dim msg As String
    '    Dim i, Total As Integer
    '    'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
    '    'sinon le calcul est arreté.
    '    Call Lecture_fichier(xl, donnee_OK)
    '    If donnee_OK = False Then Exit Sub
    '    Total = 0 : For i = 1 To 4 : Total = Total + Total_combinaison(i) + Total_cas_de_charge(i) : Next
    '    Cal_Statique_lin = True : structure_OK = True
    '    Cal_Dynamique_lin = False : Cal_Dynamique_Non_lin = False
    '    Select Case Type_probleme
    '        Case 1, 2 'treillis ou portique plan
    '            Dim Kg(3 * Total_noeud, 3 * Total_noeud), kg0(9, Total_element), L(Total_element), Rot(9, Total_element) As Double
    '            'Ajustement des tableaux existants: variables publiques
    '            ReDim eFBarre1(Total, Total_element, 6), FNodal1(Total, Total_noeud, 3), Depl1(Total, Total_noeud, 3)
    '            ReDim eFBarre(Total, Total_element, 6), FNodal(Total, Total_noeud, 3), Depl(Total, Total_noeud, 3)
    '            Call Analyse_Lineaire_2D(structure_OK, Kg, kg0, L, Rot, 0, 1)
    '        Case 3, 4 'idem mais spatial
    '            Dim Kg(6 * Total_noeud, 6 * Total_noeud), kg0(36, Total_element), L(Total_element), Rot(36, Total_element) As Double
    '            'Ajustement des tableaux existants: variables publiques
    '            ReDim eFBarre1(Total, Total_element, 12), FNodal1(Total, Total_noeud, 6), Depl1(Total, Total_noeud, 6)
    '            ReDim eFBarre(Total, Total_element, 12), FNodal(Total, Total_noeud, 6), Depl(Total, Total_noeud, 6)
    '            Call Analyse_Lineaire_3D(structure_OK, Kg, kg0, L, Rot, 0, 1)
    '        Case 5 'grille
    '            Stop
    '    End Select
    '    If structure_OK = False Then Exit Sub
    '    msg = "Analyse linéaire de la structure terminée."
    '    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    'End Sub
    'Private Sub MnuAnalyseStatiqueNonLinéairePortiqueBétonArmé_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAnalyseStatiqueNonLinéairePortiqueBétonArmé.Click
    '    'Analyse statique non linéaire de portique BA suivant méthode COIN
    '    Dim donnee_OK, structure_OK As Boolean
    '    Dim msg As String
    '    Dim i, Total As Integer
    '    'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
    '    'sinon le calcul est arreté.
    '    Call Mise_a_zero_charge()
    '    Call Mise_a_zero_Statique_Non_Lineaire() 'effacement des éventuelles anciennes valeurs
    '    Call Lecture_fichier(xl, donnee_OK)
    '    If donnee_OK = False Then Exit Sub
    '    Total = 0 : For i = 1 To 4 : Total = Total + Total_combinaison(i) + Total_cas_de_charge(i) : Next
    '    structure_OK = True
    '    If Cal_Statique_Non_lin = True Then
    '        Select Case Type_probleme
    '            Case 1, 2 'treillis ou portique plan
    '                Dim Kg(3 * Total_noeud, 3 * Total_noeud), kg0(9, Total_element), L(Total_element), Rot(9, Total_element) As Double
    '                'Ajustement des tableaux existants: variables publiques
    '                ReDim eFBarre1(Total, Total_element, 6), FNodal1(Total, Total_noeud, 3), Depl1(Total, Total_noeud, 3)
    '                ReDim eFBarre(Total, Total_element, 6), FNodal(Total, Total_noeud, 3), Depl(Total, Total_noeud, 3)
    '                Call Analyse_Non_Lineaire_2D(structure_OK)
    '            Case 3, 4 'idem mais spatial
    '                'If Type_probleme = 4 Then
    '                msg = "Désolé!!!  cette version ne permet pas le calcul BA 3D non linéaire"
    '                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")

    '                'Else
    '                '    Dim Kg(6 * Total_noeud, 6 * Total_noeud), kg0(36, Total_element), L(Total_element), Rot(36, Total_element) As Double
    '                '    'Ajustement des tableaux existants: variables publiques
    '                '    ReDim eFBarre1(Total, Total_element, 12), FNodal1(Total, Total_noeud, 6), Depl1(Total, Total_noeud, 6)
    '                '    ReDim eFBarre(Total, Total_element, 12), FNodal(Total, Total_noeud, 6), Depl(Total, Total_noeud, 6)
    '                '    Call Analyse_Lineaire_3D(structure_OK, Kg, kg0, L, Rot, 0, 1)
    '                'End If
    '            Case 5 'grille
    '                msg = "Désolé!!!  cette version ne permet pas le calcul BA 3D non linéaire"
    '                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '        End Select
    '        If structure_OK = False Then Exit Sub
    '        msg = "Analyse Non Linéaire de la structure terminée."
    '        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '    Else
    '        msg = "Désolé, mais vous n'avez pas spécifié d'Analyse Non Linéaire" & vbCrLf & _
    '        "dans votre fichier de données."
    '        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '    End If
    'End Sub
    'Private Sub MnuAnalyseStatiqueNonLinéaireFlambementGénéralisé_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAnalyseStatiqueNonLinéaireFlambementGénéralisé.Click
    '    'Analyse statique non linéaire - Flambement généralisé
    '    Dim donnee_OK, structure_OK As Boolean
    '    Dim msg As String
    '    Dim i, Total As Integer
    '    'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
    '    'sinon le calcul est arreté.
    '    Call Mise_a_zero_charge()
    '    Call Mise_a_zero_Statique_Non_Lineaire() 'effacement des éventuelles anciennes valeurs
    '    Call Lecture_fichier(xl, donnee_OK)
    '    If donnee_OK = False Then Exit Sub
    '    Total = 0 : For i = 1 To 4 : Total = Total + Total_combinaison(i) + Total_cas_de_charge(i) : Next
    '    structure_OK = True
    '    If Cal_Statique_Non_lin = True Then
    '        Select Case Type_probleme
    '            Case 1, 2 'treillis ou portique plan
    '                Dim Kg(3 * Total_noeud, 3 * Total_noeud), kg0(9, Total_element), L(Total_element), Rot(9, Total_element) As Double
    '                'Ajustement des tableaux existants: variables publiques
    '                ReDim eFBarre1(Total, Total_element, 6), FNodal1(Total, Total_noeud, 3), Depl1(Total, Total_noeud, 3)
    '                ReDim eFBarre(Total, Total_element, 6), FNodal(Total, Total_noeud, 3), Depl(Total, Total_noeud, 3)
    '                Call Analyse_Non_Lineaire_2D(structure_OK)
    '            Case 3, 4 'idem mais spatial
    '                If Type_probleme = 4 Then
    '                    msg = "Désolé!!!  cette version ne permet pas le calcul  3D"
    '                    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")

    '                Else
    '                    Dim Kg(6 * Total_noeud, 6 * Total_noeud), kg0(36, Total_element), L(Total_element), Rot(36, Total_element) As Double
    '                    'Ajustement des tableaux existants: variables publiques
    '                    ReDim eFBarre1(Total, Total_element, 12), FNodal1(Total, Total_noeud, 6), Depl1(Total, Total_noeud, 6)
    '                    ReDim eFBarre(Total, Total_element, 12), FNodal(Total, Total_noeud, 6), Depl(Total, Total_noeud, 6)
    '                    Call Analyse_Non_Lineaire_3D(structure_OK)
    '                End If
    '            Case 5 'grille
    '                msg = "Désolé!!!  cette version ne permet pas le calcul  3D"
    '                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '        End Select
    '        If structure_OK = False Then Exit Sub
    '        msg = "Analyse Non Linéaire de la structure terminée."
    '        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '    Else
    '        msg = "Désolé, mais vous n'avez pas spécifié d'Analyse Non Linéaire" & vbCrLf & _
    '        "dans votre fichier de données."
    '        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '    End If
    'End Sub
    'Private Sub MnuAnalyseDynamiqueLinéaire_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAnalyseDynamiqueLinéaire.Click
    '    Dim donnee_OK, structure_OK As Boolean
    '    Dim msg As String
    '    Dim i, Total As Integer
    '    'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
    '    'sinon le calcul est arreté.
    '    Call Lecture_fichier(xl, donnee_OK)
    '    If donnee_OK = False Then Exit Sub
    '    If Cal_Dynamique_lin = False Then
    '        msg = "Aucune Analyse Dynamique de la structure n'a" & vbCrLf & _
    '              "été spécifiée dans le fichier de données !!!"
    '        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '        Exit Sub
    '    End If
    '    Total = 0 : For i = 1 To 4 : Total = Total + Total_combinaison(i) + Total_cas_de_charge(i) : Next
    '    Cal_Statique_lin = True : structure_OK = True
    '    Select Case Type_probleme
    '        Case 1, 2 'treillis ou portique plan
    '            Dim Kg(3 * Total_noeud, 3 * Total_noeud), kg0(9, Total_element), L(Total_element), Rot(9, Total_element) As Double
    '            'Ajustement des tableaux existants: variables publiques
    '            ReDim eFBarre1(Total, Total_element, 6), FNodal1(Total, Total_noeud, 3), Depl1(Total, Total_noeud, 3)
    '            ReDim eFBarre(Total, Total_element, 6), FNodal(Total, Total_noeud, 3), Depl(Total, Total_noeud, 3)
    '            Call Analyse_Lineaire_2D(structure_OK, Kg, kg0, L, Rot, 2, 3)
    '            If structure_OK = False Then Exit Sub
    '            Call Cal_sismique_2D(structure_OK, Kg, L, Rot, kg0)
    '        Case 3, 4 'idem mais spatial
    '            msg = "Désolé!!!  cette version ne permet pas le calcul dynamique 3D"
    '            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '            Exit Sub
    '            'Dim Kg(6 * Total_noeud, 6 * Total_noeud), kg0(36, Total_element), L(Total_element), Rot(36, Total_element) As Double
    '            ''Ajustement des tableaux existants: variables publiques
    '            'ReDim eFBarre1(Total, Total_element, 12), FNodal1(Total, Total_noeud, 6), Depl1(Total, Total_noeud, 6)
    '            'ReDim eFBarre(Total, Total_element, 12), FNodal(Total, Total_noeud, 6), Depl(Total, Total_noeud, 6)
    '            'Call Analyse_Lineaire_3D(structure_OK, Kg, kg0, L, Rot)
    '            'If structure_OK = False Then Exit Sub
    '            'Call Cal_sismique_3D(structure_OK, Kg, L, Rot, kg0)
    '        Case 5 'grille
    '            msg = "Désolé!!!  cette version ne permet pas le calcul dynamique de grille"
    '            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '            Exit Sub
    '    End Select
    '    If structure_OK = False Then Exit Sub
    '    msg = "Analyse de la structure terminée."
    '    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    'End Sub
    'Private Sub MnuAnalyseGlobale_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAnalyseGlobale.Click
    '    Dim donnee_OK, structure_OK As Boolean
    '    Dim msg As String
    '    Dim i, Total As Integer
    '    'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
    '    'sinon le calcul est arreté.
    '    Call Mise_a_zero_charge()
    '    Call Mise_a_zero_Statique_Non_Lineaire() 'effacement des éventuelles anciennes valeurs
    '    Call Lecture_fichier(xl, donnee_OK)
    '    If donnee_OK = False Then Exit Sub
    '    Total = 0 : For i = 1 To 4 : Total = Total + Total_combinaison(i) + Total_cas_de_charge(i) : Next
    '    structure_OK = True
    '    Select Case Type_probleme
    '        Case 1, 2 'treillis ou portique plan
    '            Dim Kg(3 * Total_noeud, 3 * Total_noeud), kg0(9, Total_element), L(Total_element), Rot(9, Total_element) As Double
    '            'Ajustement des tableaux existants: variables publiques
    '            ReDim eFBarre1(Total, Total_element, 6), FNodal1(Total, Total_noeud, 3), Depl1(Total, Total_noeud, 3)
    '            ReDim eFBarre(Total, Total_element, 6), FNodal(Total, Total_noeud, 3), Depl(Total, Total_noeud, 3)
    '            If Cal_Statique_lin = True Then Call Analyse_Lineaire_2D(structure_OK, Kg, kg0, L, Rot, 0, 1)
    '            If structure_OK = False Then Exit Sub
    '            If Cal_Statique_Non_lin = True Then Call Analyse_Non_Lineaire_2D(structure_OK)
    '            If structure_OK = False Then Exit Sub
    '            If Cal_Dynamique_lin = True Then Call Cal_sismique_2D(structure_OK, Kg, L, Rot, kg0)
    '        Case 3, 4 'idem mais spatial
    '            Dim Kg(6 * Total_noeud, 6 * Total_noeud), kg0(36, Total_element), L(Total_element), Rot(36, Total_element) As Double
    '            'Ajustement des tableaux existants: variables publiques
    '            ReDim eFBarre1(Total, Total_element, 12), FNodal1(Total, Total_noeud, 6), Depl1(Total, Total_noeud, 6)
    '            ReDim eFBarre(Total, Total_element, 12), FNodal(Total, Total_noeud, 6), Depl(Total, Total_noeud, 6)
    '            If Cal_Statique_lin = True Then Call Analyse_Lineaire_3D(structure_OK, Kg, kg0, L, Rot, 0, 1)
    '            If structure_OK = False Then Exit Sub
    '            If Cal_Statique_Non_lin = True Then
    '                Select Case Type_probleme
    '                    Case 3, 4  'treillis ou portique plan'idem mais spatial
    '                        If Type_probleme = 4 Then
    '                            msg = "Désolé!!!  cette version ne permet pas le calcul  3D"
    '                            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '                        Else
    '                            Call Analyse_Non_Lineaire_3D(structure_OK) : If structure_OK = False Then Exit Sub
    '                        End If
    '                    Case 5 'grille
    '                        msg = "Désolé!!!  cette version ne permet pas le calcul  3D"
    '                        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '                End Select
    '            End If
    '            If Cal_Dynamique_lin = True Then
    '                msg = "Désolé!!!  cette version ne permet pas le calcul dynamique 3D"
    '                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '                'Call Cal_sismique_3D(structure_OK, Kg, L, Rot, kg0)
    '            End If
    '        Case 5 'grille
    '            msg = "Désolé!!!  cette version ne permet pas le calcul "
    '            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    '    End Select
    '    If structure_OK = False Then Exit Sub
    '    msg = "Analyse de la structure terminée."
    '    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    'End Sub
    Private Sub MnuCalculer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuCalculer.Click
        Dim donnee_OK, structure_OK As Boolean
        Dim msg As String
        Dim i, Total As Integer
        'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
        'sinon le calcul est arreté.
        Call Mise_a_zero_charge()
        Call Mise_a_zero_Statique_Non_Lineaire() 'effacement des éventuelles anciennes valeurs
        Call Lecture_fichier(donnee_OK)
        If donnee_OK = False Then Exit Sub
        Total = 0 : For i = 1 To 4 : Total = Total + Total_combinaison(i) + Total_cas_de_charge(i) : Next
        structure_OK = True
        Select Case Type_probleme
            Case 1, 2 'treillis ou portique plan
                Dim Kg(3 * Total_noeud, 3 * Total_noeud), kg0(9, Total_element), L(Total_element), Rot(9, Total_element) As Double
                'Ajustement des tableaux existants: variables publiques
                ReDim eFBarre1(Total, Total_element, 6), FNodal1(Total, Total_noeud, 3), Depl1(Total, Total_noeud, 3)
                ReDim eFBarre(Total, Total_element, 6), FNodal(Total, Total_noeud, 3), Depl(Total, Total_noeud, 3)
                Call Analyse_Lineaire_2D(structure_OK, Kg, kg0, L, Rot, 0, 1)
                If structure_OK = False Then Exit Sub
                If Cal_Statique_Non_lin_BA = True Then
                    Call Methode_Pdelta(structure_OK) 'Analyse P_delta
                ElseIf Cal_Statique_Non_lin_Inc = True Then
                    Call Analyse_Non_Lin_2D(structure_OK)
                ElseIf Cal_Statique_Non_lin_Fla = True Then
                    Call Flambement_2D(structure_OK, Kg, L, Rot) 'calcul Flambement coef Cr
                End If
                If structure_OK = False Then Exit Sub
                If Cal_Dynamique_lin = True Then Call Cal_sismique_2D(structure_OK, Kg, L, Rot, kg0)
            Case 3, 4 'idem mais spatial
                Dim Kg(6 * Total_noeud, 6 * Total_noeud), kg0(36, Total_element), L(Total_element), Rot(36, Total_element) As Double
                'Ajustement des tableaux existants: variables publiques
                ReDim eFBarre1(Total, Total_element, 12), FNodal1(Total, Total_noeud, 6), Depl1(Total, Total_noeud, 6)
                ReDim eFBarre(Total, Total_element, 12), FNodal(Total, Total_noeud, 6), Depl(Total, Total_noeud, 6)
                If Cal_Statique_lin = True Then Call Analyse_Lineaire_3D(structure_OK, Kg, kg0, L, Rot, 0, 1)
                If structure_OK = False Then Exit Sub
                If Cal_Statique_Non_lin_BA = True Then
                    msg = "Analyse de structure 3D en statique non linéaire" & vbCrLf & _
                  "Désolé!!!  Non implémenté dans cette version"
                    MsgBox(msg, MsgBoxStyle.Exclamation, "Structure")
                ElseIf Cal_Statique_Non_lin_Inc = True Then
                    msg = "Analyse de structure 3D en statique non linéaire" & vbCrLf & _
                   "Désolé!!!  Non implémenté dans cette version"
                    MsgBox(msg, MsgBoxStyle.Exclamation, "Structure")
                ElseIf Cal_Statique_Non_lin_Fla = True Then
                    'calcul Flambement coef Cr
                    msg = "Analyse de structure 3D en flambement généralisé." & vbCrLf & _
                    "Désolé!!!  Non implémenté dans cette version"
                    MsgBox(msg, MsgBoxStyle.Exclamation, "Structure")
                End If
                If Cal_Dynamique_lin = True Then
                    msg = "Désolé!!!  cette version ne permet pas le calcul dynamique 3D"
                    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
                    'Call Cal_sismique_3D(structure_OK, Kg, L, Rot, kg0)
                End If
            Case 5 'grille
                msg = "Désolé!!!  cette version ne permet pas le calcul "
                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
        End Select
        If structure_OK = False Then Exit Sub
        msg = "Analyse de la structure terminée."
        MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Structure")
    End Sub
    Private Sub MnuSousFormatStandard_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuSousFormatStandard.Click
        If OpenFileDialog1.FileName = "" Then
            Dim msg As String
            msg = "Désolé, mais vous n'avez ouvert aucun fichier de structure !!!!"
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, Me.Text)
            Exit Sub
        End If
        My.Forms.frmResultats.MdiParent = Me
        My.Forms.frmResultats.Show()
    End Sub
    Private Sub SousFormatStandard2ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SousFormatStandard2ToolStripMenuItem.Click
        My.Forms.Form1.MdiParent = Me
        My.Forms.Form1.Show()
    End Sub
    Private Sub MnuSousFormatExcel_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuSousFormatExcel.Click
        'If OpenFileDialog1.FileName = "" Then
        '    Dim msg As String
        '    msg = "Désolé, mais vous n'avez ouvert aucun fichier de structure !!!!"
        '    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, Me.Text)
        '    Exit Sub
        'End If
        Call Affichage_Resultats_Excel()
    End Sub
    Private Sub MnuNdcPortMetal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuNdcPortMetal.Click
        Try
            'Affichage de la note de calcul
            Dim startInfo As New ProcessStartInfo("notepad.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "TestFile.txt"
            Process.Start(startInfo)
        Catch ex As Exception
            MsgBox("Erreur données " & _
                    vbCrLf + "Exception: " + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)

        End Try
    End Sub
    Private Sub MnuCalculatrice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuCalculatrice.Click
        Try
            Dim startInfo As New ProcessStartInfo("calc.exe")
            Process.Start(startInfo)
            startInfo.WindowStyle = ProcessWindowStyle.Normal
        Catch ex As Exception
            Dim msg As String
            msg = "Erreur lors du chargement de la calculatrice" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub MnuUtilitaireDeCalculDeLangleGamma_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuUtilitaireDeCalculDeLangleGamma.Click
        My.Forms.frmGamma.MdiParent = Me
        My.Forms.frmGamma.Show()
    End Sub
    Private Sub MnuBaseDeDonnéesDesProfilésMétalliquesDuCommerce_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuBaseDeDonnéesDesProfilésMétalliquesDuCommerce.Click
        Try
            Dim startInfo As New ProcessStartInfo("excel.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "Catalogue_profilés_métalliques.xls"
            Process.Start(startInfo)
        Catch exc As Exception
            Dim msg As String
            msg = "Erreur: " & exc.Message & vbCrLf & "Problème d'accés au fichier des profilés"
            MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Logiciel Structure")
            Exit Sub
        End Try
    End Sub
    Private Sub MnuCalculDesCaractéristiquesGéométriquesDesPRS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuCalculDesCaractéristiquesGéométriquesDesPRS.Click
        My.Forms.frmCarProfil.MdiParent = Me
        My.Forms.frmCarProfil.Show()
    End Sub
    Private Sub MnuModificationGénériques_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuModificationGénériques.Click
        My.Forms.frmValDefaut.MdiParent = Me
        My.Forms.frmValDefaut.Show()
    End Sub
    Private Sub MnuAide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAide.Click
        Try
            Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Structure
            Dim startInfo As New ProcessStartInfo("AcroRd32.exe") '("word.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = SousDossier1 & "\Aide_Structure.pdf" '"\Aide_Structure.docx"
            Process.Start(startInfo.Arguments)
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher l'Aide" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub MnuFichierModèleType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuFichierModèleType.Click
        Dim frm1 As frmEdit
        Dim fichier As String
        fichier = "\modele_fichier.rtf"
        frm1 = New frmEdit
        frm1.MdiParent = Me
        Call frm1.Affichage_frmEdit(fichier)
    End Sub
    Private Sub MnuMiseÀJour_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuMiseÀJour.Click
        Dim frm1 As frmEdit
        Dim fichier As String
        fichier = "\StructureMaj.rtf"
        frm1 = New frmEdit
        frm1.MdiParent = Me
        Call frm1.Affichage_frmEdit(fichier)
    End Sub
    Private Sub MnuAProposde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuAProposDe.Click
        My.Forms.frmSplash.MdiParent = Me
        My.Forms.frmSplash.Show()
    End Sub
#End Region

    Private Sub SousFormatGraphiqueToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles SousFormatGraphiqueToolStripMenuItem.Click
        Dim donnee_OK As Boolean
        'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
        'sinon le calcul est arreté.
        Call Lecture_fichier(donnee_OK)
        If donnee_OK = False Then Exit Sub
        My.Forms.frmResultGraph.MdiParent = Me
        My.Forms.frmResultGraph.Show()
    End Sub
End Class